package org.exoplatform.faces.cms;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.exoplatform.faces.core.component.UIInput;
import org.exoplatform.faces.core.component.UIUploadInput;
import org.exoplatform.services.cms.JcrInputProperty;

public class CMSUtils {
  
  public static final String JCR_INFO = "jcrInfo";

  public static Map prepareMap(Map inputs) {
    Map rawinputs = new HashMap();
    Set keys = inputs.keySet();
    Object value = null;
    for (Iterator iter = keys.iterator(); iter.hasNext();) {
      String key = (String) iter.next();
      UIInput input = (UIInput) inputs.get(key);
      if (input instanceof UIUploadInput) {
        value = ((UIUploadInput) input).getContent();
      } else {
        value = input.getValue();
      }
      JcrInputProperty property = (JcrInputProperty) input.getProperty(JCR_INFO);
      if(property != null) {
        property.setValue(value);      
        rawinputs.put(property.getJcrPath(), property);
      }
    }
    return rawinputs;
  }    
  
}
