/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.actions.component;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cms.actions.ActionServiceContainer;


/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentDisplayer.java,v 1.2 2004/08/07 18:11:26 tuan08 Exp $
 */
public class UISelectActionTypeForm extends UISimpleForm  {
 
  final static public String CHANGE_TYPE_ACTION = "changeActionType" ;
  
  UISelectBox uiSelect_ ;
  
  private String defaultActionType_;

  private ActionServiceContainer actionsServiceContainer_;  
  
  public UISelectActionTypeForm(ActionServiceContainer actionsServiceContainer) throws Exception {
    super("selectactionTypeForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer");
    
    uiSelect_ = new  UISelectBox("actionType", "", null) ;
    uiSelect_.setUpdateOnChangeAction(CHANGE_TYPE_ACTION) ;
    add(uiSelect_) ;
    
    actionsServiceContainer_ = actionsServiceContainer;
    
    addActionListener(ChangeTypeActionListener.class, CHANGE_TYPE_ACTION) ;
  }  
  
  private Iterator getActionTypes() throws Exception{
    return actionsServiceContainer_.getActionPluginNames().iterator();
  }
  
  public String getDefaultActionType() throws Exception{    
    if(defaultActionType_ == null) {
      Iterator actionsTypes = getActionTypes();
      defaultActionType_ = (String) actionsTypes.next();
    }
    return defaultActionType_;
  }  
  
  public void update() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    Iterator actionsTypes = getActionTypes();    
    while(actionsTypes.hasNext()){
      String actionsType = (String) actionsTypes.next();
      options.add(new SelectItem(actionsType, actionsType));
    }    
    uiSelect_.setOptions(options) ;
    uiSelect_.setValue(getDefaultActionType());
  }
  
  static public class ChangeTypeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UISelectActionTypeForm uicomp = (UISelectActionTypeForm) event.getSource() ;
      String actionType = uicomp.uiSelect_.getValue() ;
      UIActionTypeForm uiForm = (UIActionTypeForm) uicomp.getSibling(UIActionTypeForm.class) ;
      uiForm.createNewActionType(actionType) ;
    }
  }

}