/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.dynamic.component;

import javax.jcr.Node;

import org.exoplatform.faces.cms.CMSDelegate;
import org.exoplatform.faces.core.component.UINode;
import org.exoplatform.services.grammar.wiki.WikiContext;
import org.exoplatform.services.grammar.wiki.WikiEngineService;
/**
 * Apr 26, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentTab.java,v 1.2 2004/07/26 02:27:18 tuan08 Exp $
 **/
public class UIContentTab extends UINode { 
  private String name;
  private CMSDelegate delegate;
  private String errorMessage;
  
  public UIContentTab(String name, Node viewNode) {
    setRendererType("VelocityRenderer") ;   
    this.name = name;        
    delegate = new CMSDelegate(viewNode);      
  }
  
  public UIContentTab(String errorMessage) {
    setRendererType("VelocityRenderer") ;   
    this.name = "referenced error";
    this.errorMessage = errorMessage;
  }
  
  public boolean isError(){
    if(errorMessage == null || "".equals(errorMessage))
      return false;
    return true;
  }
  
  public String getErrorMessage(){
    return errorMessage;
  }

  public String getName() { 
    Node node;
    try {
      node = getNode();
      if(node.hasProperty("exo:title"))
        return node.getProperty("exo:title").getString();
    } catch (Exception e) {      
    }
    return this.name; 
  }     
  
  public boolean isNodeTypeSupported() {
    return delegate.isNodeTypeSupported();
  }
  
  public String getViewTemplatePath() throws Exception {
    return delegate.getTemplatePath();
  }
  
  public Node getNode() throws Exception{
    return delegate.getNode();
  }
  
  public void setNode(Node node){
    delegate.setNode(node);
  }
  
  public String getPortalName() {
    return delegate.getPortalName();
  }
  
  public String getWorkspaceName() throws Exception {
    return delegate.getWorkspaceName();
  }
  
  public WikiContext getWikiContext() {
    return delegate.getWikiContext();
  }
  
  public WikiEngineService getWikiService() {
    return delegate.getWikiService();
  }
  
}