/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.util.Iterator;

import javax.jcr.Node;
import javax.jcr.Property;
import javax.jcr.RepositoryException;
import javax.jcr.Value;
import javax.jcr.ValueFormatException;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.jcr.JCRUtil;
import org.exoplatform.services.jcr.core.ExtendedPropertyType;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentDisplayer.java,v 1.2 2004/08/07 18:11:26 tuan08 Exp $
 */
public class UIPropertiesInfo extends UIExoCommand implements ChangeNodeListener {
      
  private static String ADD_PROPERTY_ACTION = "addProperty" ;
  static Parameter[] BACK_PARAMS = { new Parameter(ACTION , CANCEL_ACTION)} ;
  static Parameter[] ADD_PROPERTY_PARAMS = { new Parameter(ACTION , ADD_PROPERTY_ACTION)} ;

  private Node node_ ;
  
  public UIPropertiesInfo() {
    setRendererType("VelocityRenderer") ;
    
    addActionListener(AddPropertyActionListener.class, ADD_PROPERTY_ACTION);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
  }
  public Parameter[] getBackParams() { return BACK_PARAMS ; }
  public void  onChange(UIJCRExplorer explorer, Node node)  {
    node_ = node ;
    setRendered(false) ;
  }
  
  public Parameter[] getAddPropertyParams() { return ADD_PROPERTY_PARAMS; }
  
  public Node getNode() {
    return node_;
  }
  
  public Iterator getProperties() throws Exception { return node_.getProperties() ; }
  
  public boolean isMultiValue(Property prop) throws Exception{
    try {
      prop.getValue();
      return false;
    } catch (ValueFormatException e) {
      return true;      
    }
  }
  
  public String getPropertyIcon(Property prop) { return JCRUtil.getPropertyTypeIcon(prop) ; }
  public String getPropertyValue(Property prop) throws Exception {      
    try {
      if("jcr:data".equals(prop.getName())) return "Binary Data" ;
      if(prop.getValue() == null)
        return "N/A";
      return prop.getValue().getString() ;
    } catch (ValueFormatException e) {      
      Value[] values =  prop.getValues();
      StringBuffer sB = new StringBuffer();
      for (int i = 0; i < values.length; i++) {
        Value value = values[i];
        sB.append(ExtendedPropertyType.nameFromValue(value.getType()) + "; ");
      }
      return sB.toString();
    } 
  }
  
  static public class AddPropertyActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIPropertiesInfo propertiesInfo = (UIPropertiesInfo) event.getSource();
      propertiesInfo.setRenderedSibling(UIPropertyForm.class);
    }
  }      
  
}