package org.exoplatform.portlets.content.search.component;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UICommandNode;
import org.exoplatform.faces.core.component.UINode;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.jcr.component.ChangeNodeListener;
import org.exoplatform.portlets.content.jcr.component.UIFolderForm;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;

public class UISearch extends UINode implements ChangeNodeListener{
  
  private UIJCRAdvancedSearch uiAdvancedSearch_;
  private UIResults uiResults_;
  private UISimpleSearch uiSimpleSearch_;

  public UISearch() throws Exception {
    //setRendererType("SimpleTabRenderer");
    setRendererType("VelocityNodeMenuRenderer");
    setTemplatePath("org/exoplatform/faces/core/renderer/html/UIFirstTabLevel.vm");   
    uiSimpleSearch_ = (UISimpleSearch) addChild(UISimpleSearch.class);
    uiSimpleSearch_.setRendered(true);
    uiAdvancedSearch_ = (UIJCRAdvancedSearch) addChild(UIJCRAdvancedSearch.class);
    uiAdvancedSearch_.setRendered(false);
    addChild(UIQueryList.class).setRendered(false);
    uiResults_ = (UIResults) addChild(UIResults.class);
    uiResults_.setRendered(false);   
  }
  
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    setRendered(false);
    uiSimpleSearch_.updateNode(node);
    uiAdvancedSearch_.updateQueryField(node);
    uiResults_.setQueryResults(0, null);
    
  }  
}
