/*
 * Created on Apr 8, 2005
 */
package org.exoplatform.portlets.content.templates.component;

import java.util.Iterator;
import java.util.List;

import javax.faces.component.UIComponent;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIToolbar;
import org.exoplatform.faces.core.component.model.Button;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * @author benjaminmestrallet
 */
public class UIListsManager extends UIExoCommand {

  static String ADD_DIALOG = "addDialog";

  static String ADD_VIEW = "addView";

  static Parameter[] ADD_DIALOG_PARAMS = { new Parameter(ACTION, ADD_DIALOG) };

  static Parameter[] ADD_VIEW_PARAMS = { new Parameter(ACTION, ADD_VIEW) };

  static Parameter[] CANCEL_PARAMS = { new Parameter(ACTION, CANCEL_ACTION) };

  protected String nodeType;  

  public UIListsManager() throws Exception {
    setId("UIListsManager");
    setRendererType("VelocityRenderer");
    
    UIToolbar dialogToolbar = new UIToolbar("dialogToolbar");
    dialogToolbar.addLeftButton(new Button("#{UIListsManager.button.add-dialog}",
        ADD_DIALOG_PARAMS));
    getChildren().add(dialogToolbar);
    UITemplatesList dialogs = (UITemplatesList) addChild(UITemplatesList.class);
    dialogs.setId("DialogList");    
    dialogs.setDialog(true);
    
    UIToolbar uitoolbar = new UIToolbar("viewToolbar");
    uitoolbar.addLeftButton(new Button("#{UIListsManager.button.add-view}",
        ADD_VIEW_PARAMS));
    getChildren().add(uitoolbar);
    UITemplatesList views = (UITemplatesList) addChild(UITemplatesList.class);
    views.setId("ViewList");        
    views.setDialog(false);

    addActionListener(AddDialogActionListener.class, ADD_DIALOG);
    addActionListener(AddViewActionListener.class, ADD_VIEW);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
  }

  public Parameter[] getAddDialogParams() {
    return ADD_DIALOG_PARAMS;
  }

  public Parameter[] getAddViewParams() {
    return ADD_VIEW_PARAMS;
  }

  public Parameter[] getCancelParams() {
    return CANCEL_PARAMS;
  }

  public void setNodeType(String nodeType) {
    this.nodeType = nodeType;
    List children = getChildren();
    for (Iterator iter = children.iterator(); iter.hasNext();) {
      UIComponent component = (UIComponent) iter.next();
      if(component instanceof UITemplatesList)
        ((UITemplatesList)component).setNodeType(nodeType);
    }
  }

  static public class AddDialogActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIListsManager uicomp = (UIListsManager) event.getComponent();
      UITemplateForm form = (UITemplateForm) uicomp.getSibling(UITemplateForm.class);
      form.addTemplate(true, uicomp.nodeType);
      uicomp.setRenderedSibling(UITemplateForm.class);
    }
  }

  static public class AddViewActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIListsManager uicomp = (UIListsManager) event.getComponent();
      UITemplateForm form = (UITemplateForm) uicomp.getSibling(UITemplateForm.class);
      form.addTemplate(false, uicomp.nodeType);
      uicomp.setRenderedSibling(UITemplateForm.class);
    }
  }

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIListsManager uicomp = (UIListsManager) event.getComponent();
      uicomp.setRenderedSibling(UINodeTypesList.class);
    }
  }

}