/*
 * Created on Apr 8, 2005
 */
package org.exoplatform.portlets.content.templates.component;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.Session;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cms.BasePath;
import org.exoplatform.services.cms.CmsConfigurationService;

/**
 * @author benjaminmestrallet
 */
public class UINodeTypesList extends UIExoCommand{
  
  static public String DELETE_NODE_TYPE = "deleteNodeType" ;
  static public String VIEW_NODE_TYPE = "viewNodeType" ;
  
  static Parameter[] DELETE_NODE_TYPE_PARAMS = { new Parameter(ACTION , DELETE_NODE_TYPE)} ;
  static Parameter[] VIEW_NODE_TYPE_PARAMS = { new Parameter(ACTION , VIEW_NODE_TYPE)} ;

  private String templatesPath;
  
  public UINodeTypesList(CmsConfigurationService cmsConfigurationService) throws Exception {
    setId("UICategoryList") ;
    setRendererType("VelocityRenderer") ;
    this.templatesPath = cmsConfigurationService.getJcrPath(BasePath.CMS_TEMPLATES_PATH);    
    addActionListener(DeleteNodeTypeActionListener.class, DELETE_NODE_TYPE)  ;
    addActionListener(ViewNodeTypeActionListener.class, VIEW_NODE_TYPE)  ;
  }
  
  public NodeIterator getNodeTypeIterator() throws Exception {
    Session session = ((UITemplatesManager) getAncestorOfType(
        UITemplatesManager.class)).getSession();          
    Node templatesHome = (Node) session.getItem(templatesPath);
    return templatesHome.getNodes();
  }
  
  public Parameter[] getDeleteNodeTypeParams() { return DELETE_NODE_TYPE_PARAMS ; }
  public Parameter[] getViewNodeTypeParams() { return VIEW_NODE_TYPE_PARAMS ; }
  
  static public class DeleteNodeTypeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINodeTypesList uicomp = (UINodeTypesList) event.getComponent() ;
      String categoryName = event.getParameter(OBJECTID);
      Session session = ((UITemplatesManager)uicomp.getAncestorOfType(
          UITemplatesManager.class)).getSession();            
      Node templatesNode = (Node) session.getItem(uicomp.templatesPath);
      Node templateNode = templatesNode.getNode(categoryName);
      templateNode.remove();
      templatesNode.save();
    }
  }
  
  static public class ViewNodeTypeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINodeTypesList uicomp = (UINodeTypesList) event.getComponent() ;
      String nodetypeName = event.getParameter(OBJECTID);
      
      UIListsManager manager = (UIListsManager) uicomp.getSibling(UIListsManager.class);
      manager.setNodeType(nodetypeName);
      uicomp.setRenderedSibling(UIListsManager.class);
    }
  }
}
