/*
 * Created on Apr 4, 2005
 */
package org.exoplatform.portlets.content.templates.component;

import javax.jcr.Repository;
import javax.jcr.Session;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIToolbar;
import org.exoplatform.faces.core.component.model.Button;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.user.component.UIExoPermissionBrowser;
import org.exoplatform.portlets.content.admin.component.UIECMAdminSummary;
import org.exoplatform.services.jcr.RepositoryService;

/**
 * @author benjaminmestrallet
 */
public class UITemplatesManager extends UIExoCommand{
  
  static String ADD_NODE_TYPE = "addNodeType" ;
  
  static Parameter[] ADD_NODE_TYPE_PARAMS = { new Parameter(ACTION , ADD_NODE_TYPE)} ;
  static Parameter[] CANCEl_PARAMS = { new Parameter(ACTION , CANCEL_ACTION)} ;

  private Session session;  
  
  public UITemplatesManager(RepositoryService repositoryService) throws Exception{
    setRendererType("ChildrenRenderer") ;    
    
    Repository repository = repositoryService.getRepository(); 
    session = repository.login();         
    
    UIToolbar uitoolbar = (UIToolbar) addChild(UIToolbar.class);
    uitoolbar.setId("UITemplatesToolbar");
    uitoolbar.addLeftButton(new Button("#{UITemplatesManager.icon.add}", ADD_NODE_TYPE_PARAMS));        
    uitoolbar.addRightButton(new Button("#{UITemplatesManager.icon.cancel}", CANCEl_PARAMS));
    uitoolbar.setRendered(true);
    UINodeTypesList nodetypes = (UINodeTypesList) addChild(UINodeTypesList.class);
    nodetypes.setRendered(true);
    
    UINodeTypeForm nodetypesForm = (UINodeTypeForm) addChild(UINodeTypeForm.class);
    nodetypesForm.buildTree(session);
    nodetypesForm.setRendered(false);
    
    UIListsManager listsManager = (UIListsManager) addChild(UIListsManager.class);
    listsManager.setRendered(false);
    
    UITemplateForm templateForm = (UITemplateForm) addChild(UITemplateForm.class);
    templateForm.setRendered(false);
    
    UIExoPermissionBrowser premBrowser = (UIExoPermissionBrowser) addChild(UIExoPermissionBrowser.class);
    premBrowser.setRendered(false);
    
    addActionListener(AddNodeTypeActionListener.class, ADD_NODE_TYPE)  ;
    addActionListener(CancelActionListener.class,CANCEL_ACTION);
  }  

  public Session getSession() {
    return session;
  }  
  
  static public class AddNodeTypeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UITemplatesManager uicomp = (UITemplatesManager) event.getComponent() ;
      uicomp.setRenderedComponent(UINodeTypeForm.class);
    }
  }

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UITemplatesManager uicomp = (UITemplatesManager) event.getComponent() ;            
      uicomp.setRenderedSibling(UIECMAdminSummary.class) ;
    }
  } 
  
}
