/*
 * Created on Mar 1, 2005
 */
package org.exoplatform.services.cms.templates;

import javax.jcr.NodeIterator;


/**
 * @author benjaminmestrallet
 */
public interface TemplateService {  

  static final public String DIALOGS = "dialogs";
  static final public String VIEWS = "views";
  
  static final public String DEFAULT_DIALOG = "dialog1";
  static final public String DEFAULT_VIEW = "view1";
  
  static final String[] UNDELETABLE_TEMPLATES = {DEFAULT_DIALOG, DEFAULT_VIEW};  
  
  static final public String DEFAULT_DIALOGS_PATH = "/" + DIALOGS + "/" + DEFAULT_DIALOG;
  static final public String DEFAULT_VIEWS_PATH = "/" + VIEWS + "/" + DEFAULT_VIEW;  
  
  public String getDefaultTemplatePath(boolean isDialog, String nodeTypeName) ;  
  
  public String getTemplatePath(boolean isDialog, String nodeTypeName) throws Exception ;
  public String getTemplatePath(boolean isDialog, String nodeTypeName, String templateName) throws Exception ;
  
  public String getTemplate(boolean isDialog, String nodeTypeName) throws Exception ;
  public String getTemplate(boolean isDialog, String nodeTypeName, String templateName) throws Exception ;
  
  public void addTemplate(boolean isDialog, String nodeTypeName, String templateName, 
      String[] roles, String templateFile) throws Exception;  
  public void removeTemplate(boolean isDialog, String nodeTypeName, String templateName) throws Exception;
  
  public boolean isNodeTypeConfigured(String nodeTypeName) throws Exception ; 
  
  public NodeIterator getDocumentTypes() throws Exception ;
  public NodeIterator getTemplates(boolean isDialog, String nodeTypeName) throws Exception;
}
