/*
 * Created on Mar 22, 2005
 */
package org.exoplatform.services.cms.publications.impl;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * @author benjaminmestrallet
 */
public class PublicationMixinType extends NodeTypeImpl {

  public PublicationMixinType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:published";
    this.mixin = true;
    this.orderableChild = false;
    this.primaryItemName = null;
    
    this.declaredPropertyDefinitions = new PropertyDefinition[2];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "exo:startPublication",      //name
        this,                        //declaringNodeType
        PropertyType.DATE,           //requiredType
        null,                        //valueConstraints 
        NULL_VALUES,                 //defaultValues
        false,                       //autoCreate       
        true,                        //mandatory        
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false                        //multiple         
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "exo:endPublication",        //name
        this,                        //declaringNodeType
        PropertyType.DATE,           //requiredType
        null,                        //valueConstraints 
        NULL_VALUES,                 //defaultValues
        false,                       //autoCreate       
        true,                       //mandatory
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false                        //multiple         
        );
    
    this.declaredChildNodeDefinitions = new NodeDefinition[0];

  }

}
