/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import javax.jcr.Node;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIDocument extends UIExoCommand {   
  static Parameter[] BACK_PARAMS = { new Parameter(ACTION , CANCEL_ACTION)} ;
  
  Node document_ ;
  Class backComponent_ ;
  
  public UIDocument() throws Exception {
    setId("UIDocuments") ;
    setRendererType("VelocityRenderer") ;
    addActionListener(BackActionListener.class, CANCEL_ACTION) ;
  }
 
  public Parameter[] getBackParams() { return BACK_PARAMS ; }
  
  public void setData(Node document, Class backComponent) throws Exception { 
    document_ = document ;
    backComponent_ = backComponent ;
  } 
  
  public String getDocumentName() throws Exception {
    return document_.getName() ;
  }
  
  public String getMimeType() throws Exception {
    return document_.getProperty("exo:mimeType").getString() ;
  }
  
  public String getOwner() throws Exception {
    return document_.getProperty("exo:owner").getString() ;
  }
  
  public String getDescription() throws Exception {
    if(!document_.hasProperty("exo:description")) return "No Description" ;
    return document_.getProperty("exo:description").getString() ;
  }
  
  public String getDocument() throws Exception {
    if(!document_.hasProperty("exo:data")) return "" ;
    String mimeType = document_.getProperty("exo:mimeType").getString()  ;
    if(mimeType.startsWith("text")) {
      return document_.getProperty("exo:data").getString() ;
    }
    return "Mime type " + mimeType + " is not supported" ;
  }
  
  static public class BackActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIDocument uicomp = (UIDocument) event.getComponent() ;
      uicomp.setRenderedSibling(uicomp.backComponent_) ;
    }
  }  
}