/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.Project;
import org.exoplatform.services.pmanager.Constant ;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectComponents extends UIExoCommand {
  static String CREATE_COMPONENT = "createComponent".intern() ;      
  static Parameter[] CREATE_COMPONENT_PARAMS = { new Parameter(ACTION , CREATE_COMPONENT)} ;
  
  Project project_ ;
  
  public UIProjectComponents() throws Exception {
    setRendererType("VelocityRenderer") ;
    addActionListener(CreateComponentActionListener.class, CREATE_COMPONENT)  ;
  }
 
  public Parameter[] getCreateComponentParams() { return CREATE_COMPONENT_PARAMS ; }
  
  public void setData(Project project, Class backComponent) throws Exception { 
    project_ = project ;
  } 
 
  public NodeIterator getComponents() throws Exception {
    return project_.getComponents() ;
  }
  
  public String getComponentName(Node node) throws Exception {
    return node.getProperty(Constant.PROJECT_COMPONENT_NAME).getString() ;
  }
  
  public String getComponentDescription(Node node) throws Exception {
    return node.getProperty(Constant.PROJECT_COMPONENT_DESCRIPTION).getString() ;
  }
  
  static public class CreateComponentActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectComponents uicomp = (UIProjectComponents) event.getComponent() ;
    }
  }
}