/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import javax.portlet.PortletPreferences;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.ProjectManager;
import org.exoplatform.services.pmanager.ProjectManagerService;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectManagers extends UIExoCommand {
  static public String VIEW = "view" ;
  static public String REMOVE_URI = "removeURI" ;
  
  static Parameter[] VIEW_PARAMS = { new Parameter(ACTION , VIEW)} ;
  static Parameter[] REMOVE_URI_PARAMS = { new Parameter(ACTION , REMOVE_URI)} ;
  
  List managers_ ;
  
  public UIProjectManagers() throws Exception {
    setId("UIProjectManagers") ;
    setRendererType("VelocityRenderer") ;
    update() ;
    addActionListener(ViewProjectManagerActionListener.class, VIEW)  ;
    addActionListener(RemoveURIActionListener.class, REMOVE_URI)  ;
  }
  
  public Parameter[] getViewParams() { return VIEW_PARAMS ; }
  public Parameter[] getRemoveURIParams() { return REMOVE_URI_PARAMS ; }
  
  public List getProjectManagers() { return managers_ ; }
  
  public void update() throws Exception {
    PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
    managers_ = new ArrayList() ;
    Enumeration e = prefs.getNames() ;
    while(e.hasMoreElements()) {
      String key  = (String) e.nextElement() ;
      if("default".equals(key)) continue ;
      String value = prefs.getValue(key, null) ;
      Preference pref = new Preference(key, value) ;
      managers_.add(pref) ;
    }
  }
  
  static public class ViewProjectManagerActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagers uicomp = (UIProjectManagers) event.getComponent() ;
      String path = event.getParameter(OBJECTID) ;
      UIProjectManager uimanager = 
        (UIProjectManager) uicomp.getSibling(UIProjectManager.class) ;
      ProjectManagerService service = 
        (ProjectManagerService) PortalContainer.getComponent(ProjectManagerService.class) ;
      ProjectManager pmanager = service.getProjectManager(null, path) ;
      uimanager.setProjectManager(pmanager) ;
      uicomp.setRenderedSibling(UIProjectManager.class);
    }
  }
  
  
  static public class RemoveURIActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagers uicomp = (UIProjectManagers) event.getComponent() ;
      String path = event.getParameter(OBJECTID) ;
      List list = uicomp.getProjectManagers() ;
      for(int i = 0; i < list.size(); i++) {
        Preference pref = (Preference) list.get(i) ;
        if(path.equals(pref.getPath())) {
          PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
          prefs.reset(path) ;
          prefs.store() ;
          uicomp.update() ;
        }
      }
    }
  }

  
  static public class Preference {
    String path_ ;
    String name_ ;
    
    public Preference(String path, String name) {
      name_ = name ;
      path_ = path ;
    }
    
    public String getName() { return name_ ; }
    public String getPath() { return path_ ; }
  }
}