/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import java.io.ByteArrayInputStream;
import java.util.List;
//import javax.jcr.Node;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.Constant;
import org.exoplatform.services.pmanager.DocumentUtil;
import org.exoplatform.portal.Information;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIUploadForm extends UISimpleMulltipartForm {
  static String NAME= "name".intern(), DESCRIPTION = "description".intern(), 
                FILE = "file".intern() , MIME_TYPE = "mimeType".intern();
  static String UPLOAD_ISSUE_DOCUMENT = "uploadIssueDocument".intern() ;
  static String UPLOAD_DOCUMENT = "uploadDocument".intern() ;
  
  static List MIME_OPTIONS = UIDocumentForm.MIME_OPTIONS ;
  
  String action_ ;
  Node node_ ;
  Class backComponent_ ;
  
  public UIUploadForm() {
    super("uploadForm", "post", null) ;
    setId("UIUploadForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UISelectBox(MIME_TYPE, "application/octet-stream", MIME_OPTIONS)) ;
    add(new UIStringInput(NAME, "")) ;
    add(new UIUploadInput(FILE)) ;
    add(new UITextArea(DESCRIPTION, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public String getHeader() { return "Upload Document" ; }
  
  public void setData(String action, Node node, Class backComponent) {
    action_ = action ;
    node_  = node ;
    backComponent_ = backComponent ;
  }
  
  boolean saveUploadDocument(Information iprovider) throws Exception {
    byte[] buf = getUIUploadInput(FILE).getContent() ;
    if(buf == null || buf.length == 0) return  false ;
    String name = getUIStringInput(NAME).getValue() ;
    if(name.length() == 0) name = getUIUploadInput(FILE).getFileName() ;
    if(node_.hasNode(name)) {
      iprovider.addMessage(new ExoFacesMessage("UIUploadForm.msg.file-name-exist")) ;
      return false ;
    }
    String mimeType = getUISelectBox(MIME_TYPE).getValue() ;
    ByteArrayInputStream is = new ByteArrayInputStream(buf) ;
    DocumentUtil.createDocument(node_, "exo", name, mimeType, is) ; 
    node_.save() ;
    return true ;
  }
  
  boolean saveUploadIssueDocument(Information iprovider) throws Exception {
    byte[] buf = getUIUploadInput(FILE).getContent() ;
    if(buf == null || buf.length == 0) return  false ;
    String name = getUIStringInput(NAME).getValue() ;
    if(name.length() == 0) name = getUIUploadInput(FILE).getFileName() ;
    Node resources = null ;
    if(node_.hasNode(Constant.ISSUE_RESOURCES)) {
      resources = node_.getNode(Constant.ISSUE_RESOURCES) ;
    } else {
      resources = node_.addNode(Constant.ISSUE_RESOURCES, Constant.CONTAINER_NODE_TYPE) ;
    }
    if(resources.hasNode(name)) {
      iprovider.addMessage(new ExoFacesMessage("UIUploadForm.msg.file-name-exist")) ;
      return false ;
    }
    String mimeType = getUISelectBox(MIME_TYPE).getValue() ;
    ByteArrayInputStream is = new ByteArrayInputStream(buf) ;
    DocumentUtil.createDocument(resources, "exo", name, mimeType, is) ; 
    node_.save() ;
    return true ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIUploadForm uiForm = (UIUploadForm) event.getComponent() ;
      boolean goback = false ;
      if(uiForm.action_ == UPLOAD_DOCUMENT) {
        Information iprovider = this.findInformationProvider(uiForm) ;
        goback = uiForm.saveUploadDocument(iprovider) ;
      } else if(uiForm.action_ == UPLOAD_ISSUE_DOCUMENT) {
        Information iprovider = this.findInformationProvider(uiForm) ;
        goback = uiForm.saveUploadIssueDocument(iprovider) ;
      }
      if(goback) uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIUploadForm uiForm = (UIUploadForm) event.getComponent() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
}