/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.forum.hibernate;

import java.util.List;

import org.exoplatform.services.database.XResources;
import org.exoplatform.services.forum.Category;
import org.exoplatform.services.forum.Forum;
import org.exoplatform.services.forum.ForumEventListener;
import org.exoplatform.services.forum.ForumServiceContainer;
import org.exoplatform.services.forum.Post;
import org.exoplatform.services.forum.Topic;
import org.hibernate.Session;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Nov 25, 2004
 * @version $Id$
 */
public class ForumDependencyObjectManager extends ForumEventListener {
  
  public void onDelete(XResources resources, Category category) throws Exception  {  
    Session session = (Session) resources.getResource(Session.class) ;
//    List forums = session.find(ForumServiceImpl.queryForumsByCategory, 
//                               category.getId(), Hibernate.STRING );
    List forums = session.createQuery(ForumServiceImpl.queryForumsByCategory)
	.setString(0, category.getId()).list();

    for (int i = 0; i < forums.size(); i++) {
      Forum forum = (Forum) forums.get(i) ;
      onDelete(resources, forum) ;
    }
    List entries = session.createQuery(ForumServiceImpl.queryForumsByCategory)
	.setString(0, category.getId()).list();
    for(int i=0; i<entries.size(); i++)
    	session.delete(entries.get(i));
    //session.delete(ForumServiceImpl.queryForumsByCategory, category.getId(), Hibernate.STRING );
  }
  
  public void onDelete(XResources resources, Forum forum) throws Exception  {
    Session session = (Session) resources.getResource(Session.class) ;
    List entries = session.createQuery(ForumServiceImpl.queryTopicsByForum)
	.setString(0, forum.getId()).list();
    for(int i=0; i<entries.size(); i++)
    	session.delete(entries.get(i));
//    session.delete(ForumServiceImpl.queryTopicsByForum, forum.getId(), Hibernate.STRING );
    entries = session.createQuery(ForumServiceImpl.queryPostsByForum)
	.setString(0, forum.getId()).list();
    for(int i=0; i<entries.size(); i++)
    	session.delete(entries.get(i));
//    session.delete(ForumServiceImpl.queryPostsByForum, forum.getId(), Hibernate.STRING );
    entries = session.createQuery("from w in class org.exoplatform.services.forum.hibernate.WatcherImpl where w.forumId = ?")
	.setString(0, forum.getId()).list();
    for(int i=0; i<entries.size(); i++)
    	session.delete(entries.get(i));
//    session.delete("from w in class org.exoplatform.services.forum.hibernate.WatcherImpl " + 
//                   "where w.forumId = ?",
//                   forum.getId(), Hibernate.STRING );
  }
  
  public void onDelete(XResources resources, Topic topic) throws Exception  {
    Session session = (Session) resources.getResource(Session.class) ;
    List entries = session.createQuery(ForumServiceImpl.queryPostsByTopic)
	.setString(0, topic.getId()).list();
    for(int i=0; i<entries.size(); i++)
    	session.delete(entries.get(i));

//    session.delete(ForumServiceImpl.queryPostsByTopic, topic.getId(), Hibernate.STRING);
    entries = session.createQuery("from w in class org.exoplatform.services.forum.hibernate.WatcherImpl where w.topicId = ?")
	.setString(0, topic.getId()).list();
    for(int i=0; i<entries.size(); i++)
    	session.delete(entries.get(i));

//    session.delete("from w in class org.exoplatform.services.forum.hibernate.WatcherImpl " + 
//                   "where w.topicId = ?",
//                   topic.getId(), Hibernate.STRING );
  }
  
  public void onDelete(XResources resources, Post post) throws Exception  { }
}