/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager.impl.exont;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * @author Tuan Nguyen
 */
public class ProjectManagerType extends NodeTypeImpl {

  public ProjectManagerType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:projectManager";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[3];
    this.declaredPropertyDefinitions[0] = 
      new PropertyDefinitionImpl("exo:owner",                  //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          null,                        //defaultValues
                          false,                       //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.COPY,  //onVersion        
                          false,                       //readOnly         
                          false                         //multiple         
      );

    this.declaredPropertyDefinitions[1] = 
      new PropertyDefinitionImpl("exo:createdDate",          //name
                          this,                       //declaringNodeType
                          PropertyType.DATE,         //requiredType
                          null,                        //valueConstraints 
                          NULL_VALUES,                     //defaultValues
                          true,                       //autoCreate       
                          false,                        //mandatory
                          OnParentVersionAction.COPY,  //onVersion        
                          false,                       //readOnly         
                          false                        //multiple         
      );
    
    this.declaredPropertyDefinitions[2] = 
      new PropertyDefinitionImpl("exo:description",          //name
                          this,                       //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          NULL_VALUES,                     //defaultValues
                          false,                       //autoCreate       
                          false,                        //mandatory
                          OnParentVersionAction.COPY,  //onVersion        
                          false,                       //readOnly         
                          false                        //multiple         
      );
    
    this.declaredChildNodeDefinitions = new NodeDefinition[1];
    NodeType[] types = {manager.getNodeType("exo:project")};
    this.declaredChildNodeDefinitions[0] = 
      new NodeDefinitionImpl("*",                               // name
                      this,                              // declaringNodeType
                      types,                             // requiredNodeTypes
                      manager.getNodeType("exo:project"),   // defaultNodeType
                      false,                             // autoCreate       
                      false,                              // mandatory        
                      OnParentVersionAction.IGNORE,     // onVersion        
                      false,                             // protected        
                      false                              // same-name sibling
      );
  }
}
