/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.htmlparser.impl;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.List;

import org.exoplatform.services.spider.core.htmlparser.Document;
import org.exoplatform.services.spider.core.htmlparser.Node;
import org.exoplatform.services.spider.core.io.DataStream;


/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Jan 5, 2006
 */
public class DocumentImpl implements Document {
  
  private Node root;
  
  public DocumentImpl(String html) throws Exception {   
    this(html.getBytes());   
  }
  
  public DocumentImpl(byte[] data) throws Exception {   
    parser(data);
  }
  
  public DocumentImpl(InputStream input) throws Exception {    
    if(input instanceof FileInputStream)
      parser((new DataStream()).load( (FileInputStream)input));
    else{
      BufferedInputStream buffer = new BufferedInputStream(input);   
      ByteArrayOutputStream output = new ByteArrayOutputStream();
      byte[] data  = new byte[buffer.available()];      
      int available = -1;
      while( (available = buffer.read(data)) > -1){
        output.write(data, 0, available);
      }   
      parser(output.toByteArray());
    }
  }
  
  public DocumentImpl(File file) throws Exception {    
    parser((new DataStream()).load( file));
  }  
  
  private void parser(byte[] data){
    DocumentParser  parser = new DocumentParser(); 
    List<Token> list = parser.getToken(new String(data));    
    for(Token ele : list)
      System.out.println( ele.getValue());
  }
   
  public Node getRootNode(){
    return this.root;
  }
  
  public Node findNodeByStructureId(String structureID) throws Exception {
    if(structureID == null || structureID.trim().equals("")) 
      throw new NullPointerException("Structure ID is null or empty");
    String [] split = structureID.split("\\.");
    int index = -1;
    Node node = root;
    for(String element : split){
      index = Integer.parseInt( element);
      if(index >= node.getChildrenSize() || index < 0)
        throw new IndexOutOfBoundsException("Structure ID have incorrect index");
      node = node.getChild(index);      
    }
    return node;    
  }
  
  public String getEncoding(){
    return "utf-8";
//    EncodingFinder handler = new EncodingFinder(root);   
//    return handler.getCharset();
  }  
  
  public String getTextContent(){
    String content = "";    
    return content;
  }
}
