/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.htmlparser.impl;

import java.util.ArrayList;
import java.util.List;
/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Jan 5, 2006
 */
class DocumentParser {
  
  String[] SINGLE = {"area", "base", "basefont", "br", "col", "!doctype",
                  "frame",  "hr", "img",  "input", "isindex",  "link", "meta",  "param"};
  
  char slash = '/', openTag = '<', closeTag = '>' ;
  
  List<Token> getToken(String data){    
    List<Token> list = new ArrayList<Token>();      
    if( data == null || data.length() < 2) return list; 
    int start = data.charAt(0) == openTag ? 1 : 0;    
    int end = start+1;
    while( end < data.length()){       
      if( data.charAt(end) == openTag)         
        start = createToken( data, start, end, list, StaticData.CONTENT); 
      else if( data.charAt(end) == closeTag)        
        start = createToken(data, start, end, list, StaticData.TAG);
      end++;      
    }
    return list;
  } 
   
  private int createToken(String data, int start, int end, List<Token> list, int type){    
    String value = data.substring(start, end).trim(); 
    if(value.length() <= 0) return end+1;   
    if(value.charAt(0) == slash){
      if(value.length() <= 1) return end+1;
      value = value.substring(1);      
      type = StaticData.CLOSE;    
    }   
    String name = null;
    if(type != StaticData.CONTENT){      
      name = value.substring(0, StaticData.findWhiteSpace(value,0));
      if(value.charAt(value.length()-1) == slash || isToken(SINGLE, name)) 
      type = StaticData.SINGLE;    
    }
    list.add( new Token( value, name, type));
    return end+1;
  }  
  
  private boolean isToken(String[] arr, String value){    
    for(String ele : arr){
      if(value.equalsIgnoreCase(ele)) return true;
    }
    return false;
  }
}
