/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

import java.io.IOException;

import javax.portlet.* ;
/**
 * The simplest portlet ever!
 *
 * <p>
 * Date: May 25, 2003 Time: 11:26:44 PM
 * </p>
 *
 * @author Mestrallet Benjamin
 * @version $Revision: 1.2 $
 */
public class HelloWorldPortlet extends GenericPortlet {
  private static final String HELLO_TEMPLATE =
    "/WEB-INF/templates/html/HelloWorld.jsp";

  /**
   * A life cycle method. This method gets inovked by the container.
   *
   * @param pConfig a object that holds the portlet configuration information
   *
   * @throws PortletException an exception that you throw if things go wrong
   *         while starting the portlet
   */
  public void init(PortletConfig pConfig) throws PortletException
  {
    super.init(pConfig);
  }

  /**
   * The GenericPortlet calls this method if the portlet mode is view
   *
   * @param pRequest the request
   * @param pResponse the response
   *
   * @throws PortletException
   * @throws IOException
   */
  public void doView(RenderRequest pRequest, RenderResponse pResponse)
    throws PortletException, IOException
  {
    WindowState state = pRequest.getWindowState();
    pResponse.setContentType("text/html");

    PortletContext context = getPortletContext();
    PortletRequestDispatcher rd = context.getRequestDispatcher(HELLO_TEMPLATE);
    rd.include(pRequest, pResponse);
  }

  /**
   * The GenericPortlet calls this method if the portlet mode is edit
   *
   * @param pRequest the request
   * @param pResponse the response
   *
   * @throws PortletException
   * @throws IOException
   */
  public void doEdit(RenderRequest pRequest, RenderResponse pResponse)
    throws PortletException, IOException
  {
    WindowState state = pRequest.getWindowState();
    pResponse.setContentType("text/html");

    PortletContext context = getPortletContext();
    PortletRequestDispatcher rd = context.getRequestDispatcher(HELLO_TEMPLATE);
    rd.include(pRequest, pResponse);

  }


  /**
   * The GenericPortlet calls this method if the portlet mode is help
   *
   * @param pRequest the request
   * @param pResponse the response
   *
   * @throws PortletException
   * @throws IOException
   */
  public void doHelp(RenderRequest pRequest, RenderResponse pResponse)
    throws PortletException, IOException
  {
    WindowState state = pRequest.getWindowState();
    pResponse.setContentType("text/html");

    PortletContext context = getPortletContext();
    PortletRequestDispatcher rd = context.getRequestDispatcher(HELLO_TEMPLATE);
    rd.include(pRequest, pResponse);
  }
}
