/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.core.exoservices;

import java.net.URL;

/**
 * An implemenation of this interface should be able to return a well formatted URL given
 * a unresolved URL (please see method description below).
 * 
 * The main motivation of providing such an interface is to allow the UI layer to provide
 * the implementation which might, for example, ask the user to provide the resloved URL
 * by displaying the unresloved URL to the user.
 * 
 * @author Hatim Khan
 */
public interface IImportConfigurationURLResolver
{
  /**
   * Should return a well formatted URL given the unresolved URL. The unresolved URL is a
   * string value taken as is from the &lt;import&gt; element. For example, the value of
   * the unresloved URL could be something like file:${tobeevaluated},
   * jar:/conf/confiugration.xml, war:/conf/org-configuration.xml, file:C:/lab/file.xml.
   * 
   * @param pUnresolvedURL the unresolved URL
   * @param pInclusingFile the file in which the unresolved URL appeared 
   * @return please see method description
   */
  public URL resolveImportURL(String pUnresolvedURL, URL pInclusingFile);

}