/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.launching;

/**
 * A way to encapsulate the information about the location of Tomcat, that can be used
 * later to determine its configuraton.
 * 
 * @author Hatim Khan
 */
public interface ITomcatLocation
{

  /**
   * The tomcat home. For example if you installed Tomcat at c:\tomcat5, then the tomcat
   * home should be c:\tomcat5.
   * 
   * @return the installation directory of Tomcat
   */
  public String getTomcatHome();

  /**
   * The location of the main source code directory. By default, Tomcat 5, installs the
   * source code under tomcat5/src
   * 
   * @return the installation directory of the source code
   */
  public String getTomcatSrc();

  /**
   * Sets the installation directory of Tomcat
   * 
   * @param pTomcatHome the installation directory of Tomcat
   */
  public void setTomcatHome(String pTomcatHome);

  /**
   * Sets the installation directory of the source code of Tomcat
   * 
   * @param pTomcatSrc the installation directory of the source code of Tomcat
   */
  public void setTomcatSrc(String pTomcatSrc);

}