/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.launching.delegate;


import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.exoplatform.eclipse.core.launching.IExoTomcatLocation;

/**
 * A location the represents an eXo tomcat installation
 * 
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public class ExoTomcatLocation extends TomcatLocation implements IExoTomcatLocation
{
  public static final String CLASS_VERSION = "$Id: ExoTomcatLocation.java,v 1.1 2004/09/20 01:39:14 hatimk Exp $"; //$NON-NLS-1$
  private String mExoSrc;

  /**
   * The location of eXo platform source directory
   * 
   * @return the eXo platform source directory
   */
  public String getExoSrc()
  {
    return mExoSrc;
  }

  /**
   * Sets the location of eXo platform source directory
   * 
   * @param pExoSrc the eXo platform source directory
   */
  public void setExoSrc(String pExoSrc)
  {
    mExoSrc = pExoSrc;
  }

  /**
   * @see java.lang.Object#equals(java.lang.Object)
   */
  public boolean equals(Object pExoTomcatLocation)
  {
    if ((pExoTomcatLocation == null))
    {
      return false;
    }
    if (this == pExoTomcatLocation)
    {
      return true;
    }

    if (!(pExoTomcatLocation instanceof IExoTomcatLocation))
    {
      return false;
    }

    boolean tomcatsame = super.equals(pExoTomcatLocation);
    if (tomcatsame)
    {
      IExoTomcatLocation location = (IExoTomcatLocation) pExoTomcatLocation;

      // now lets put the locations in terms of IPath
      IPath exoSrc1 = (mExoSrc == null) ? Path.EMPTY : new Path(mExoSrc);
      IPath exoSrc2 = (location.getExoSrc() == null) ? Path.EMPTY : new Path(location.getExoSrc());

      return exoSrc1.equals(exoSrc2);
    }
    else
    {
      return false;
    }
  }
}