/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.core.portal;

/**
 * A listener that wants to be notified when any elements of a PortalSettings
 * configuration is changed should implement this interface, and then register itself with
 * the appropriate event source (as of this writing, only PortalSettings is a source of
 * this event).
 * 
 * @author Hatim Khan
 */
public interface IPortalSettingsConfigurationChangedListener
{
  public void ConfigurationElementRemoved(Object pParent, Object pChild);

  public void ConfigurationElementAdded(Object pChild);

  public void ConfigurationElementUpdated(Object pElement);
}