/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.core.portal.model;

/**
 * A value holder that can have a parent
 * 
 * @author Hatim Khan
 */
public class ValueHolder implements INode
{
  private transient Object mParent = null;
  private String mValue;

  /**
   * @see org.exoplatform.eclipse.core.portal.model.INode#getChildren()
   */
  public Object[] getChildren()
  {
    return null;
  }

  /**
   * @see org.exoplatform.eclipse.core.portal.model.INode#getParent()
   */
  public Object getParent()
  {
    return mParent;
  }

  /**
   * @param pParent The parent to set.
   */
  public void setParent(Object pParent)
  {
    mParent = pParent;
  }

  /**
   * @return Returns the value.
   */
  public String getValue()
  {
    return mValue;
  }

  /**
   * @param pValue The value to set.
   */
  public void setValue(String pValue)
  {
    mValue = pValue;
  }

  /**
   * @see org.exoplatform.eclipse.core.portal.model.INode#removeChild(java.lang.Object)
   */
  public boolean removeChild(Object pChild)
  {
    // the value holder does not have children
    return false;
  }

  /**
   * @see org.exoplatform.eclipse.core.portal.model.INode#addChild(java.lang.Object)
   */
  public void addChild(Object pChild)
  {
    // value holder does not have children
  }
}