/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.runtime;


import org.eclipse.core.runtime.QualifiedName;
import org.exoplatform.eclipse.core.ExoCorePlugin;

/**
 * A place to hold all runtime properties for the project resource. An example
 * of such properties would be the deployment directory, the context root,
 * etc.
 *
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public interface IExoProjectRuntimeProperties
{
  public static final String CLASS_VERSION =
    "$Id: IExoProjectRuntimeProperties.java,v 1.1 2004/04/19 03:45:48 hatimk Exp $"; //$NON-NLS-1$
  public static final QualifiedName PORTLET_PROJECT =
    new QualifiedName(ExoCorePlugin.PLUGIN_ID, "portlet_project"); //$NON-NLS-1$    
  public static final QualifiedName DEPLOYMENT_DIR =
    new QualifiedName(ExoCorePlugin.PLUGIN_ID, "deployment_dir"); //$NON-NLS-1$
  public static final QualifiedName DEPLOYMENT_OPTION =
    new QualifiedName(ExoCorePlugin.PLUGIN_ID, "deployment_option"); //$NON-NLS-1$
  public static final QualifiedName OVERWRITE_PROMPT =
    new QualifiedName(ExoCorePlugin.PLUGIN_ID, "overwrite_prompt"); //$NON-NLS-1$
  public static final QualifiedName OVERWRITE_WEBXML_PROMPT =
    new QualifiedName(ExoCorePlugin.PLUGIN_ID, "overwrite_webxml_prompt"); //$NON-NLS-1$    
  public static final QualifiedName DETECT_WEBXML_FORMODIFICATION_OPTION =
    new QualifiedName(ExoCorePlugin.PLUGIN_ID,
      "detect_webxml_formodification_option"); //$NON-NLS-1$        
  public static final boolean OVERWRITE_PROMPT_ON = true;
  public static final boolean OVERWRITE_PROMPT_OFF = false;
  public static final boolean OVERWRITE_PROMPT_DEFAULT = OVERWRITE_PROMPT_ON;
  public static final boolean OVERWRITE_WEBXML_PROMPT_DEFAULT =
    OVERWRITE_PROMPT_ON;
  public static final int DEPLOYMENT_OPTION_EXPLODED = 1;
  public static final int DEPLOYMENT_OPTION_PACKAGED = 2;
  public static final int DEPLOYMENT_OPTION_DEFAULT =
    DEPLOYMENT_OPTION_EXPLODED;
  public static final boolean DETECT_WEBXML_FORMODIFICATION_OPTION_ENABLED = true;
  public static final boolean DETECT_WEBXML_FORMODIFICATION_OPTION_DISABLED = false;
  public static final boolean DETECT_WEBXML_FORMODIFICATION_OPTION_DEFAULT =
    DETECT_WEBXML_FORMODIFICATION_OPTION_ENABLED;
}
