/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.warpackager;

import org.eclipse.core.runtime.CoreException;

import java.util.jar.Manifest;

/**
 * A manifest provider creates manifest files.  Clients may implement this
 * interface. This is a direct adaptation of the same concept from
 * org.eclipse.jdt.ui.jarpackager.IManifestProvider
 */
public interface IManifestProvider
{
  /**   
   * Creates a manifest as defined by the <code>JarPackage</code>.
   *
   * @param pWarPackage the WAR package specification
   *
   * @return a manifest
   *
   * @throws CoreException if access to any resource described by the WAR
   *         package has failed
   */
  Manifest create(WarPackageData pWarPackage) throws CoreException;

  /**   
   * Creates a default manifest.
   *
   * @param pManifestVersion a string denoting the manifest version
   *
   * @return a default manifest
   */
  Manifest createDefault(String pManifestVersion);
}
