/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.xmlvalidator;

import org.eclipse.core.runtime.IProgressMonitor;

/**
 * Represents a validator for portlet.xml
 *
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public interface IPortletDescriptorValidator
{
  public static final String CLASS_VERSION = "$Id: IPortletDescriptorValidator.java,v 1.1 2004/04/19 03:45:50 hatimk Exp $"; //$NON-NLS-1$

  /**   
   * validates the given portlet.xml.  IMPORTANT NOTE: the implementation of
   * this interface might choose to perform the validation in a different
   * thread. Therefore, the IProgressMonitor implemenation should be able to
   * handle the operation from non UI thread.
   *
   * @param pReporter the resource to validate
   */
  public void validate(PortletValidationProblemReporter pReporter,
    IProgressMonitor pMonitor);

  /**   
   * DOCUMENT ME!
   *
   * @return
   */
  public String getSupportedSpecVersion();

  /**   
   * DOCUMENT ME!
   *
   * @param pVersion
   */
  public void setSupportedSpecVersion(String pVersion);

  /**   
   * DOCUMENT ME!
   *
   * @return
   */
  public String getSupportedExoVersion();

  /**   
   * DOCUMENT ME!
   *
   * @param pVersion
   */
  public void setSupportedExoVersion(String pVersion);

  /**   
   * DOCUMENT ME!
   *
   * @return
   */
  public boolean isDefault();

  /**   
   * DOCUMENT ME!
   *
   * @param pDefault
   */
  public void setDefault(boolean pDefault);

  /**   
   * DOCUMENT ME!
   *
   * @return
   */
  public int getOrder();

  /**   
   * DOCUMENT ME!
   *
   * @param pOrder
   */
  public void setOrder(int pOrder);
}
