/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.internal.ui.editor;

import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.forms.editor.FormPage;
import org.exoplatform.eclipse.core.portal.PortalSettings;

/**
 * This page hosts the 'portal services' master/detail block. Because this class extends
 * from FormPage it comes with a managed form. The managed form is passed to the block to
 * create the actual content. Notice that this class does not listen to any portal
 * settings changed events because it does not need to, instead the block will have to
 * worry about them. When the block is dirty it will inform the managed form provided by
 * this class which in turn will inform the editor of this page.
 * 
 * @author Hatim Khan
 */
public class PortalServicesFormPage extends FormPage
{
  public static final String PAGE_ID = "PortalServices"; //$NON-NLS-1$
  public static final String PAGE_TITLE = "Portal Services";
  private PortalSettings mPortalSettings;
  private PortalServicesBlock mBlock;

  public PortalServicesFormPage(PortalSettings pPortalSettings, FormEditor pEditor)
  {
    super(pEditor, PAGE_ID, PAGE_TITLE);
    mPortalSettings = pPortalSettings;
    mBlock = new PortalServicesBlock(mPortalSettings);
  }

  /**
   * @see org.eclipse.ui.forms.editor.FormPage#createFormContent(org.eclipse.ui.forms.IManagedForm)
   */
  protected void createFormContent(IManagedForm pManagedForm)
  {
    mBlock.createContent(pManagedForm);
  }

}