/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.internal.ui.sample;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

import java.util.ArrayList;

/**
 * This class can be used with the viewers to return all available sample
 * webapp projects that match the given kind.
 *
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public class SampleWebappContentProvider implements IStructuredContentProvider
{
  public static final String CLASS_VERSION = "$Id: SampleWebappContentProvider.java,v 1.1 2004/04/19 03:37:23 hatimk Exp $"; //$NON-NLS-1$
  private String mKind;

  /**
   * The constructor method.
   *
   * @param pKind  
   */
  public SampleWebappContentProvider(String pKind)
  {
    mKind = pKind;
  }

  /**   
   * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
   */
  public Object[] getElements(Object pInputElement)
  {
    // it does not matter what the input element is, always return the available
    // sample webapp projects that match the given kind
    java.util.List result = new ArrayList();

    SampleWebappProject[] all =
      SampleWebappInitializer.getSampleWebappProjects(mKind);
    if (all != null)
    {
      for (int i = 0, sizei = all.length; i < sizei; ++i)
      {
        result.add(all[i]);
      }
    }

    return result.toArray();
  }

  /**   
   * @see org.eclipse.jface.viewers.IContentProvider#dispose()
   */
  public void dispose()
  {
  }

  /**   
   * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer,
   *      java.lang.Object, java.lang.Object)
   */
  public void inputChanged(Viewer pViewer, Object pOldInput, Object pNewInput)
  {
  }
}
