/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.internal.ui.sample;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * This class is able to understand SampleWebappProject objects and can answer
 * to the viewers questions regarding texts and images.
 *
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public class SampleWebappLabelProvider extends LabelProvider
{
  public static final String CLASS_VERSION = "$Id: SampleWebappLabelProvider.java,v 1.1 2004/04/19 03:37:23 hatimk Exp $"; //$NON-NLS-1$
  private Map mImageCache = new HashMap();

  /**   
   * @see org.eclipse.jface.viewers.ILabelProvider#getImage(java.lang.Object)
   */
  public Image getImage(Object pElement)
  {
    ImageDescriptor descriptor = null;
    if (pElement instanceof SampleWebappProject)
    {
      descriptor = ((SampleWebappProject) pElement).getIcon();
    }
    else
    {
      return null;
    }

    //obtain the cached image corresponding to the descriptor
    Image image = (Image) mImageCache.get(descriptor);
    if (image == null)
    {
      image = descriptor.createImage();
      mImageCache.put(descriptor, image);
    }

    return image;
  }

  /**   
   * @see org.eclipse.jface.viewers.ILabelProvider#getText(java.lang.Object)
   */
  public String getText(Object pElement)
  {
    if (pElement instanceof SampleWebappProject)
    {
      return ((SampleWebappProject) pElement).getTitle();
    }

    return ""; //$NON-NLS-1$
  }

  /**   
   * @see org.eclipse.jface.viewers.IBaseLabelProvider#dispose()
   */
  public void dispose()
  {
    super.dispose();
    for (Iterator i = mImageCache.values().iterator(); i.hasNext();)
    {
      ((Image) i.next()).dispose();
    }
    mImageCache.clear();
  }
}
