/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.internal.ui.wizard;

import org.eclipse.jface.wizard.IWizardContainer2;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.exoplatform.eclipse.ui.dialog.DidYouKnowForm;

/**
 * @author Hatim Khan
 */
public abstract class DidYouKnowPage extends WizardPage
{
  private String mDidYouKnowMessage;

  /**
   * @param pageName
   */
  protected DidYouKnowPage(String pPageName, String pDidYouKnowMessage)
  {
    super(pPageName);
    mDidYouKnowMessage = pDidYouKnowMessage;
  }

  /**
   * @see org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
   */
  public void createControl(Composite pParent)
  {
    Composite mainContainer = new Composite(pParent, SWT.NONE);
    initializeDialogUnits(mainContainer);
    mainContainer.setFont(pParent.getFont());

    GridLayout layout = new GridLayout(1, false);
    layout.marginHeight = 0;
    layout.marginWidth = 0;
    layout.verticalSpacing = 0;
    layout.horizontalSpacing = 0;

    mainContainer.setLayout(layout);
    mainContainer.setLayoutData(new GridData(GridData.FILL_BOTH));

    createContentBeforeDidYouKnow(mainContainer);
    createDidYouKnowContent(mainContainer);
    setControl(mainContainer);
  }

  private void createContentBeforeDidYouKnow(Composite pParent)
  {
    Composite container = new Composite(pParent, SWT.NONE);
    container.setFont(pParent.getFont());

    GridLayout layout = new GridLayout(1, false);
    layout.marginHeight = 4;
    layout.marginWidth = 0;
    layout.verticalSpacing = 0;
    layout.horizontalSpacing = 0;

    container.setLayout(layout);
    container.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    createActualContent(container);
  }

  public abstract void createActualContent(Composite pParent);

  private void createDidYouKnowContent(Composite pParent)
  {

    Composite container = new Composite(pParent, SWT.NONE);
    container.setFont(pParent.getFont());

    GridLayout layout = new GridLayout(1, false);
    layout.marginHeight = 0;
    layout.marginWidth = 0;
    layout.verticalSpacing = 0;
    layout.horizontalSpacing = 0;

    container.setLayout(layout);
    container.setLayoutData(new GridData(GridData.FILL_BOTH));
    //UICompositeUtil.setHeightHint(container, 200);

    // Build the separator line
    Label titleBarSeparator = new Label(container, SWT.HORIZONTAL | SWT.SEPARATOR);
    titleBarSeparator.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

    new DidYouKnowForm(container, mDidYouKnowMessage, (IWizardContainer2) getContainer());

    // Build the separator line
    titleBarSeparator = new Label(container, SWT.HORIZONTAL | SWT.SEPARATOR);
    titleBarSeparator.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
  }
}