/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.eclipse.webunit.views;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.exoplatform.eclipse.webunit.widgets.ExoTextEditor;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Oct 4, 2004
 * @version $Id: HtmlTextEditorView.java,v 1.3 2004/10/09 19:08:59 tuan08 Exp $
 */
public class HtmlTextEditorView extends Composite {
  private StyledText editor_ ;
  public HtmlTextEditorView(Composite parent ) {
    super(parent, SWT.NONE) ;
    GridLayout gridLayout = new GridLayout();
    setLayout(gridLayout);
    
    GridData textGridData = new GridData();
    textGridData.grabExcessVerticalSpace = true ;
    textGridData.grabExcessHorizontalSpace = true;
    textGridData.horizontalAlignment = GridData.FILL;
    textGridData.verticalAlignment = GridData.FILL;
    editor_ = new ExoTextEditor (this, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL | SWT.H_SCROLL);

    editor_.setText("") ;
    editor_.setEditable(true) ;
    editor_.setLayoutData(textGridData) ;
    
    Button saveButton = new Button(this, SWT.PUSH);
    saveButton.setText("Preview") ;  
    saveButton.addSelectionListener(new PreviewSelectionListener()) ;
  }
  
  public void setText(String text) { editor_.setText(text) ; }
  
  class PreviewSelectionListener extends SelectionAdapter{
    public void widgetSelected(SelectionEvent evt) {
      Control control = (Control) evt.getSource() ;
      ViewController controller = ViewController.findController(control) ;
      controller.getResultView().getBrowserView().getBrowser().setText(editor_.getText()) ;
      controller.getResultView().showBrowser() ;
    }
  }
}