/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.eclipse.webunit.views;

import org.exoplatform.eclipse.webunit.ExceptionUtil;
import org.exoplatform.test.web.ExoWebClient;
import org.exoplatform.test.web.TestSuites;
import org.exoplatform.test.web.unit.WebUnit;
/**
 * May 22, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UnitTestPlayer.java,v 1.3 2004/10/09 19:08:59 tuan08 Exp $
 **/
public class UnitTestPlayer implements Runnable {
  private TestSuites suites_ ;
  private ExoWebClient webClient_ ;
  private ViewController controller_ ;
  
  public UnitTestPlayer(ViewController controller, TestSuites suites) {
    String user = Long.toString(new java.util.Date().getTime()) ;
    webClient_ = new ExoWebClient(user, "http://localhost:8080/portal");
    webClient_.setValidateWebUnit(true) ;
    webClient_.setValidateWellFormedXhtml(false) ;
    webClient_.setInterval(1000) ;
    suites_ = suites;
    webClient_.setSuites(suites_) ;
    controller_  = controller ;
  }
  
  public void reset() { suites_.reset() ; }
  
  public ExoWebClient getWebClient() { return webClient_ ; }
  
  public String getCurrentUnitTestDescription() {
    WebUnit  unit = suites_.getCurrentWebUnit() ;
    if(unit != null ) return unit.getDescription() ;
    return "Done...." ;
  }
  
  public String getCurrentResponseText() {
    try {
      return webClient_.getResponseText() ;
    } catch (Exception ex) {
    }
    return "" ;
   }
  
  public void runNextUnit() {
    try {
      if(!suites_.nextUnit()) return; 
      WebUnit unit = suites_.getCurrentWebUnit() ;
      webClient_.executeUnit(unit) ;
      controller_.getResultView().getBrowserView().getBrowser().setText(webClient_.getResponseText()) ;
    } catch (Exception ex) {
      String s = "<pre>" + ExceptionUtil.getStackTrace(ex, 100) + "</pre>";
      controller_.showError(ex, s) ;
    }
  }
  
  public void run() {
    suites_.reset() ;
    try {
      while(suites_.nextUnit()) {
        WebUnit unit = suites_.getCurrentWebUnit() ;
        webClient_.executeUnit(unit) ;
        long interval = webClient_.getInterval() ; 
        if(interval > 0) {
          controller_.getResultView().getBrowserView().getBrowser().setText(webClient_.getResponseText()) ;
          controller_.getUnitTestControlellerView().
                      getUnitTestDescriptionWidget().
                      setText(unit.getDescription()) ;
          controller_.getUnitTestView().updateUnitTreeLabelStatus() ;
          Thread.sleep(interval) ;
        } 
      }
    } catch (InterruptedException ex) {
      return ;
    } catch (Exception ex) {
      String s = "<pre>" + ExceptionUtil.getStackTrace(ex, 100) + "</pre>";
      controller_.getResultView().getBrowserView().getBrowser().setText(s) ;
    }
    controller_.getUnitTestView().updateUnitTreeLabelStatus() ;
  }
}
