/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.addrbook.component;

import java.util.Collection;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.addrbook.AddrBookService;
import org.exoplatform.services.addrbook.model.AddrBook;

/**
 * @author: Daniel Summer
 * @email:  danny_xcz@163.com
 */
public class UIAddrUserInfo extends UIExoCommand {
  private AddrBook addrBook_;
  private AddrBookService service_ ; 
   
  public UIAddrUserInfo(AddrBookService service) throws Exception {
    setId("UIAddrUserInfo") ;
    setRendererType("AddrUserInfoRenderer") ;
    service_ = service ;
    addActionListener(BackActionListener.class, "back") ;
  }
  
  public void setAddrBookInfo(AddrBook addr){
  	addrBook_=addr;
  }
  
  public AddrBook getAddrBookInfo(){
  	return addrBook_;
  }
  
  static public class BackActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
      UIAddrUserInfo uiInfo = (UIAddrUserInfo) event.getComponent() ;
      uiInfo.setRenderedSibling(UIAddrBookExplorer.class) ;
    }
  }
  
  public String getFamily() {
	return "org.exoplatform.portlets.addrbook.component.UIAddrUserInfo";
  }
}