/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.ftp.component;

import java.util.Collection;
import java.util.Iterator;
import java.util.ResourceBundle;
import java.util.List;

import org.exoplatform.faces.core.component.UIFileUpload;
import org.exoplatform.faces.core.component.UIPortlet;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.FacesUtil;
import javax.portlet.PortletPreferences;
import org.exoplatform.portlets.ftp.component.util.FtpConnection;
import org.apache.commons.net.ftp.*;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UIMessageCenterPortlet.java,v 1.4 2004/09/11 01:56:31 tuan08 Exp $
 */
public class UIFtpPortlet extends UIPortlet {

	private static FtpConnection ftpConn;

	public UIFtpPortlet(ResourceBundle res) throws Exception {
		try {
			setId("UIFtpPortlet");
			
			setRendererType("ChildrenRenderer");

			PortletPreferences prefs = FacesUtil.getPortletPreferences();

			String host = prefs.getValue("host", "localhost");
			String port = prefs.getValue("port", "21");
			String anonymous = prefs.getValue("anonymous", "true");
			String username = prefs.getValue("username", "");
			String password = prefs.getValue("password", "");
			ftpConn =
				new FtpConnection(host, port, anonymous, username, password);

			List children = getChildren();
			UIFtp uiFtp = new UIFtp(ftpConn, res);
			uiFtp.setRendered(true);
			children.add(uiFtp);

			UIFileForm uiFileForm = new UIFileForm(ftpConn, res);
			uiFileForm.setRendered(false);
			children.add(uiFileForm);

			UIFileUpload uiFileUpload = new UIFileUpload();
			uiFileUpload.setNumberOfField(1);
			uiFileUpload.setRendered(false);
			uiFileUpload.addActionListener(
				ShowExplorerActionListener.class,
				UIFileUpload.CANCEL_ACTION);
			uiFileUpload.addActionListener(
				SaveUploadFileActionListener.class,
				UIFileUpload.UPLOAD_ACTION);
			children.add(uiFileUpload);

		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	static public class ShowExplorerActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFileUpload uiFileUpload = (UIFileUpload) event.getComponent();
			UIFtpPortlet uiController = (UIFtpPortlet) uiFileUpload.getParent();
			uiController.setRenderedComponent(UIFtp.class);
		}
	}

	static public class SaveUploadFileActionListener
		extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFileUpload uiFileUpload = (UIFileUpload) event.getComponent();
			UIFtpPortlet uiController = (UIFtpPortlet) uiFileUpload.getParent();
			Collection processes = uiFileUpload.getUserInputs();
			for (Iterator iterator = processes.iterator();
				iterator.hasNext();
				) {
				UIFileUpload.UserInput userInput =
					(UIFileUpload.UserInput) iterator.next();
				/*
				WorkflowDefinitionService workflowDefinitionService =
					workflowServiceContainer.createWorkflowDefinitionService();
				try {
					JarInputStream iS =
						new JarInputStream(
							new ByteArrayInputStream(userInput.getStream()));
					workflowDefinitionService.deployProcessArchive(iS);
				} catch (IOException e) {
					e.printStackTrace();
				} catch (JpdlException e) {
					e.printStackTrace();
				} finally {
					workflowDefinitionService.close();
				}
				*/
			}
			UIFtp uiFtp =
				(UIFtp) uiController.getChildComponentOfType(
					UIFtp.class);
			uiFtp.update();
		}
	}

}