/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.ftp.component.util;

import java.io.InputStream;
import java.io.OutputStream;

import org.apache.commons.net.ftp.*;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UIAccount.java,v 1.7 2004/09/20 01:00:17 tuan08 Exp $
 */
public class FtpConnection {
	private FTPClient ftp_ = new FTPClient();
	private String host;
	private String port;
	private String anonymous;
	private String username;
	private String password;
	private String currentDir = "/";

	public FtpConnection(
		String phost,
		String pport,
		String panonymous,
		String pusername,
		String ppassword) {
		host = phost;
		port = pport;
		anonymous = panonymous;
		username = pusername;
		password = ppassword;
	}

	public boolean changeWorkingDirectory(String dir) throws Exception {
		boolean b = false;
		connect();
		b = ftp_.changeWorkingDirectory(dir);
		disconnect();
		return b;
	}
/*
	public boolean changeCurrentDirectory() throws Exception {
		boolean b = false;
		connect();
		b =
			ftp_.changeWorkingDirectory(
				new String(currentDir.getBytes("GBK"), "ISO-8859-1"));
		disconnect();
		return b;
	}
*/
	public FTPFile[] listFiles() throws Exception {
		FTPFile[] files;
		connect();
		files =
			ftp_.listFiles(
				//new String(currentDir.getBytes(), "ISO-8859-1"));
		currentDir);
		disconnect();
		return files;
	}

	public boolean retrieveFile(String remote,OutputStream local) throws Exception {
		boolean b = false;
		connect();
		b = ftp_.retrieveFile(remote,local);
		disconnect();
		return b;
	}

	public boolean storeFileStream(String remote,InputStream local) throws Exception {
		boolean b = false;
		connect();
		b = ftp_.storeFile(remote,local);
		disconnect();
		return b;
	}

	public boolean rename(String from, String to) throws Exception {
		boolean b = false;
		connect();
		b = ftp_.rename(from, to);
		disconnect();
		return b;
	}

	private void connect() throws Exception {

		if (anonymous.equals("true")) {
			ftp_.connect(host);
			ftp_.login("anonymous", "");
		} else {
			ftp_.connect(host);
			ftp_.login(username, password);
		}
		//changeCurrentDirectory();
	}

	private void disconnect() throws Exception {
		ftp_.disconnect();
	}

	/**
	 * @return
	 */
	public String getAnonymous() {
		return anonymous;
	}

	/**
	 * @return
	 */
	public String getHost() {
		return host;
	}

	/**
	 * @return
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * @return
	 */
	public String getPort() {
		return port;
	}

	/**
	 * @return
	 */
	public String getUsername() {
		return username;
	}

	/**
	 * @param string
	 */
	public void setAnonymous(String string) {
		anonymous = string;
	}

	/**
	 * @param string
	 */
	public void setHost(String string) {
		host = string;
	}

	/**
	 * @param string
	 */
	public void setPassword(String string) {
		password = string;
	}

	/**
	 * @param string
	 */
	public void setPort(String string) {
		port = string;
	}

	/**
	 * @param string
	 */
	public void setUsername(String string) {
		username = string;
	}

	/**
	 * @return
	 */
	public String getCurrentDir() {
		return currentDir;
	}

	/**
	 * @param string
	 */
	public void setCurrentDir(String string) {
		currentDir = string;
	}

}
