/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.ftp.renderer.html;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.Collection;
import java.util.*;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.ftp.component.*;

import org.apache.commons.net.ftp.*;
import java.text.SimpleDateFormat;
import org.exoplatform.portlets.ftp.component.util.*;

/**
 * @email:   danny_xcz@users.sourceforge.net
 * @version: $Id: GroupExplorerRenderer.java,v 1.10 2004/09/07 01:44:00 danny_xcz Exp $
 */
public class FtpRenderer extends HtmlBasicRenderer {

	private static Parameter EDIT_FILE = new Parameter(ACTION, "editFile");
	private static Parameter CHANGE_DIR = new Parameter(ACTION, "changeDir");
	private static Parameter CONNECT = new Parameter(ACTION, "connect");
	private static Parameter DISCONNECT = new Parameter(ACTION, "disconnect");
	private static Parameter REFRESH = new Parameter(ACTION, "refresh");
	private static Parameter UPLOAD_FILE = new Parameter(ACTION, "uploadFile");
	private static Parameter NEW_FOLDER =
		new Parameter(ACTION, "newFolder");
	private static Parameter DOWNLOAD = new Parameter(ACTION, "download");
	//private static Parameter[] deleteGroupParams_ = { new Parameter(ACTION , "deleteGroup")} ;

	final public void encodeBegin(FacesContext context, UIComponent component)
		throws IOException {
		ResourceBundle res =
			getApplicationResourceBundle(context.getExternalContext());
		ResponseWriter w = context.getResponseWriter();
		UIFtp uiFtp = (UIFtp) component;
		//FTPFile[] ftpFiles = uiFtp.getFiles();

		//System.out.println(files);
		String currentDir = uiFtp.getFtpConnection().getCurrentDir();
		
		String parentDir = "";
				int idx = currentDir.lastIndexOf("/");
				if (idx != 0) {
					parentDir = currentDir.substring(0, idx--);
				} else {
					parentDir = "/";
				}
		
		//String tmp = new String(currentDir.getBytes("ISO-8859-1"),"GBK");
		//currentDir = tmp;
		
		
		//tmp = new String(parentDir.getBytes("ISO-8859-1"),"GBK");
		//parentDir = tmp;

		w.write("<table class='UIFtp'>");
		w.write("<tr>");
		w.write("<td class='control-panel'>");
		addControlPanel(currentDir, uiFtp, context, w, res);
		w.write("</td>");
		w.write("</tr>");
		w.write("<tr>");
		w.write("<td class='path-panel'>");
		addPathSelect(currentDir, uiFtp, context, w, res);
		w.write("</td>");
		w.write("</tr>");
		w.write("<tr>");
		w.write("<td>");
		addFilesListTable(currentDir, parentDir, uiFtp, context, w, res);
		w.write("</td>");
		w.write("</tr>");
		w.write("</table>");
	}

	private void addControlPanel(
		String currentDir,
		UIFtp uiFtp,
		FacesContext context,
		ResponseWriter w,
		ResourceBundle res)
		throws IOException {
		//w.write("Control Panel");
		Parameter[] newFolderParams = { NEW_FOLDER };
		Parameter[] uploadFileParams = { UPLOAD_FILE };
						
//		uiFtp.appendLink(w, "New Folder", newFolderParams, "");
//		uiFtp.appendLink(w, "Upload File", uploadFileParams, "");
	}

	private void addPathSelect(
		String currentDir,
		UIFtp uiFtp,
		FacesContext context,
		ResponseWriter w,
		ResourceBundle res)
		throws IOException {
			//w.write(currentDir);
		w.write(new String(currentDir.getBytes("ISO-8859-1"),"GBK"));
		//w.write(new String(currentDir.getBytes("GBK"),"UTF-8"));
	}

	private void addFilesListTable(
		String currentDir,
		String parentDir,
		UIFtp uiFtp,
		FacesContext context,
		ResponseWriter w,
		ResourceBundle res)
		throws IOException {

		Parameter fileParam = new Parameter("file", "");
		Parameter dirParam = new Parameter("dir", "");
		Parameter downloadFileParam = new Parameter("downloadfile", "");
		Parameter[] editFileParams = { EDIT_FILE, fileParam };
		Parameter[] changeDirParams = { CHANGE_DIR, dirParam };
		Parameter[] downloadParams = { DOWNLOAD, downloadFileParam };

		FTPFile[] files = uiFtp.getFiles();
		List ftpFiles = new ArrayList();
		for(int i=0;i<files.length;i++){
			if (files[i].isDirectory()){
				ftpFiles.add(files[i]);
			}
		}
		for(int i=0;i<files.length;i++){
			if (files[i].isFile()){
				ftpFiles.add(files[i]);
			}
		}
		//files = (FTPFile[])ftpFiles.toArray();
		w.write("<table class='file-list'>");
		w.write("<tr>");
		w.write("<th>");
		w.write(res.getString("UIFtp.header.file-name"));
		w.write("</th>");
		w.write("<th>");
		w.write(res.getString("UIFtp.header.file-size"));
		w.write("</th>");
		w.write("<th>");
		w.write(res.getString("UIFtp.header.modified-date"));
		w.write("</th>");
		w.write("<th>");
		w.write(res.getString("UIFtp.header.property"));
		w.write("</th>");
		w.write("<th>");
		w.write(res.getString("UIFtp.header.edit"));
		w.write("</th>");
		w.write("</tr>");

		String upIcon = res.getString("UIFtp.img.up-icon");
		w.write("<tr class='odd'>");
		w.write("<td>");
		w.write(upIcon);
		dirParam.setValue(TextUtil.urlEncodeUTF8(parentDir));
//		uiFtp.appendLink(w, "[..]", changeDirParams, "");
		w.write("</td>");
		w.write("<td>");
		w.write("</td>");
		w.write("<td>");
		w.write("</td>");
		w.write("<td>");
		w.write("</td>");
		w.write("</tr>");

		
		if (files != null && files.length != 0) {
			Iterator i = ftpFiles.iterator() ;
			int j = 0;
			while(i.hasNext()) {

				FTPFile ftpFile = (FTPFile) i.next();
				
				//System.out.println(new String(ftpFile.getName().getBytes("GBK"),"ISO-8859-1"));
				//System.out.println(new String(ftpFile.getName().getBytes("UTF-8"),"ISO-8859-1"));
				//System.out.println(new String(ftpFile.getName().getBytes("GBK"),"UTF-8"));
				//System.out.println(new String(ftpFile.getName().getBytes("UTF-8"),"GBK"));
				//*System.out.println(new String(ftpFile.getName().getBytes("ISO-8859-1"),"GBK"));
				//System.out.println(new String(ftpFile.getName().getBytes("ISO-8859-1"),"UTF-8"));
				
				String clazz = "odd";
				if (j % 2 == 0)
					clazz = "even";
				w.write("<tr class='" + clazz + "'>");
				w.write("<td>");
				if (!ftpFile.isFile()) {
					String folderIcon = res.getString("UIFtp.img.folder-icon");
					w.write(folderIcon);
					String newDir = "";
					if(currentDir.equals("/")){
					newDir = currentDir + ftpFile.getName();
					}
					else {
					newDir = currentDir+"/"+ftpFile.getName();
					}
					dirParam.setValue(TextUtil.urlEncodeUTF8(newDir));
					
					String folderName = new String(ftpFile.getName().getBytes("ISO-8859-1"),"GBK");
					
//					uiFtp.appendLink(w, folderName, changeDirParams, "");
				} else {
					String fileIcon = res.getString("UIFtp.img.file-icon");
					w.write(fileIcon);
					String fullpathname = "";
					if(currentDir.equals("/")){
					fullpathname = currentDir + ftpFile.getName();
					}
					else {
					fullpathname = currentDir+"/"+ftpFile.getName();
					}
					downloadFileParam.setValue(fullpathname);

					String fileName = new String(ftpFile.getName().getBytes("ISO-8859-1"),"GBK");
//					uiFtp.appendLink(w, fileName, downloadParams, "");
					//w.write(fileName);
				}

				w.write("</td>");
				w.write("<td>");
				w.write(Long.toString(ftpFile.getSize()));
				w.write("</td>");
				w.write("<td>");
				SimpleDateFormat dateFormat =
					new SimpleDateFormat("yyyy-MM-dd HH:mm");
				w.write(dateFormat.format(ftpFile.getTimestamp().getTime()));
				w.write("</td>");
				w.write("<td>");
				int idx = ftpFile.getRawListing().indexOf(" ");
				w.write(ftpFile.getRawListing().substring(0,idx--));
				w.write("</td>");
				w.write("<td>");

				fileParam.setValue(ftpFile.getName());
//				uiFtp.appendLink(w, "edit", editFileParams, "");

				w.write("</td>");
				w.write("</tr>");
				j++;
			}
		} else {
			w.write("<tr>");
			w.write("<td class='empty-list' colspan='5'>");
			w.write(res.getString("UIFtp.label.empty-list"));
			w.write("</td>");
		}
		w.write("</table>");
	}
}