/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.publish.component;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.PageListDataHandler;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.publish.model.*;
import org.exoplatform.services.publish.PublishService;

/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIPosts.java,v 1.9 2004/10/20 18:46:31 benjmestrallet Exp $
 */
public class UIContentDisplay extends UIExoCommand {

	private Content content_;
	private PublishService service_;

	public UIContentDisplay(PublishService service) throws Exception {
		setRendererType("ContentDisplayRenderer");
		setId("UIContentDisplay");
		//setClazz("UIContentDisplay");
		service_ = service;
		addActionListener(BackActionListener.class, "back");
	}

	public Content getContent() {
		return content_;
	}

	public void setUIContentDisplayData(String contentId) throws Exception {
		content_ = service_.findContentById(contentId);
	}


	static public class BackActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIContentDisplay uiContentDisplay =
				(UIContentDisplay) event.getComponent();
			UIContentsReaderPortlet uiContentsReaderPortlet =
				(UIContentsReaderPortlet) uiContentDisplay.getParent();
			uiContentsReaderPortlet.undo();
		}
	}
	public String getFamily() {
		return "org.exoplatform.portlets.publish.component.UIContentDisplay";
	}
}