/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.publish.component;

import java.util.ArrayList;
import java.util.List;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.publish.component.model.ContentConfig;

import org.exoplatform.services.publish.PublishService;
import org.exoplatform.services.publish.model.Section;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UIAccount.java,v 1.9 2004/10/23 01:58:56 tuan08 Exp $
 */
public class UIContentTitlesBlock extends UIExoCommand {

	public final static String READ_CONTENT_ACTION = "readContent";
	public final static String FULL_CONTENTS_ACTION = "fullContents";

	public final static String CONTENT_ID = "contentId";
	public final static String SECTION_ID = "sectionId";

	private PublishService service_;
	private ContentConfig contentConfig_;
	private List titles_;
	private Section selectSection_;
	//private SectionACL acl_ ;   

	public UIContentTitlesBlock(
		PublishService service,
		ContentConfig contentConfig) {
		setId("UIContentTitlesBlock");
		//setClazz("UIContentTitlesBlock");
		setRendererType("ContentTitlesBlockRenderer");

		service_ = service;
		contentConfig_ = contentConfig;
        titles_ = new ArrayList();

		addActionListener(ReadContentActionListener.class, READ_CONTENT_ACTION);
		addActionListener(
			FullContentsActionListener.class,
			FULL_CONTENTS_ACTION);
			//refresh();	

	}

	public List getBlockTitles() {
		refresh();
		return titles_;

	}
	
	public String getBlockTitle() {
		
		return contentConfig_.getTitle();

	}

	public String getSectionId() {
		return contentConfig_.getUri();
	}

	void refresh() {

		try {
			titles_ =
				service_.findContentsBySectionAndNumber(
					contentConfig_.getUri(),
					Integer.parseInt(contentConfig_.getItemtoshow()));
		//System.out.println("fdfdfddfdfdfdf444"+contentConfig_.getUri()+contentConfig_.getItemtoshow());
		//System.out.println(titles_.get(0).toString());
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	static public class ReadContentActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			String contentId = event.getParameter(CONTENT_ID);
			UIContentTitlesBlock uiContentTitlesBlock =
				(UIContentTitlesBlock) event.getSource();
			UIContentTitlesBlocks uiContentTitlesBlocks =
				(UIContentTitlesBlocks) uiContentTitlesBlock.getParent();
			UIContentDisplay uiContentDisplay =
				(UIContentDisplay) uiContentTitlesBlocks.getSibling(
					UIContentDisplay.class);
			uiContentDisplay.setUIContentDisplayData(contentId);
			uiContentTitlesBlocks.setRenderedSibling(UIContentDisplay.class);
			
						UIContentsReaderPortlet uiContentsReaderPortlet =
				(UIContentsReaderPortlet) uiContentTitlesBlocks.getParent();
			uiContentsReaderPortlet.addHistoryElement(uiContentTitlesBlocks);
		}
	}

	static public class FullContentsActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIContentTitlesBlock uiContentTitlesBlock =
				(UIContentTitlesBlock) event.getSource();
			String sectionId = event.getParameter(SECTION_ID);
			UIContentTitlesBlocks uiContentTitlesBlocks =
				(UIContentTitlesBlocks) uiContentTitlesBlock.getParent();
			UIContentTitles uiContentTitles =
				(UIContentTitles) uiContentTitlesBlocks.getSibling(
					UIContentTitles.class);
			uiContentTitles.setUIContentTitlesData(sectionId);
			uiContentTitlesBlocks.setRenderedSibling(UIContentTitles.class);
			
			UIContentsReaderPortlet uiContentsReaderPortlet =
				(UIContentsReaderPortlet) uiContentTitlesBlocks.getParent();
			uiContentsReaderPortlet.addHistoryElement(uiContentTitlesBlocks);
		}
	}

	public String getFamily() {
		return "org.exoplatform.portlets.publish.component.UIContentTitlesBlock";
	}
}