/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.publish.renderer.html;

import java.io.IOException;
import java.util.*;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.publish.component.UIContentExplorer;
import org.exoplatform.services.publish.model.Section;
import org.exoplatform.services.publish.model.Content;
/**
 * @email:   danny_xcz@163.com
 * @version: $Id: ContentExplorerRenderer.java,v 1.12 2004/10/22 14:23:31 tuan08 Exp $
 */
public class ContentExplorerRenderer extends HtmlBasicRenderer {

	private static Parameter[] CONFIG_SECTION =
		{ new Parameter(ACTION, "configSection")};
	private static Parameter[] EXIT_CONFIG_SECTION =
		{ new Parameter(ACTION, "exitConfigSection")};

	private static Parameter CHANGE_SECTION =
		new Parameter(ACTION, "changeSection");
	private static Parameter[] ADD_SECTION =
		{ new Parameter(ACTION, "addSection")};

	private static Parameter SEARCH = new Parameter(ACTION, "search");

	final public void encodeBegin(FacesContext context, UIComponent component)
		throws IOException {
		ResourceBundle res =
			getApplicationResourceBundle(context.getExternalContext());
		ResponseWriter w = context.getResponseWriter();
		UIContentExplorer uiExplorer = (UIContentExplorer) component;
		Collection childrenSection = uiExplorer.getChildrenSection();
		Section currentSection = uiExplorer.getCurrentSection();
		Section parentSection = uiExplorer.getParentSection();
		String groupName = "ROOT";
		if (currentSection != null)
			groupName = currentSection.getName();
		Object[] args = { groupName };
		//The head line
		w.write("<table class='UIContentExplorer'>");
		w.write("<tr>");
		w.write("<th class='header' colspan='2'>");
		w.write(
			ft_.format(res.getString("UIContentExplorer.label.section"), args));
			

		w.write("</th>");
		w.write("</tr>");
		//The middle line
		w.write("<tr>");
		w.write("<td class='tree'>");
		
		if (uiExplorer.getConfigState() == 0) {
			linkRenderer_.render(
				w,
				uiExplorer,
				res.getString("UIContentExplorer.button.config-section"),
				CONFIG_SECTION);
		} else if (uiExplorer.getConfigState() == 1) {
			linkRenderer_.render(
				w,
				uiExplorer,
				res.getString("UIContentExplorer.button.exit-config-section"),
				EXIT_CONFIG_SECTION);
		}
		
		
		if (uiExplorer.getConfigState() == 0) {
			addSectionTreeTable(
				parentSection,
				childrenSection,
				w,
				res,
				uiExplorer);
		} else if (uiExplorer.getConfigState() == 1) {
			addConfigSectionTreeTable(
				parentSection,
				childrenSection,
				w,
				res,
				uiExplorer);
		}
		w.write("</td>");
		w.write("<td>");
	   // if(currentSection!=null){
	    
		renderChildren(context, uiExplorer);
		//}
		//else {
		//	w.write("no section selected!");
		//}
		w.write("</td>");
		w.write("</tr>");
		//The bottom line
		w.write("<tr>");
		w.write("<td colspan='2' class='footer'>");
		//String parentSectionId = "" ;
		//if (currentSection != null) parentSectionId = currentSection.getId() ;
		// Parameter groupParam = new Parameter(UIContentExplorer.SECTION_ID, parentSectionId) ;
		//w.write("search");

		w.write("</td>");
		w.write("</tr>");

		w.write("</table>");
	}

	private void addSectionTreeTable(
		Section parentSection,
		Collection childrenSection,
		ResponseWriter w,
		ResourceBundle res,
		UIContentExplorer uiContentExplorer)
		throws IOException {
		Parameter sectionIdParam =
			new Parameter(UIContentExplorer.SECTION_ID, "");
		Parameter[] changeSectionParams = { CHANGE_SECTION, sectionIdParam };

		Iterator i = childrenSection.iterator();
		String parentSectionId = "";
		if (parentSection != null){
			parentSectionId = parentSection.getId();
		}else {
		    parentSectionId = "/";
		}
		String groupIcon = res.getString("UIContentExplorer.img.section-icon");
		w.write("<table>");
		w.write("<tr>");
		w.write("<td>");
		sectionIdParam.setValue(parentSectionId);
		uiContentExplorer.appendLink(w, "[..]", changeSectionParams, "");
		w.write("</td>");
		w.write("</tr>");
		while (i.hasNext()) {
			Section section = (Section) i.next();
			w.write("<tr>");
			w.write("<td style='padding-left: 10px'>");
			w.write(groupIcon);
			sectionIdParam.setValue(section.getId());
			uiContentExplorer.appendLink(
				w,
				section.getName(),
				changeSectionParams,
				"");
			w.write("</td>");
			w.write("</tr>");
		}
		w.write("</table>");

	}

	private void addConfigSectionTreeTable(
		Section parentSection,
		Collection childrenSection,
		ResponseWriter w,
		ResourceBundle res,
		UIContentExplorer uiContentExplorer)
		throws IOException {
		Parameter sectionIdParam =
			new Parameter(UIContentExplorer.SECTION_ID, "");
		Parameter[] changeSectionParams = { CHANGE_SECTION, sectionIdParam };

		Iterator i = childrenSection.iterator();
		String parentSectionId = "";
		if (parentSection != null)
			parentSectionId = parentSection.getId();
		String groupIcon = res.getString("UIContentExplorer.img.section-icon");
		w.write("<table>");
		w.write("<tr>");
		w.write("<td>");
		sectionIdParam.setValue(parentSectionId);
		uiContentExplorer.appendLink(w, "[..]", changeSectionParams, "");
		w.write("</td>");
		w.write("</tr>");
		while (i.hasNext()) {
			Section section = (Section) i.next();
			w.write("<tr>");
			w.write("<td style='padding-left: 10px'>");
			w.write(groupIcon);
			sectionIdParam.setValue(section.getId());
			uiContentExplorer.appendLink(
				w,
				section.getName(),
				changeSectionParams,
				"");
			w.write("</td>");
			w.write("</tr>");
		}
		w.write("<tr>");
		w.write("<td>");
		linkRenderer_.render(
			w,
			uiContentExplorer,
			res.getString("UIContentExplorer.button.add-section"),
			ADD_SECTION);
		w.write("</td>");
		w.write("</tr>");
		w.write("</table>");

	}

}