/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.ria;

import java.net.URL;
import java.util.ResourceBundle;
import java.util.Map;
import java.util.WeakHashMap ;

import javax.swing.ImageIcon;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Jul 3, 2005
 */
public class ResourceManager {
  static private ResourceBundle res_ = ResourceBundle.getBundle("resources.resources") ;
  static private Map<String, ImageIcon>  icons_ = new WeakHashMap<String, ImageIcon>() ;
  
  static public String getString(String key) { return res_.getString(key) ; }
  
  static public ImageIcon getIcon(String key) {
    String value = res_.getString(key) ;
    ImageIcon icon = icons_.get(value) ;
    if(icon == null) {
      URL url = Thread.currentThread().getContextClassLoader().getResource(value) ;
      icon = new ImageIcon(url) ;
      icons_.put(value, icon) ;
    }
    return icon ;
  }
}