/**
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.bookmark;

import org.exoplatform.services.bookmark.model.*;
import java.util.*;
import org.exoplatform.commons.utils.PageList;
/**
 * Created by The eXo Platform SARL
 * Author : Daniel Summer
 *          danny_xcz@users.sourceforge.net
 * Date: Nov 29, 2004
 * Time: 3:22:54 PM
 */
public interface BookmarkService {
	public Bookmark createBookmarkInstance();
	public Bookmark createBookmark(BookmarkCategory category,Bookmark bookmark) throws Exception;
	public void updateBookmark(Bookmark bookmark) throws Exception;
	public Bookmark removeBookmark(String bookmarkId) throws Exception;
	

	public Bookmark findBookmarkById(String bookmarkId) throws Exception;
	//public Bookmark findBookmarkByAuthor(String userName) throws Exception;
	//public PageList findBookmarksByAuthor(String userName) throws Exception;
	
	public PageList findBookmarksByBookmarkCategory(String categoryId) throws Exception;
	public List findBookmarksByBookmarkCategoryAndNumber(String categoryId,int num) throws Exception;
	
	public BookmarkCategory createBookmarkCategoryInstance();
	public BookmarkCategory createBookmarkCategory(BookmarkCategory category) throws Exception ;
	public BookmarkCategory addChild(BookmarkCategory parent, BookmarkCategory child) throws Exception;
	public void updateBookmarkCategory(BookmarkCategory category) throws Exception ;
	public BookmarkCategory removeBookmarkCategory(BookmarkCategory category) throws Exception ;
	public BookmarkCategory findBookmarkCategoryById(String categoryId) throws Exception ;
	public Collection findBookmarkCategorysByParent(BookmarkCategory parent) throws Exception ;

}
