/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.css.sac.impl;

import org.apache.commons.logging.Log;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.css.sac.ParserImpl;
import org.exoplatform.services.css.sac.SacService;
import org.exoplatform.services.log.LogService;
import org.w3c.css.sac.Parser;
import org.w3c.css.sac.helpers.ParserFactory;



/**
 * @author Ove Ranheim (oranheim@yahoo.no)
 * @since Jun 29, 2004 5:51:26 PM
 */
public class SacServiceImpl implements SacService {
    
    private Log _log;
    
    public SacServiceImpl() {
        LogService logservice = (LogService) PortalContainer.getInstance().getComponentInstanceOfType(LogService.class);
        _log = (Log) logservice.getLog("org.exoplatform.services.css.sac.impl");
        System.setProperty("org.w3c.css.sac.parser", ParserImpl.class.getName());
    }
    
    public Parser makeParser() {
        ParserFactory factory = new ParserFactory();
        try {            
            return factory.makeParser();
        } catch(ClassNotFoundException cnfe) {
            _log.error(cnfe.getMessage());
        } catch(IllegalAccessException iae) {
            _log.error(iae.getMessage());
        } catch(InstantiationException ie) {
            _log.error(ie.getMessage());
        }
        return null;
    }

}
