/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.css.test;

import java.io.InputStream;
import java.net.URL;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.css.sac.SacService;
import org.exoplatform.test.BasicTestCase;
import org.w3c.css.sac.InputSource;
import org.w3c.css.sac.Parser;

/**
 * @author Ove Ranheim (oranheim@yahoo.no)
 * @since Jun 29, 2004 5:41:13 PM
 */
public class TestSacService extends BasicTestCase {

    static protected SacService _service;

    public TestSacService(String name) {
        super(name);
    }

    public void setUp() throws Exception {
        if (_service == null) {
            PortalContainer manager = PortalContainer.getInstance();
            _service = (SacService) manager.getComponentInstanceOfType(SacService.class);
        }
    }

    public void tearDown() throws Exception {
    }
    

    public void testService() throws Exception {
        InputSource source = new InputSource();
        
        URL uri = new URL("file:./src/test/org/exoplatform/services/css/test/test-portlet.css");
        InputStream stream = uri.openStream();
        
        source.setURI(uri.toString());
        source.setByteStream(stream);
        
        Parser sac = _service.makeParser();
        sac.setDocumentHandler( new DemoDocumentHandler() );
        sac.parseStyleSheet(source);
        
        stream.close();
    }

    protected String getDescription() {
        return "Test SAC service";
    }
}
