/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.grammar.bbcode.impl;

import java.util.* ;
import org.exoplatform.services.grammar.*;
import org.exoplatform.services.grammar.bbcode.BBCodeAnalyzerService;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Oct 19, 2004
 * @version $Id: BBCodeAnalyzerServiceImpl.java,v 1.1 2004/10/20 14:17:26 tuan08 Exp $
 */
public class BBCodeAnalyzerServiceImpl implements BBCodeAnalyzerService {
  private ThreadLocal threadLocal_ ;
  private HashMap tokenHandlers_ ;
  
  public BBCodeAnalyzerServiceImpl() {
    tokenHandlers_ = new HashMap() ;
    threadLocal_ = new ThreadLocal() ;
    tokenHandlers_.put("bbcode.text" ,new DefaultTokenHandler()) ;
    tokenHandlers_.put("bbcode.code" ,new TagAppenderTokenHandler("<code>","</code>")) ;
    tokenHandlers_.put("bbcode.img" ,new TagAppenderTokenHandler("<img src='","' alt='image'/>")) ;
    tokenHandlers_.put("bbcode.smiley" ,new SmileyTokenHandler()) ;
  }
  
  public Analyzer getAnalyzer()  {
    Analyzer analyzer = (Analyzer) threadLocal_.get() ;
    if(analyzer == null) {
      analyzer = new BBCodeAnalyzerImpl() ;
      Iterator i = tokenHandlers_.entrySet().iterator() ;
      try {
        while(i.hasNext()) {
          Map.Entry entry = (Map.Entry) i.next() ;
          String name = (String) entry.getKey() ;
          TokenHandler handler = (TokenHandler) entry.getValue() ;
          analyzer.registerTokenHandler(name, handler) ;
        }
      } catch (Exception ex) {
        ex.printStackTrace() ;
        return null ;
      }
      threadLocal_.set(analyzer) ;
    }
    return analyzer ;
  }
  
  synchronized public void registerTokenHandler(String name, TokenHandler handler)  {
  
  }
}
