/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.rdf.jena.tutorial;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import org.exoplatform.services.rdf.model.RDFModelService;
import org.exoplatform.services.rdf.model.RDFModelServiceImpl;

import junit.framework.TestCase;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 12:59:40
 */
public class JenaTestCase extends TestCase {

    protected RDFModelService _modelservice;
    
    public JenaTestCase(String name) {
        super(name);
    }
    
    public void setUp() throws Exception {        
        if (_modelservice == null) {
            _modelservice = new RDFModelServiceImpl();
        }
    }
    
    protected InputStream getRDFResource(String filename) {
        File file = new File("src/test/data/"+filename);
        InputStream is = null;
        try {
            is = new FileInputStream(file);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            fail();
        }
        return is;
    }

}


