/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * (c) Copyright 2003, 2004, Hewlett-Packard Development Company, LP All rights reserved.
 * Please look at license.txt and license_hp in info directory for more license detail.
 **/
package org.exoplatform.services.rdf.jena.tutorial;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.vocabulary.VCARD;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 12:59:40
 */

public class TestTutorial01 extends JenaTestCase {

    // some definitions
    static String personURI = "http://somewhere/JohnSmith";
    static String fullName = "John Smith";

    public TestTutorial01(String name) {
        super(name);
    }

    public void testSimpleModel() {
        // create an empty model
        Model model = _modelservice.createDefaultModel();
        assertNotNull(model);

        // create the resource
        Resource johnSmith = model.createResource(personURI);
        assertEquals(personURI, johnSmith.getURI());

        // add the property
        johnSmith.addProperty(VCARD.FN, fullName);
        assertEquals(fullName, johnSmith.getProperty(VCARD.FN).getObject().toString());
    }
}

