/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * (c) Copyright 2003, 2004, Hewlett-Packard Development Company, LP All rights reserved.
 * Please look at license.txt and license_hp in info directory for more license detail.
 **/

package org.exoplatform.services.rdf.jena.tutorial;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.vocabulary.VCARD;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 12:59:40
 */
public class TestTutorial02 extends JenaTestCase {

    public TestTutorial02(String name) {
        super(name);
    }

    public void testResourcesAsPropertyValues() {
        // some definitions
        String personURI = "http://somewhere/JohnSmith";
        String givenName = "John";
        String familyName = "Smith";
        String fullName = givenName + " " + familyName;

        // create an empty model
        Model model = _modelservice.createDefaultModel();
        assertNotNull(model);

        // create the resource
        //   and add the properties cascading style
        Resource johnSmith = model.createResource(personURI).addProperty(VCARD.FN, fullName).addProperty(VCARD.N,
                model.createResource().addProperty(VCARD.Given, givenName).addProperty(VCARD.Family, familyName));

        assertEquals(fullName, johnSmith.getProperty(VCARD.FN).getObject().toString());
        
        Statement stmt = johnSmith.getProperty(VCARD.N);
        assertNotNull(stmt);
        
        assertEquals(givenName, stmt.getProperty(VCARD.Given).getObject().toString());
        assertEquals(familyName, stmt.getProperty(VCARD.Family).getObject().toString());

    }
}