/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * (c) Copyright 2003, 2004, Hewlett-Packard Development Company, LP All rights reserved.
 * Please look at license.txt and license_hp in info directory for more license detail.
 **/


package org.exoplatform.services.rdf.jena.tutorial;

import java.io.InputStream;
import java.io.InputStreamReader;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ResIterator;
import com.hp.hpl.jena.vocabulary.VCARD;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 12:59:40
 */
public class TestTutorial07 extends JenaTestCase {

    static final String inputFileName = "vc-db-1.rdf";

    public TestTutorial07(String name) {
        super(name);
    }
    
    public void testSelectingTheVCardResources() {
        // create an empty model
        Model model = _modelservice.createDefaultModel();

        // use the class loader to find the input file
        InputStream in = getRDFResource(inputFileName);
        if (in == null) { throw new IllegalArgumentException("File: " + inputFileName + " not found"); }

        // read the RDF/XML file
        model.read(new InputStreamReader(in), "");

        // select all the resources with a VCARD.FN property
        ResIterator iter = model.listSubjectsWithProperty(VCARD.FN);
        assertNotNull(iter);
        
        if (iter.hasNext()) {
            System.out.println("The database contains vcards for:");
            while (iter.hasNext()) {
                System.out.println("  " + iter.nextResource().getRequiredProperty(VCARD.FN).getString());
            }
        } else {
            System.out.println("No vcards were found in the database");
        }
        
        assertTrue(true);
    }
}
