/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * (c) Copyright 2003, 2004, Hewlett-Packard Development Company, LP All rights reserved.
 * Please look at license.txt and license_hp in info directory for more license detail.
 **/


package org.exoplatform.services.rdf.jena.tutorial;

import java.io.InputStream;
import java.io.InputStreamReader;

import com.hp.hpl.jena.rdf.model.Model;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 12:59:40
 */
public class TestTutorial09 extends JenaTestCase {

    static final String inputFileName1 = "vc-db-3.rdf";
    static final String inputFileName2 = "vc-db-4.rdf";

    public TestTutorial09(String name) {
        super(name);
    }
    
    public void testDemonstrateGraphOperations() {
        // create an empty model
        Model model1 = _modelservice.createDefaultModel();
        Model model2 = _modelservice.createDefaultModel();

        // use the class loader to find the input file
        InputStream in1 = getRDFResource(inputFileName1);
        if (in1 == null) { throw new IllegalArgumentException("File: " + inputFileName1 + " not found"); }
        InputStream in2 = getRDFResource(inputFileName2);
        if (in2 == null) { throw new IllegalArgumentException("File: " + inputFileName2 + " not found"); }

        // read the RDF/XML files
        model1.read(new InputStreamReader(in1), "");
        model2.read(new InputStreamReader(in2), "");

        // merge the graphs
        Model model = model1.union(model2);
        assertNotNull(model);

        // print the graph as RDF/XML
        model.write(System.out, "RDF/XML-ABBREV");
        System.out.println();
    }
}
