/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.crawler;

import java.util.prefs.Preferences;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.impl.core.io.local.LoadCollection;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 10, 2005
 */
public class AgentConfigStore {
  
  protected String [] names ;
  protected int index;  
  protected Agent agent;
  
  public AgentConfigStore(){   
    try{
      init();
      if( AgentConfig.SAVE_ORDER){
        Preferences prefs = Preferences.userNodeForPackage( this.getClass() );
        String old = prefs.get( "index", "");
        if( old != null && !old.trim().equals(""))        
          index = Integer.parseInt(  old);
        if( index >= this.names.length ) index = 0;
      }
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }

  protected void init() throws Exception {    
    LoadCollection load = new LoadCollection();
    this.names = load.getAllAgent( null);    
    if( this.names == null || this.names.length < 1) return;
    if(index >= this.names.length) index = 0; 
  }
  
  protected Agent get() throws Exception {  
    if( this.names == null ) init();     
    if( index >= this.names.length)  init();    
    if( this.names.length < 1) return null;    
    Agent a = (new LoadCollection()).getAgent( this.names[index]);
    if( AgentConfig.SAVE_ORDER){
      Preferences prefs = Preferences.userNodeForPackage( this.getClass() );
      prefs.put("index", String.valueOf( index));
    }    
    AgentConfig.CURRENT_THREAD = index;
    index++;  
//    if( index >= this.names.length) AgentConfig.SLEEP = 900000;
    return a;  
  }
  
  public void set( int index){
    this.index = index;
  }
  
}
