/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.crawler;

import java.util.List;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.impl.core.io.net.UrlCreation;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 14, 2005
 */
public class AgentStore {
  
  private AgentLinkStore [] collection;  
  private int level = 0; 
  private Agent agent; 
  private boolean add = false;
 
  public void init( Agent a){
     this.agent = a;
     collection = new AgentLinkStore[ agent.getDepth()+1];
    
    for( int i=0; i< collection.length; i++)
      collection[i] = new AgentLinkStore();    
    
    level = 0;   
    add = false;
  }
  
  public void add(List<String> link, int l, String address, 
        UrlCreation creation, AgentChecker checker, String pattern, boolean bound){
    if( l>= collection.length) return;    
    collection[l].add( link, address, creation, checker , pattern, bound);
    if( link.size() > 0) add = true;
  }
  
  public boolean end(){
    if( this.agent == null) return false;
    if( level < (this.agent.getDepth()+1)) return false;
    for( AgentLinkStore ele : collection)
      if( ele.size() > 0 ) return false;    
    return true;
  }
  
  public boolean begin(){
    return !add;
  }
  
  public Agent get(){
    if( add && collection[ level].size() < 1)
      level++;
    if( level >= collection.length) return null;
    return collection[ level].get( agent, level);
  }
 

}
