package org.vietspider.veis.impl.core.crawler;

import java.net.URL;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.api.core.agent.AgentManager;
import org.vietspider.veis.impl.core.io.local.LogData;
import org.vietspider.veis.impl.core.text.html.Document;

public class AgentThread extends Thread{
  
  private boolean busy;
  private AgentManager manager;
  private Agent agent;
  private Document doc;  
  private String path;	
  
  int id = -1;
  int time = 0;

  public AgentThread(AgentManager s, int id) {
    this.manager = s;
    this.id = id;   
    busy  = false;     
    this.start();   
  }
  
  public void run(){
    while (true){
      try{ 	
        if( !busy) step_1(); 
        time++;        
        if( time >= 100) busy= false;
        sleep(500);
      }catch(Exception exp){  
        step_5();
        new LogData( exp.getStackTrace());        
      }
    }
  }
  
  private void step_1() throws Exception{    
    time = 0;
    this.agent = this.manager.get();
    if( agent == null) return;
    busy = true;
    this.manager.setStatus( agent.getUrl(), id);  
    step_2();
    
  }
  private void step_2() throws Exception{
//    System.out.println("buoc 2 "+ agent.getUrl()); 
    byte[] objs = this.manager.getConnection().loadContent( agent.getUrl());       
    if( objs != null && objs.length > 0){     
      doc = new Document( objs, agent.getCharset());   
    } else {      
      step_5();
      return;
    }  
    //doc = new HtmlDocumentImpl( new URL( agent.getUrl()), agent.getCharset());        
    if( agent.getLevel() <= agent.getDepth()) {		
      this.manager.add( this.manager.getDocumentProcessor().getLink(doc.getTag()),
          agent.getLevel()+1, agent.getUrl(), agent.getName(), agent.getDomain());       
    }   
    step_3();    
  }	
  private void step_3() throws Exception{    
    if( this.manager.getChecker().isUrl( agent.getUrl(), true) ){     
      step_5();
      return;      
    } else if  ( this.manager.getChecker().isNotPart( agent.getPattern(), agent.getUrl())){        
        step_5();
        return;
   }  
   doc = this.manager.getNodeProcessor().getDocument( doc, agent.getAdd());//, agent.getRemove()); 
   if( this.manager.getRemover() != null)
     doc = this.manager.getRemover().remove( doc);
   step_4();
      
  }	
  private void step_4() throws Exception{    
    if( this.manager.getChecker().isTitle( 
        this.manager.getDocumentProcessor().getTitle( doc.getTag()), true)){
      step_5();
//      System.out.println("link da duoc download ");
      return;
    } 
    URL home = new URL( agent.getHome());
    String address = this.manager.getCreation().createURL(
        home.getHost(), home.getPort(), home.getProtocol(), agent.getUrl());
    path = this.manager.getDocumentProcessor().loadResource(
        doc.getTag(), agent, this.manager.getConnection(), this.manager.getCreation());    
    String content = this.manager.getNodeProcessor().getText( doc.getTag()).toString();
    if( AgentConfig.REMOVE_SCRIPT)   
      content = this.manager.getDocumentProcessor().removeScript( content);    
    content = "<!--"+address+"-->"
    + "\n<meta http-equiv=\"content-type\" content=\"text/html; charset=\"utf-8\">\n"+content;
    this.manager.getBuffer().saveByte( path+".htm",content.getBytes( "utf-8"));
    //System.out.println(doc.getBlock( null).getValue().toString());
    step_5();
  }	
  private void step_5() {   
    agent = null;
    busy = false;		
    //time = System.currentTimeMillis() - time;    
    //System.out.println( (time)+",");    
  }
  
}
