package org.vietspider.veis.impl.core.io.base;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;


/**
 * @author thuannd
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DataBuffer {
  
  public synchronized byte[] loadByte( String path) throws Exception {
    File file = new File( path);       
    return loadByte( file );
  }	
  
  public synchronized byte[] loadByte( File file ) throws Exception {
    if ( ! file.exists() || !file.isFile()) file.createNewFile();        
    FileInputStream input = new FileInputStream(file);
    FileChannel fchan = input.getChannel();
    long fsize = fchan.size();       
    ByteBuffer buff = ByteBuffer.allocate((int)fsize);        
    fchan.read(buff);
    buff.rewind();      
    byte[] data = buff.array();      
    buff.clear();      
    fchan.close();        
    input.close();       
    return data;
  }
  
  public synchronized  void saveByte( String path, byte[] d ) throws Exception { 
    File file = new File( path);
    saveByte( file, d);
  }
  
  public synchronized  void saveByte( File file, byte[] d ) throws Exception {
    if( file.isDirectory()) return;   
    if (file.exists()) file.delete();         
    if (!file.exists()) file.createNewFile();       
    
    FileOutputStream fout = new FileOutputStream( file);
    FileChannel fchan = fout.getChannel();      
    ByteBuffer buff = ByteBuffer.allocateDirect( d.length);        
    for(int i=0; i<d.length; i++){
      buff.put(d[i]);
    }        
    buff.rewind();
    fchan.write(buff);        
    buff.clear();        
    fchan.close();
    fout.close();      
  }   
}
