package org.vietspider.veis.impl.core.io.local;

import java.io.File;
import java.util.Properties;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.impl.core.agent.AgentImpl;
import org.vietspider.veis.impl.core.io.base.IOProperties;

public class AgentProperties extends IOProperties {
  
  protected void set( Agent agent, String path) throws Exception {
    Properties  p = new Properties();
    p.put("name", agent.getName());
    p.put("pattern", agent.getPattern());
    p.put("home", agent.getHome());    
    p.put("domain", agent.getDomain());
    p.put("depth", String.valueOf(agent.getDepth()));       
    String text = "";
    String [] array = agent.getAdd();
    for( int i=0; i< array.length; i++){
      text += array[i]+" ";
    }
    p.put("add", text);          
    text = "";
    array = agent.getRemove();
    for( int i=0; i<array.length; i++){
      text += array[i]+" ";
    }
    p.put("remove", text);
    if( agent.getCharset() == null) 
      p.put("charset", "");
    else
      p.put("charset", agent.getCharset());        
    super.save( path, p);
  }
  protected Agent get( String path) throws Exception {
    File f = new File( path);    
    if( !f.exists()) return null;
    Properties p = super.load( f);    
    if( (p.getProperty("name") == null) 
        && (p.getProperty("home") == null)  
        && (p.getProperty("pattern") == null)){
      f.delete();
      return null;
    }
    Agent agent = new AgentImpl();
    agent.setName( p.getProperty("name"));    
    agent.setPattern( p.getProperty("pattern"));
    agent.setHome( p.getProperty("home"));
    agent.setUrl( p.getProperty("home"));   
    agent.setDomain( p.getProperty("domain"));		
    agent.setDepth(Integer.parseInt(p.getProperty("depth")));
    agent.setLevel(0);
    
    agent.setAdd( p.getProperty("add").trim().split(" "));	         
    agent.setRemove( p.getProperty("remove").split(" "));
    if( !p.getProperty("charset").trim().equals(""))
      agent.setCharset( p.getProperty("charset").trim());
    return agent;
  }
}
