/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.io.local;

import java.io.File;
import java.io.RandomAccessFile;
import java.util.Calendar;
import java.util.Locale;

import org.vietspider.veis.impl.core.io.base.UtilFile;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 26, 2005
 */
public class LogData {
  
  public LogData( StackTraceElement[] traces ) {
    try{
      UtilFile utils = new UtilFile();   
      String path = utils.getFolder("data.log");     
      
      File [] files = utils.list( path, null); 
      
      for( int i=5; i< files.length; i++)
        files[i].delete();
      
      Calendar cal=Calendar.getInstance(Locale.FRANCE);
      path = path + File.separator + String.valueOf(cal.get(Calendar.YEAR))+"_"
            + String.valueOf(cal.get(Calendar.MONTH)+1)+"_"+ String.valueOf(cal.get(Calendar.DATE));   
      File file = new File( path);         
      if( !file.exists()) file.createNewFile();
      
      StringBuilder text = new StringBuilder();
      for( StackTraceElement ele : traces){
        text.append("\n");
        text.append( ele.toString());
      }
      text.append("\n");
      
      RandomAccessFile current = new RandomAccessFile( file, "rw");
      current.seek( current.length());      
      current.writeUTF( text.toString());
      current.close();      
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  
}
