/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.core.io.local;

import java.io.File;
import java.io.FileInputStream;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.vietspider.veis.impl.core.text.codec.VietnameseConverter;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 4, 2005
 */
public class SearchData {
  
  public List<File> search( String string, List<File> list) throws Exception {
    VietnameseConverter convert = new VietnameseConverter();
    String[] text = convert.convert( string);
    Pattern [] pattern = new Pattern[ text.length];
    for( int i=0; i<pattern.length; i++)
      pattern[i] = Pattern.compile( text[i], Pattern.CASE_INSENSITIVE); 
    List<File> result = new ArrayList<File>();
    for( File ele: list){
      for( Pattern p : pattern){
        if( this.find( p, ele)){
          result.add( ele);
          break;
        }
      }
    }
    return result;
  }
  
  private boolean find( Pattern pattern, File file) throws Exception {  
    Charset charset = Charset.forName("utf-8");   
    FileInputStream stream = new FileInputStream(file);
    FileChannel f = stream.getChannel();
    ByteBuffer bytes = f.map(FileChannel.MapMode.READ_ONLY, 0, f.size( ));
    CharBuffer chars = charset.decode(bytes);   
    Matcher matcher = pattern.matcher(chars);
    boolean result = matcher.find(); 
    chars.clear();
    bytes.clear();  
    f.close();
    stream.close();
    return result;
  } 
}
