/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.io.net;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Properties;

import org.vietspider.veis.api.net.NetConnection;
import org.vietspider.veis.impl.core.io.local.ProxyProperties;
import org.vietspider.veis.impl.core.text.codec.CharacterEncoder;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 14, 2005
 */
public class HttpConnectionImpl implements NetConnection { 
  
  private String user = null;

  public HttpConnectionImpl() throws Exception {   
    Properties proxy = (new ProxyProperties()).get();
    if( proxy.getProperty("ProxyHost") != null)
        System.setProperty("http.proxyHost", proxy.getProperty("ProxyHost"));
    if( proxy.getProperty("ProxyPort") != null)
       System.setProperty("http.proxyPort", proxy.getProperty("ProxyPort"));
    if( proxy.getProperty("ProxyUser") != null && proxy.getProperty("ProxyPass") != null) {
        this.user = proxy.getProperty("ProxyLogin") + ":";
        this.user = (new CharacterEncoder()).encodeBuffer( 
              this.user.getBytes())+ proxy.getProperty("ProxyPass");
    }else
      this.user = null;        
  }
  
  public byte[] loadContent(String link) throws Exception {   
    URL url = new URL( link);
    HttpURLConnection http = (HttpURLConnection) url.openConnection();
    if( user != null)
        http.setRequestProperty("Proxy-Authorization", "Basic " + user);    
    http.connect();
    InputStream in = http.getInputStream();
    BufferedInputStream input = new BufferedInputStream(in);
    ByteArrayOutputStream output = new ByteArrayOutputStream();
    byte b[] = new byte[1024];
    int read = 0;
    while ((read = input.read(b)) > -1){
      output.write(b, 0, read);
    }
    in.close();
    input.close();
    http.disconnect();
    b  = output.toByteArray();
    output.flush();
    output.close();
    return b;
  }
  public String loadResource( String link, String path) throws Exception {
    URL url = new URL( link);
    HttpURLConnection http = (HttpURLConnection) url.openConnection();
    if( user != null)
        http.setRequestProperty("Proxy-Authorization", "Basic " + user);    
    http.connect();
    InputStream in = http.getInputStream();
    BufferedInputStream inputs = new BufferedInputStream(in);
    byte b[] = new byte[4096];
    ByteArrayOutputStream out = new ByteArrayOutputStream();
    int read = 0;
    while ((read = inputs.read(b)) > 0){
           out.write(b, 0, read);
    }
    OutputStream output = new FileOutputStream(path);
    out.writeTo(output) ;
    output.flush();
    out.flush();
    in.close();
    inputs.close();
    out.close();
    output.close();
    http.disconnect();  
    return link;
  }

}
