/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.io.net;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.net.URL;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JPanel;

import org.jdesktop.jdic.browser.WebBrowser;
import org.jdesktop.jdic.browser.WebBrowserEvent;
import org.jdesktop.jdic.browser.WebBrowserListener;
import org.vietspider.veis.impl.core.io.net.action.DocumentLoadEvent;
import org.vietspider.veis.impl.core.io.net.action.DocumentLoadListener;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 14, 2005
 */
public class UIHttpBrowser {
  
  protected WebBrowser webBrowser;  
  
  private Vector<DocumentLoadListener> listeners;
  protected boolean end = false;

  public UIHttpBrowser() {
     
     JFrame frame = new JFrame("JDIC API Demo - SimpleBrowser");
     webBrowser = new WebBrowser(); 
     
     listeners = new Vector<DocumentLoadListener>();
  
     webBrowser.addWebBrowserListener(
        new WebBrowserListener() {                            
        public void downloadStarted(WebBrowserEvent event) {;}
        public void downloadCompleted(WebBrowserEvent event) {;}
        public void downloadProgress(WebBrowserEvent event) {;}
        public void downloadError(WebBrowserEvent event) {;}
        public void documentCompleted(WebBrowserEvent event) { 
          completedDocument();
        }
        public void titleChange(WebBrowserEvent event) {;}  
        public void statusTextChange(WebBrowserEvent event) {;}        
    });  
    
    JPanel panel = new JPanel();
    panel.setLayout(new BorderLayout());
    panel.setPreferredSize(new Dimension(700, 500));
    panel.add(webBrowser, BorderLayout.CENTER);
    
    frame.getContentPane().add(panel, BorderLayout.CENTER);
    frame.pack();
    frame.setVisible(true);  
  }
  public void setUrl( URL url) throws Exception {
    webBrowser.setURL( url);
  } 
  public String getContent(){
    return this.webBrowser.getContent();
  }
  
//new domain
  public void fireLoadEvent( DocumentLoadEvent e) {
     synchronized(listeners)  {
        for(int i = 0; i < listeners.size(); i++){
        try{
          DocumentLoadListener listener = listeners.get(i);
              listener.completed(e);
         break;
        }catch(Exception exp){                  
        }       
      }
     }
  }
  public void addLoadListener(  DocumentLoadListener listener) {     
    synchronized(listeners) {
      listeners.remove(listener);
      listeners.add(listener);
      }
  }
  public void removeLoadListener(  DocumentLoadListener listener) {
     synchronized(listeners) {
          listeners.remove(listener);
     }
  }
  public void completed (DocumentLoadEvent ev) {           
     fireLoadEvent(ev);     
  } 
  public void completedDocument()  {
    DocumentLoadEvent e = new  DocumentLoadEvent( 
        this.webBrowser.getContent(), this.webBrowser.getURL().toString());
    fireLoadEvent(e);
    end = true;
  } 
 

}
