/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.core.io.net.server;

import java.io.BufferedReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.StringTokenizer;

import org.vietspider.veis.impl.core.io.base.DataBuffer;
import org.vietspider.veis.impl.core.text.html.Document;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;

public class EditorServer extends BaseNetworkServer {
  
  protected int maxRequestLines = 50;
  
  public static int port = 9247;

  public EditorServer( int maxConnections) throws Exception{    
    super( port, maxConnections);    
    exit = false;
    listen();
  } 
  
  public void handleConnection(Socket server) {  
    try{
    BufferedReader in = SocketUtil.getReader(server);    
    PrintWriter out = SocketUtil.getWriter(server);
    String[] inputLines = new String[maxRequestLines];
    int i;
    for (i=0; i<maxRequestLines; i++) {
      inputLines[i] = in.readLine();
      if (inputLines[i] == null) 
        break;
      if (inputLines[i].length() == 0) { 
        if (usingPost(inputLines)) {
          readPostData(inputLines, i, in);
          i = i + 2;
        }
        break;
      }
    }  
    
    out.println("<html><head>"
        +"<META http-equiv=refresh content=\"0; url=JavaScript:history.go(-2)\">"
        +"</head></html>");    
    
    if( inputLines[ i-1].indexOf("veispath=") > -1 && inputLines[ i-1].indexOf("veiseditor=") > -1){
      try{
        String path = inputLines[ i-1].substring(
            inputLines[ i-1].indexOf("veispath=")+9, inputLines[ i-1].indexOf("veiseditor=") - 1);
        String content = inputLines[ i-1].substring( inputLines[ i-1].indexOf("veiseditor=")+11);
        
        content = content.replaceAll("text/html; charset=", "text/html; charset=utf-8");
        Document doc = new Document( content);
        content = (new NodeProcessor()).getText( doc.getTag()).toString();
        DataBuffer buffer = new DataBuffer();
        buffer.saveByte( path, content.getBytes("utf-8"));
      }catch( Exception exp){
        exp.printStackTrace();
      }
    }
    in.close();
    out.close();
    server.close();
    
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }  
  private boolean usingPost(String[] inputs) {
    return(inputs[0].toUpperCase().startsWith("POST"));
  }

  private void readPostData(String[] inputs, int i, BufferedReader in) throws Exception {    
    int contentLength = contentLength(inputs);
    char[] postData = new char[contentLength];
    in.read(postData, 0, contentLength);
    String temp = new String(postData, 0, contentLength); 
    String [] charsets = {"utf-8","charset-1252","iso-8859-1",
        "iso-8859-13" , "iso-8859-15" , "iso-8859-2" , "iso-8859-3" ,
        "iso-8859-4" , "iso-8859-5" , "iso-8859-6" , "iso-8859-7" ,
        "iso-8859-8" , "iso-8859-9", "us-ascii" , "utf-16" ,
        "windows-1250" , "windows-1251" , "windows-1253" , "windows-1254" ,
        "windows-1255" , "windows-1256" , "windows-1257" , "windows-1258" };
    String strDecode = null;
    for( String ele : charsets){
      strDecode = this.decode( temp, ele);
      if(strDecode != null) break;
    }    
    if( strDecode == null) strDecode="";
    inputs[++i] = strDecode;
  }
  private String decode( String temp, String charset){
    try{
      return java.net.URLDecoder.decode( temp.trim(), charset);
    }catch( Exception exp){
      return null;
    }
  }
    
  private int contentLength(String[] inputs) {
    String input;
    for (int i=0; i<inputs.length; i++) {      
      if (inputs[i].length() == 0)
        break;
      input = inputs[i].toUpperCase();
      if (input.startsWith("CONTENT-LENGTH"))
        return(getLength(input));
    }
    return(0);
  }

  private int getLength(String length) {
    StringTokenizer tok = new StringTokenizer(length);
    tok.nextToken();
    return(Integer.parseInt(tok.nextToken()));
  }
}
