/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.text.html;

import java.io.File;
import java.util.List;

import org.vietspider.veis.impl.core.io.base.DataBuffer;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 18, 2005
 */
public class Document {
  
  private Node node;
  private List<Tag> tag;
  
  public Document( List<Tag> tag) throws Exception {
    this.node = (new NodeParser( tag)).getNode();
    this.tag = tag;   
  }
  
  public Document(String html) throws Exception {   
    DocumentParser  parser = new DocumentParser();
    this.tag = parser.getTag( html);    
    this.node = (new NodeParser( this.tag)).getNode();   
  }
  
  public Document( byte[] data, String charset) throws Exception {
    DocumentParser  parser = new DocumentParser();    
    this.tag = parser.getTag( data, charset);   
    this.node = (new NodeParser( this.tag)).getNode(); 
  }
  public Document( File file, String charset) throws Exception {    
    this( (new DataBuffer()).loadByte( file), charset);
  }  
  
  public Node getNode(){
    return this.node;
  }
  public List<Tag> getTag(){
    return this.tag;
  } 

}
