/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.text.html;

import java.io.File;
import java.net.URL;
import java.util.Calendar;
import java.util.List;
import java.util.Locale;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.impl.core.crawler.AgentConfig;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.net.HttpClientImpl;
import org.vietspider.veis.impl.core.io.net.UrlCreation;
import org.vietspider.veis.impl.core.text.check.TagChecker;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 18, 2005
 */
public class DocumentProcessor extends DocumentBaseProcessor{

//  public void completeAllDocument(List<Tag> tags, String url) throws Exception{
//     TagName tagName = new TagName();
//     replaceValueAttribute(tags, tagName.getTag("frame"), "src", url, 1);
//     replaceValueAttribute(tags, tagName.getTag("iframe"), "src", url, 1);
//     replaceValueAttribute(tags, tagName.getTag("a"), "href", url, 1);   
//     replaceValueAttribute(tags, tagName.getTag("meta"), "url", url, 0);
//     replaceValueAttribute(tags, tagName.getTag("link"), "href", url, 0);
//  }
  
  public List<String> getLink(List<Tag> tag) throws Exception{
    TagName tagName = new TagName();
    List<String> list = this.getValueAttribute( tag, tagName.getTag("a"), "href", 1);//a
    list.addAll( this.getValueAttribute( tag, tagName.getTag("iframe"), "src", 1)); 
    list.addAll( this.getValueAttribute( tag, tagName.getTag("frame"), "src", 1));//frame
    list.addAll( this.getValueAttribute( tag, tagName.getTag("meta"), "url", 1));//meta
    return list;
  }
  
  public String getTitle(List<Tag> tag) throws Exception {    
    if( tag.size() < 1) return "";    
    if( tag.get(0).isContent() 
        && (tag.get(0).getValue().indexOf("!--") < 0)) return tag.get(0).getValue();    
    int i=1;
    String title = "";   
    while( i< tag.size() ){
      if( tag.get(i-1).isOpen() && tag.get(i-1).isTag( 60)){//is tag script
        i+= 2;
      }else if( tag.get(i).isContent()){        
        title = tag.get(i).getValue();       
        if( title.indexOf("GMT") > -1) title = "";        
        if( title.trim().endsWith(":"))  title = "";
        if( title.indexOf("!--") > -1) title = "";
        if( title.trim().equals("&nbsp;")) title = "";        
        if( !title.equals("")) break;
        i++;
      }else{
        i++;
      }      
    }    
    return subLine(title, 80);
  } 
  
  public String getDescription(List<Tag> tag, String title) throws Exception {   
    if( tag.size() < 1) return "";
    if( tag.get(0).isContent() 
        && (tag.get(0).getValue().indexOf("!--") < 0)) return tag.get(0).getValue();
    int i=1;
    String des = "", line = "";
    while( i< tag.size() ){
      if( tag.get(i-1).isOpen() && tag.get(i-1).isTag( 60)){//is tag script
        i+= 2;
      }else if( tag.get(i).isContent()){        
        line = tag.get(i).getValue();
        if( line.indexOf("GMT") > -1) line = ""; 
        if( line.equals( title)) line = "";        
        if( title.indexOf("!--") > -1) line = ""; 
        i++;
        des += line;
        if( des.length() > 300) break;
      }else{
        i++;
      }
    }
    return subLine( des, 300);
  } 
  public String getImage( List<Tag> tag) throws Exception {
    String addressImg = "";
    TagChecker checker = new TagChecker();
    for( Tag ele : tag){
      if(  (ele.isOpen() || ele.isSingle()) && checker.isImage( ele.getValue().toLowerCase())){ 
        addressImg = ele.getAttribute("src");
        if( addressImg != null && !addressImg.trim().equals(""))break;
      }
    }
    return addressImg;
  }
  
  public String loadResource(
      List<Tag> tag, Agent agent, HttpClientImpl connection, UrlCreation creation) throws Exception {    
    TagChecker checker = new TagChecker();
    UtilFile util = new UtilFile();   
    Calendar cal=Calendar.getInstance(Locale.FRANCE);
    String folderImg =  String.valueOf(cal.get(Calendar.HOUR))+"_"
                     +  String.valueOf(cal.get(Calendar.MINUTE))+"_"
                     + String.valueOf(cal.get(Calendar.SECOND))+"_"
                     +  String.valueOf(cal.get(Calendar.MILLISECOND));
    String folder = util.getFolder("data.web."+String.valueOf(cal.get(Calendar.YEAR))+"_"
        +String.valueOf(cal.get(Calendar.MONTH)+1)+"_"
        +String.valueOf(cal.get(Calendar.DATE))+"."
        +agent.getDomain()+"."+agent.getName()+"."+folderImg) ;    
    int index = 0;
    String addressImg;    
    int idxTagA = (new TagName()).getTag("a");
    TagChecker  check = new TagChecker();
    URL home = new URL ( agent.getHome());
    String iUrl = "";
    for( Tag ele : tag){      
      if( ele.isOpen() && ele.isTag( idxTagA)){
          addressImg = ele.getAttribute("href");
          if(addressImg != null && !addressImg.trim().equals("") && check.isLinkHtml( addressImg)){
            addressImg = creation.createURL( agent.getUrl(), addressImg);
            iUrl = creation.createURL(home.getHost(), home.getPort() , home.getProtocol(), addressImg);
            ele.replaceAttribute("href", iUrl);
          }
      }
      if(  (ele.isOpen() || ele.isSingle()) && checker.isImage( ele.getValue().toLowerCase())){ 
        addressImg = ele.getAttribute("src");
        if( addressImg != null && !addressImg.trim().equals("")){
          addressImg = creation.createURL( agent.getUrl(), addressImg);
          if( !AgentConfig.LOAD_RESOURCES){
            iUrl =creation.createURL(home.getHost(), home.getPort() , home.getProtocol(), addressImg);
            ele.replaceAttribute("src", iUrl);
          }else{
            ele.replaceAttribute("src", folderImg+"\\"+String.valueOf(index)+".jpg");
            String path =  folder+File.separator+String.valueOf(index)+".jpg";          
            connection.loadResource( addressImg, path);                     
            index++;
          }         
          
        }
      }
    }
    return folder.substring( 0 , folder.length()-1);
  }
  
  public String removeScript( String content) throws Exception{    
    int iOpenScript = content.toLowerCase().indexOf("<script");
    int iCloseScript = content.toLowerCase().indexOf("</script>");
    while( iOpenScript > -1 && iCloseScript > -1){          
       content = content.substring( 0, iOpenScript)+ content.substring( iCloseScript+9);        
       iOpenScript = content.toLowerCase().indexOf("<script");
       iCloseScript = content.toLowerCase().indexOf("</script>");
    }        
   return content;
  }
  
}
