/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.text.html;

import java.util.List;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 17, 2005
 */
class NodeParser {
  
  private Node document;
  private List<Tag> tags;
  private int idx = 0;  
  
  NodeParser ( List<Tag> t) throws Exception {
    this.tags = t;
    this.document = new Node( null, 0);
    this.document.setStart( 0);
    this.document.setEnd( this.tags.size());
    idx = 0;
    Node current = document;
    while( idx < this.tags.size()){
      //content - single 
      if( this.tags.get( idx).isContent() || this.tags.get( idx).isSingle()){        
        Node node = new Node( current, this.tags.get(idx).getName());
        node.setStart( idx);
        while( this.tags.get( idx).isContent() || this.tags.get( idx).isSingle()){           
          idx++;          
          if( idx >= ( this.tags.size()-1)) break;
        }
        node.setEnd( idx-1);       
      }
      
      if( idx >= this.tags.size()) break;
      //close
      if( this.tags.get( idx).isClose()){
        if( check( this.tags.get( idx).getName(), current)){ 
          current = set(  this.tags.get( idx).getName(), current).getParent();       
        }else{
          Node node = new Node( current, this.tags.get(idx).getName());
          node.setStart( idx);
          node.setEnd( idx);
        }
        idx++;      
      }
      
      if( idx >= this.tags.size()) break;
      //open
      if( this.tags.get( idx).isOpen()){      
        Node node = new Node( current, this.tags.get(idx).getName());       
        node.setStart( idx);
        idx++;
        current = node;
      }     
    }
    
  }
  
  
  private boolean check( int name, Node n){
    boolean have = false;
    Node node = n;
    while( node.getParent() != null){
      have = (node.getName() == name);     
      if( have) break;
      node = node.getParent();
    }     
    return have;
  }
  
  private Node set( int name, Node n){   
    Node node = n;
    while( node.getParent() != null){
      if( (node.getName()==  name) && node.getEnd() < 0) break;
      node.setEnd( idx);
      node = node.getParent();  
    }     
    node.setEnd( idx);
    return node;
  }
  
  public Node getNode(){
    return this.document;
  }  
}
