package org.vietspider.veis.impl.ui.config;

import java.io.File;
import java.net.URL;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TreeItem;
import org.vietspider.veis.impl.core.io.net.HttpBrowserImpl;
import org.vietspider.veis.impl.core.io.net.HttpClientImpl;
import org.vietspider.veis.impl.core.text.html.Document;
import org.vietspider.veis.impl.core.text.html.DocumentProcessor;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;

public class AgentAddBlock extends AgentAddBlockViewer {
  
  private int typeConnection = 0; 
  
  public AgentAddBlock( Shell parent){
    super( parent);
  }
  
  public void setTypeConnection( int t){
    this.typeConnection = t;
  }
  
  protected void goAddress(){
    String strAddress = this.txtAddress.getText();
    if( strAddress == null || strAddress.trim().equals("")) return;
    try{
      File file = new File( strAddress);	
      URL url = null;
      if( file.exists())
        url = file.toURL();				
      else
        url = new URL( strAddress);			
      this.browser.setUrl( url.toString());				
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void selectAddress(){
    try{
      String address = browser.getUrl();
      if( address == null || address.equals("about:blank") || address.trim().equals("")){
        address = this.txtAddress.getText();		
        browser.setUrl( address);				
      }		
      if( address == null || address.trim().equals("")) return;			
      
      File file = new File( address);			
      if( file.exists())
        doc  = new Document( file, charset);
      else if (address.startsWith("file")){
        URL url  = new URL( address);
        file = new File( url.toURI());			
        doc  = new Document( file, charset);
      }else if( this.typeConnection != 2){
        URL url = new URL( address);
        HttpClientImpl httpClient = new HttpClientImpl( url.getProtocol(), url.getHost(), url.getPort());       
        byte[] obj = httpClient.loadContent( address);        
        if( obj == null || obj.length < 1) return;
        doc  = new Document(obj, charset);
      }else{
        HttpBrowserImpl connection = new HttpBrowserImpl();    
        connection.setUrl( new URL(address));
        Object[] obj = connection.loadContent( address);
        if( obj[0] == null) return;
        doc  = new Document( (byte[])obj[0], null);
      }
      this.txtAddress.setText( address);
//      int [] style = doc.getNode().getSizeChildren();
      this.tree.removeAll();
      this.createTreeItem( this.tree);
//      for( int i=0; i< style.length; i++){
//        (new ConfigTreeItem()).get( this.tree, style[i], i);
//      }
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  public void documentBrowserCompleted(String content, String address){
    try{
     doc  = new Document( content);
     this.txtAddress.setText( address);
     this.tree.removeAll();
     this.createTreeItem( this.tree);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void selectTree() throws Exception {
    //get config indentified block
    TreeItem[] items = tree.getSelection();
    if( items == null || items.length  < 1) return;
    TreeItem item = items[0];
    String txt = this.getConfig( item);
    this.txtAdd.setText( txt);
    
    DocumentProcessor docProcessor = new DocumentProcessor();
    NodeProcessor nodeProcessor = new NodeProcessor();    
    String content = nodeProcessor.getText( nodeProcessor.getTag( doc.getTag(), doc.getNode(), txt)).toString();
    content = docProcessor.removeScript( content);
    this.browser.setText( "<html><body>"+content+"</body></html>");
    //expand tree with children		 
    this.expandTreeItem( items[0], txt);
  }	
  private void expandTreeItem( TreeItem item, String config) throws Exception {
    if( item.getItemCount() > 0) return;	
    this.createTreeItem( item , config);
    item.setExpanded( true);
  }
  
  protected void expandItem( TreeItem item, int depth){
    TreeItem[] items;
    int d = depth+1;
    if( item == null){
      items = tree.getSelection();
      if( items == null || items.length  < 1) return;
      item = items[0];
    }
    String config = this.getConfig( item);
    try{
      if( item.getItemCount() < 1){
        this.createTreeItem( item, config);

      }
      items = item.getItems();
      for( TreeItem ele : items)
        if(depth <= 3) expandItem( ele, d);
      item.setExpanded( true);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }	
 
  protected void addItem(){
    TreeItem[] items = tree.getSelection();
    if( items == null || items.length  < 1) return;
    TreeItem item = items[0];		
    this.add.add( this.getConfig( item));    
    item.setBackground( new Color( item.getDisplay(), 230, 230, 230));
  }
  protected void removeItem(){
    TreeItem[] items = tree.getSelection();
    if( items == null || items.length  < 1) return;
    TreeItem item = items[0];	
    String c = this.getConfig( item);    
    for( int i=0; i<add.size(); i++){
      if( add.get(i).equals( c)){
        add.remove( i);
        break;
      }
    }		
    item.setBackground( new Color( item.getDisplay(), 255, 255, 255));
  }
  protected void setUrl( String url){
    if( url == null || url.trim().equals("")) return ;
    this.txtAddress.setText( url);
    this.goAddress();
  }
  public void setConfig( String c){
    String [] split = c.split("\\.");
    if( split.length < 1) return;		
    try{			
      TreeItem item = this.tree.getItem( Integer.parseInt( split[0]) );
      this.tree.setSelection( new TreeItem[] {item});
      selectTree();
      for( int i=1; i<split.length; i++){        
        item = item.getItem( Integer.parseInt( split[i]) );
        this.tree.setSelection( new TreeItem[] {item});
        selectTree();
      }
      item.setBackground( new Color( item.getDisplay(), 230, 230, 230));
      this.add.add( c);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
 
}
