/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.config;

import java.io.File;
import java.util.prefs.Preferences;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.FileDialog;
import org.vietspider.veis.api.io.ProgressDialog;
import org.vietspider.veis.impl.core.io.base.IOProperties;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.base.ZipFolderImpl;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.widget.ProgressDialogImpl;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 12, 2005
 */
public class AgentConfig extends AgentConfigViewer {
  
  public AgentConfig() {
    super();    
  }
  
  protected void exportAgent(){
    String path = openFolderChooser();
    if( path == null) return;
    ProgressDialog progress = new ProgressDialogImpl(  this.list.getShell(), "");
    UtilConvert convert = new UtilConvert();
    UtilFile util = new UtilFile();
    IOProperties io = new IOProperties();  
    
    try{
      String domain = convert.enUnicode( this.list.getDomain());
      String [] name = this.list.getAllNameAgent();
      path = path + File.separator + domain;
      
      for( String ele : name){
        String from = util.getFile("data.config."+domain, domain+"."+convert.enUnicode(ele));
        String to = util.getFile("data.temp."+domain, domain+"."+convert.enUnicode(ele));
        io.copy( from, to);
      }      
      File input = new File( util.getFolder("data.temp."+domain));
      (new ZipFolderImpl()).addToArchive( input, new File( path), progress );
      util.deleteFolder( util.getFolder("data.temp."+domain));
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  
  protected void exportDomain(){
    String path = openFolderChooser();
    if( path == null) return;
    ProgressDialog progress = new ProgressDialogImpl( this.list.getShell(), "");
    UtilConvert convert = new UtilConvert();
    path = path + File.separator + convert.enUnicode( this.list.getDomain());
    try{
      File input = new File( (new UtilFile()).getFolder("data.config."
          +convert.enUnicode( this.list.getDomain())));
      (new ZipFolderImpl()).addToArchive( input, new File( path), progress );
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  
  protected void importDomain(){
    String path = openFileChooser();
    if( path == null) return;
    ProgressDialog progress = new ProgressDialogImpl( this.list.getShell(),"");    
    File file = new File( path);
    try{
      (new ZipFolderImpl()).extractToFiles(  file, "data.config."+file.getName(), progress);
    }catch( Exception exp){
      exp.printStackTrace();
    }
    this.list.loadDomain();
  }
  
  private String openFolderChooser(){
    Preferences prefs = Preferences.userNodeForPackage( getClass());     
    String path = prefs.get("path", "");
    DirectoryDialog dialog = new DirectoryDialog( this.list.getShell());
    if( path != null) dialog.setFilterPath( path);
    path = dialog.open();
    if( path == null) return null;
    if( !path.trim().equals("")){ 
      prefs.put("path", path);
      return path;
    }
    return null;
  }
  
  private String openFileChooser(){
    Preferences prefs = Preferences.userNodeForPackage( getClass());     
    String path = prefs.get("pathFile", "");
    FileDialog dialog = new FileDialog( this.list.getShell(), SWT.OPEN);
    if( path != null) 
      dialog.setFilterPath( path);  
    path = dialog.open();
    if( path != null) 
      prefs.put("pathFile", path);
    if(  path.trim().equals("")) return null;
    return path;
  }
  
}
