package org.vietspider.veis.impl.ui.config;


import java.util.ArrayList;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.vietspider.veis.impl.ui.config.action.AgentAddEvent;
import org.vietspider.veis.impl.ui.config.action.AgentAddListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

public class AgentRemoveBlockViewer extends AgentBlock{
  
  private Shell shell;
  protected Tree tree;
  protected Text txtAdd;	
  protected Browser browser;	
  
  private Vector<AgentAddListener> listeners;
  protected ArrayList<String> remove;	
  
  public AgentRemoveBlockViewer( Shell parent){		
    shell = new Shell( parent, SWT.MAX | SWT.MIN | SWT.RESIZE);    
    shell.setLocation( parent.getLocation().x+20, parent.getLocation().y+10);
    shell.setImage( parent.getImage());
    shell.setLayout( new FillLayout());
    ApplicationFactory factory = new ApplicationFactory( shell, this.getClass().getName());
    
    listeners = new Vector<AgentAddListener>(); 
    remove = new ArrayList<String>();
    
    SashForm sash0 = new SashForm( shell, SWT.HORIZONTAL);
    
    Composite comMain = new Composite( sash0, SWT.NONE);		
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;
    comMain.setLayout( gridLayout);  
    
    browser = new Browser( comMain, SWT.BORDER);	    
    GridData gridData = new GridData( GridData.FILL_BOTH);
    browser.setLayoutData(gridData);	   
    
    Composite comBottom = new Composite( comMain, SWT.NONE);
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    comBottom.setLayoutData( gridData);
    gridLayout = new GridLayout();
    gridLayout.numColumns = 4;
    comBottom.setLayout( gridLayout); 
    
    factory.setComposite( comBottom);
    
    txtAdd = factory.createText();
    txtAdd.setEditable( false);
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    txtAdd.setLayoutData(gridData);
    
    factory.createButton( "butClose", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        shell.dispose();
      }   
    });
    
    factory.createButton( "butOk", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        try{
          clickOk();
        }catch( Exception exp){
          exp.printStackTrace();
        }
      }   
    });
    
    factory.createButton( "butAdd", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        addItem();
      }   
    });    
    
    
    tree = new Tree( sash0, SWT.SINGLE | SWT.BORDER);
    tree.addSelectionListener(new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        try{
          selectTree();
        }catch( Exception exp){
          exp.printStackTrace();
        }
      }		
    });
    Menu mbar = new Menu( shell, SWT.POP_UP);		
    factory.createMenuItem( mbar, "itemExpand", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        expandItem( null, 0);
      }   
    });   
    
    factory.createMenuItem( mbar, "itemAdd", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        addItem();
      }   
    });  
    
    factory.createMenuItem( mbar, "itemRemove", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        removeItem();
      }   
    });   
    tree.setMenu( mbar);	
    
    sash0.setWeights( new int[]{ 500, 90}); 	
    
    shell.setSize( 800, 550);
    shell.open();	   
  }
  protected void selectTree() throws Exception {		
  }	
  protected void expandItem(TreeItem item, int depth){		
  }
  protected void addItem(){		
  }
//  protected void addItemByValue(){   
//  }
  protected void removeItem(){		
  }
  public void fireEvent( AgentAddEvent e) {
    synchronized(listeners)  {			
      for(int i = 0; i < listeners.size(); i++){
        try{
          AgentAddListener listener = listeners.get(i);
          listener.selected(e);		        
          break;
        }catch(Exception exp){               	  
        }       
      }
    }
  }
  public void addListener( AgentAddListener listener) {    	
    synchronized(listeners) {			
      listeners.remove(listener);
      listeners.add(listener);
    }
  }
  public void removeListener( AgentAddListener listener) {
    synchronized(listeners) {
      listeners.remove(listener);
    }
  }
  public void selected( AgentAddEvent ev) {
    if(ev.getAdd() == null || ev.getAdd().size() < 1) return;
    if(ev.getUrl() == null || ev.getUrl().equals("")) return;			 
    fireEvent(ev);	   
  }	
  public void clickOk(){		
    AgentAddEvent event = new AgentAddEvent( this.remove, "", null);
    fireEvent(event);
    shell.dispose();
  }
  
}
