/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.io.File;
import java.net.URL;
import java.util.prefs.Preferences;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.MessageBox;
import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.api.io.ProgressDialog;
import org.vietspider.veis.impl.core.io.base.DataBuffer;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.local.ConfigCollection;
import org.vietspider.veis.impl.core.io.net.HttpConnectionImpl;
import org.vietspider.veis.impl.core.io.net.server.EditorServer;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.core.text.html.Document;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;
import org.vietspider.veis.impl.ui.publisher.action.StoreEvent;
import org.vietspider.veis.impl.ui.publisher.action.StoreListener;
import org.vietspider.veis.impl.ui.publisher.business.AccessHtmlFile;
import org.vietspider.veis.impl.ui.publisher.business.StorePageCreation;
import org.vietspider.veis.impl.ui.publisher.business.TempPageCreation;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.spider.SpiderService;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;
import org.vietspider.veis.impl.ui.widget.ProgressDialogImpl;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 19, 2005
 */
public class Content extends ContentAction { 
  
  private TempPageCreation creation;
  
  private String name_label;
  
  public Content(ApplicationFactory factory, Composite parent, int style) {
    super(factory, parent, style);   
    creation = new TempPageCreation();
  }
  
  public String getPath(){
    return this.path;
  }
  
  public int getLevel(){
    return this.level;
  }
  
  public void setPath( String p, int level){ 
    ResourceManager resource = new ResourceManager( "veis");   
    this.path = p;        
    if( path.toLowerCase().indexOf("web") > -1){
      UtilConvert convert = new UtilConvert();
      String name = p.substring( p.toLowerCase().indexOf("web")+4);    
      String [] split = name.split( File.separator+File.separator); 
      name = "";
      if( split.length > 0){        
        String [] s = split[0].split("\\_");        
        if( s.length > 2){          
          split[0] = s[2]+"-"+s[1]+"-"+s[0];
        }
        name = split[0];
      }
      
      if( split.length > 1)  name += " / "+split[1];        
      if( split.length > 2)  name += " / "+split[2];        
      name = convert.deUnicode( name); 
      name_label = name;
//      this.lblSource.setText( name);
      this.setTitle(  resource.getLabel( "run")+" "+name+" ...");
    }    
    this.level = level;
    creation.start( this.path, this.level);
     
  }
  
  public void refreshTempPages(){
    if( creation.getState() < 1) return;
    if( creation.getState() == 1){
      this.cboPage.removeAll();
      for( int i=0; i<creation.getTotal(); i++){
        this.cboPage.add( String.valueOf( i+1));
      }
      return ;
    }
    this.cboPage.removeAll();
    for( int i=0; i<creation.getTotal(); i++){
      this.cboPage.add( String.valueOf( i+1));
    }
    this.cboPage.select(0);
    this.viewPage( 1);
    creation.setState( -1);
    this.lblSource.setText( name_label);
     
  }
  
  public void setStore( String p){  
    ResourceManager resource = new ResourceManager( "veis"); 
    ProgressDialog progress = new ProgressDialogImpl( this.getShell(),
        resource.getLabel( this.getClass().getName()+".progressGetData"));   
    this.path = p;        
    if( path.toLowerCase().indexOf("store") > -1){
      UtilConvert convert = new UtilConvert();
      String name = p.substring( p.toLowerCase().indexOf("store")+6);             
      name = convert.deUnicode( name);     
      name = name.substring(0, name.length()-1);
      this.lblSource.setText(" >>>>> "+name);
    }    
    this.level = -1;
    int total = (new StorePageCreation()).loadData( progress, this.path);
    this.cboPage.removeAll();
    for( int i=0; i<total; i++){
      this.cboPage.add( String.valueOf( i+1));
    }
    this.cboPage.select(0);
    this.viewPage( 1);
    progress.dispose();  
  }
  
  protected void selectedPage(){
    this.viewPage( this.cboPage.getSelectionIndex()+1);  
  }
  protected void nextPage(){    
    int i = this.cboPage.getSelectionIndex() + 1;
    if( i >= this.cboPage.getItemCount()) return;
    this.cboPage.select( i);
    selectedPage();  
  }
  protected void previousPage(){
    int i = this.cboPage.getSelectionIndex() - 1;    
    if( i < 0) return;   
    this.cboPage.select( i);
    selectedPage();  
  }
  protected void viewPage( int page){
    try{    
      File file = new File( ( new UtilFile()).getFile( "data.temp.web", String.valueOf(page)+".htm"));
      this.browser.setUrl( file.toURL().toString() );
    }catch( Exception exp){
      exp.printStackTrace();
    }  
  }
  protected void backPage(){
    if( this.browser.isBackEnabled())
      this.browser.back();
  }
  protected void forwardPage(){
    if( this.browser.isForwardEnabled())
      this.browser.forward();
    else 
      this.nextPage();    
  }
  protected void stopPage(){
    this.browser.stop();
    this.progressBar.setSelection(0);
  }
  protected void updatePage(){
    String url = this.browser.getUrl();     
    if( url.indexOf( "temp")> -1 && url.indexOf("web") > -1){
      int i = this.cboPage.getSelectionIndex();   
      if( this.level > -1)
        this.setPath( this.path, this.level);
      else
        this.setStore( this.path);
      if( i >= this.cboPage.getItemCount()) return;
      this.cboPage.select( i);
      selectedPage();
      return;
    }
    this.browser.refresh();
    this.progressBar.setSelection(0);
  } 
  protected void saveContent(){
    Preferences prefs = Preferences.userNodeForPackage( getClass());     
    String p = prefs.get("path", "");
    FileDialog dialog = new FileDialog( this.getShell(), SWT.SAVE);
    if( p != null) dialog.setFilterPath( p);
    p = dialog.open();
    if( p != null) prefs.put("path", p);
    if( p == null || p.trim().equals("")) return;    
    AccessHtmlFile access = new AccessHtmlFile();
    DataBuffer buffer = new DataBuffer();    
    try{
      URL url = new URL(this.browser.getUrl());
      File input = new File( url.toURI());
      if( !input.exists()) return;
      if( input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator) < 1 ) {
        if( input.getAbsolutePath().indexOf("data"+File.separator+"store"+File.separator) < 1 ) return;
      }
      File output = new File(p);
      if( output.getName().indexOf(".") < 0)
        output = new File(p+".htm");      
      access.copyImage( input, output.getParentFile().getAbsolutePath(), null, buffer, 1);
      access.copyFile( input, output, buffer);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  
  protected void saveImage(){
    Preferences prefs = Preferences.userNodeForPackage( getClass());     
    String p = prefs.get("path", "");
    FileDialog dialog = new FileDialog( this.getShell(), SWT.SAVE);
    if( p != null) dialog.setFilterPath( p);
    p = dialog.open();
    if( p != null) prefs.put("path", p);
    if( p == null || p.trim().equals("")) return;    
    AccessHtmlFile access = new AccessHtmlFile();
    DataBuffer buffer = new DataBuffer();    
    try{
      URL url = new URL(this.browser.getUrl());
      File input = new File( url.toURI());
      if( !input.exists()) return;
      if( input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator) < 1 ) {
        if( input.getAbsolutePath().indexOf("data"+File.separator+"store"+File.separator) < 1 ) return;
      }
      File output = new File(p);
      if( output.getName().indexOf(".") > -1)
        output = new File(p.substring(0, p.lastIndexOf(".")));      
      access.copyImage( input, output.getParentFile().getAbsolutePath(), output.getName(), buffer, 1);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void saveStore(){
    StoreDialogViewer viewer = new StoreDialogViewer( this.getShell());
    viewer.addStoreListener( new StoreListener(){
      public void store( StoreEvent evt){
       saveStore( evt.getPath()); 
      }
    });
  }
  private void saveStore(String p){   
    if( p == null || p.trim().equals("")) return;    
    AccessHtmlFile access = new AccessHtmlFile();
    DataBuffer buffer = new DataBuffer();    
    try{
      URL url = new URL(this.browser.getUrl());
      File input = new File( url.toURI());
      if( !input.exists()) return;
      if( input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator) < 1 ) return;
      File output = new File(p);
      if( output.getName().indexOf(".") < 0)
        output = new File(p+input.getName());      
      access.copyImage( input, output.getParentFile().getAbsolutePath(), null, buffer, 1);
      access.copyFile( input, output, buffer);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  
  protected void deleteContent(){
    MessageBox msg = new MessageBox ( this.getShell(), SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);
    msg.setText ("Cảnh báo");
    msg.setMessage ("Bạn có muốn xóa nội dung này không ?");
    if(msg.open() == SWT.NO) return;  
    try{
      URL url = new URL(this.browser.getUrl());
      File input = new File( url.toURI());
      if( !input.exists()) return;
      if( input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator) < 1 ) {
        if( input.getAbsolutePath().indexOf("data"+File.separator+"store"+File.separator) < 1 ) return;
      }
      input.delete();
      String f = input.getAbsolutePath();
      f = f.substring(0, f.indexOf(".htm"));
      UtilFile util = new UtilFile();
      util.deleteFolder( f);
      
      int i = this.cboPage.getSelectionIndex();       
      if( this.level > -1)
        this.setPath( this.path, this.level);
      else
        this.setStore( this.path);
      if( i >= this.cboPage.getItemCount()) return;
      this.cboPage.select( i);
      selectedPage();      
    }catch( Exception exp){
      exp.printStackTrace();
    } 
  }
  
  protected void viewSource(){
    try{
      String address = this.getSource();
      if( address != null)
        this.browser.setUrl( address);
    }catch( Exception exp){
    }
  }
  protected void loadAgaint(){
    try{
      URL url = new URL(this.browser.getUrl());
      File input = new File( url.toURI());
      if( !input.exists()) return;
      if( input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator) < 1 ) return ;   
      String name = input.getAbsolutePath().substring( 
          input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator)+9);        
      String [] split = name.split(File.separator+File.separator);
      if( split.length < 3) return ;
      ConfigCollection config = new ConfigCollection();      
      Agent agent = config.getAgent( split[1], split[2]);
      String address = getSource();
      if( address == null) return ;
      agent.setUrl( address);
      HttpConnectionImpl connection = new HttpConnectionImpl();
      byte[] objs = connection.loadContent( agent.getUrl());
      String c = agent.getCharset();    
      if( objs == null || objs.length < 1) return ;      
      Document doc = new Document( objs, c);
      NodeProcessor nodeProcessor = new NodeProcessor();
      doc = nodeProcessor.getDocument( doc, agent.getAdd());//, agent.getRemove()); 
      
      name = input.getAbsolutePath();
      if( name.indexOf(".htm") < 0) return;
      AccessHtmlFile access = new AccessHtmlFile();
      name = name.substring( 0, name.indexOf(".htm"));
      access.loadImageAgaint( doc.getTag(), name);
      
      String content = nodeProcessor.getText( doc.getTag()).toString();
      content = "<!--"+address+"-->"
              + "\n<meta http-equiv=\"content-type\" content=\"text/html; charset=\"utf-8\">\n"+content;        
      DataBuffer buffer = new DataBuffer();
      buffer.saveByte( input.getAbsoluteFile(),content.getBytes( "utf-8")); 
      
    }catch( Exception exp){
      exp.printStackTrace();    
    }
  }
  private String getSource(){
    try{
      DataBuffer buffer = new DataBuffer();
      URL url = new URL(this.browser.getUrl());
      File input = new File( url.toURI());
      if( !input.exists()) return null;
      if( input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator) < 1 ) return null;
      String content = new String(buffer.loadByte( input), "utf-8");
      String [] split = content.split("--");
      if( split.length < 2) return null;      
      return split[1];
    }catch( Exception exp){
      exp.printStackTrace();
      return null;
    }
  }
  
  protected void runProgram( String name){
    File file = new File( name);   
    try{    
      if( file.exists()){
        ProcessBuilder pro = new ProcessBuilder( name);
        pro.start();
      }else{
        if( name.indexOf("spider")> -1) new SpiderService();        
      }
    }catch(Exception exp){     
      exp.printStackTrace();
    }     
  }  
  
  protected void editContent(){
    try{
      URL url = new URL(this.browser.getUrl());
      File input = new File( url.toURI());
      if( !input.exists()) return;
      if( input.getAbsolutePath().indexOf("data"+File.separator+"web"+File.separator) < 1 ) {
        if( input.getAbsolutePath().indexOf("data"+File.separator+"store"+File.separator) < 1 ) return;
      }
      DataBuffer buffer = new DataBuffer();
      
      String content = new String(buffer.loadByte( input), "utf-8");
      content = content.replaceAll("\n", "");
      content = content.replaceAll("\t", "");
      content = content.replaceAll("\'", "\"");      
      UtilFile util = new UtilFile(); 
      String scriptPath = util.getFile("data.temp.script", "editor.html");      
      String html = "<html> <head>"
                  + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"
                  +"<meta name=\"robots\" content=\"noindex, nofollow\">"
                  +"<link href=\"../sample.css\" rel=\"stylesheet\" type=\"text/css\" />"
                  +"<script type=\"text/javascript\" src=\"fckeditor.js\"></script>"
                  +"</head><body>"
                  +"<form action=\"http://127.0.0.1:"+String.valueOf(EditorServer.port)+"\" method=\"post\" >"
                  +"<input type=\"hidden\" name=\"veispath\" value=\""+input.getAbsolutePath()+"\">"
                  +"<script type=\"text/javascript\">"
                  +"var sBasePath = document.location.pathname.substring(0,document.location.pathname.lastIndexOf('_samples')) ;"
                  +" var oFCKeditor = new FCKeditor( 'veiseditor' ) ;"
                  +"oFCKeditor.BasePath = sBasePath ;"
                  +"oFCKeditor.Height = 500 ;"                  
                  +"oFCKeditor.Value  = '"+content+"' ;"
                  +"oFCKeditor.Create() ;"                  
                  +"</script><br>"
                  +"</form></body></html>";
     
      buffer.saveByte( scriptPath , html.getBytes("utf-8"));
      File file = new File( scriptPath);
      this.browser.setUrl( file.toURL().toString());
      if(  EditorServer.exit){        
        new Thread() {          
          public void run() {
            if(  EditorServer.exit){
              try{              
                new EditorServer( 0);              
              }catch( Exception exp){
                exp.printStackTrace();
              }
            }
          }
        }.start();
      }
    }catch(Exception exp){     
      exp.printStackTrace();
    }   
  }
  
  protected void selectLanguage(){
    new LanguageViewer( this.getShell());
  }
  
  protected void setRSSData(){
    UtilFile util = new UtilFile(); 
    try{
      String  tp = util.getFile("data.temp.rss", "view.htm");
      File f = new File( tp);
      this.browser.setUrl( f.toURL().toString());      
    }catch( Exception exp){
      exp.printStackTrace();        
    }
  }
  
  protected void setTitle(String title){
    this.lblSource.setText( title);
  }
 
}
