/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.util.Vector;

import org.eclipse.swt.widgets.Composite;
import org.vietspider.veis.impl.ui.publisher.action.UpdateEvent;
import org.vietspider.veis.impl.ui.publisher.action.UpdateListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 26, 2005
 */
public class ContentAction extends ContentViewer {
  
  protected Vector<UpdateListener> listeners;   

  public ContentAction( ApplicationFactory factory, Composite parent, int style) {
    super( factory, parent, style);  
    
    listeners = new Vector<UpdateListener>();    
   
  }
  
//implement listener for update event 
  
  public void fireUpdateEvent( UpdateEvent e) {
    synchronized(listeners)  {      
      for(int i = 0; i < listeners.size(); i++){
        try{
          UpdateListener listener = listeners.get(i);
          listener.update(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addUpdateListener( UpdateListener listener) {     
    synchronized(listeners) {     
      listeners.remove(listener);
      listeners.add(listener);
    }
  }
  public void removeUpdateListener( UpdateListener listener) {
    synchronized(listeners) {
      listeners.remove(listener);
    }
  }
  public void update( UpdateEvent ev) {  
    fireUpdateEvent(ev);     
  } 
  public void update(){
    UpdateEvent event = new UpdateEvent();
    fireUpdateEvent(event);  
  }
}
