/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.vietspider.veis.impl.core.io.local.SystemProperties;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 14, 2005
 */
public class LanguageViewer {

  private Shell shell;
  
  private Combo list; 
  private Button ok;  
  
  public LanguageViewer( Shell parent){     
    
    shell = new Shell( parent);  
    shell.setLocation( parent.getLocation().x+250, parent.getLocation().y+300);  
    
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 3;    
    shell.setLayout( gridLayout);
    
    Label lbl = new Label( shell, SWT.LEFT);
    lbl.setText("Select one:");
    
    list = new Combo( shell, SWT.SINGLE | SWT.DROP_DOWN | SWT.READ_ONLY);
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);   
    list.setLayoutData(gridData);
    
   
    ok = new Button( shell, SWT.PUSH); 
    ok.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        selectLanguage();        
      }
    });
    ok.setText("Ok");  
    
    shell.setSize( 200, 70);
    shell.open();
    try{
      this.load();
    }catch( Exception exp){
      exp.printStackTrace();
    }   
//    shell.open();   
//    while (!shell.isDisposed()) {        
//      if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
//    }
   
  }
  public void load() throws Exception {
    SystemProperties system = new SystemProperties();  
    String value = system.get("language");
    String select = system.get("locale");
    if( value == null) return;
    String[] split = value.split(",");
    if( split.length < 1) return;
    if( split.length == 1 && split[0].trim().equals("")) return; 
    int idx = 0;
    for( int i=0; i<split.length; i++){
      if( split[i].trim().equals( select)){
        idx=i;
        break;
      }
    }
    this.list.setItems( split);
    this.list.select( idx);
  }
 public void selectLanguage(){
   if( this.list.getSelectionIndex() < 0) return;
   String value = this.list.getItem( this.list.getSelectionIndex());
   SystemProperties system = new SystemProperties();  
   try{
     system.set("locale",value);     
     this.shell.getParent().getShell().setMinimized( true);
     this.shell.getParent().getShell().setVisible( false);
     new PublisherImpl();   
   }catch( Exception exp){
     exp.printStackTrace();
   }
 }

}
