/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.io.File;
import java.util.Vector;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.TreeItem;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.publisher.action.ExportDataEvent;
import org.vietspider.veis.impl.ui.publisher.action.ExportDataListener;
import org.vietspider.veis.impl.ui.publisher.action.ImportDataEvent;
import org.vietspider.veis.impl.ui.publisher.action.ImportDataListener;
import org.vietspider.veis.impl.ui.publisher.action.MenuDateEvent;
import org.vietspider.veis.impl.ui.publisher.action.MenuDateListener;
import org.vietspider.veis.impl.ui.publisher.action.MenuDomainEvent;
import org.vietspider.veis.impl.ui.publisher.action.MenuDomainListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 25, 2005
 */
public class MenuAction extends MenuViewer {
  
  protected Vector<MenuDateListener> lMenuDate;
  protected Vector<MenuDomainListener> lMenuDomain;
  protected Vector<ImportDataListener> lImport;
  protected Vector<ExportDataListener> lExport;
  protected Vector<ExportDataListener> lCreateDocument;
  protected Vector<ExportDataListener> lSearch;  
  
  public MenuAction(ApplicationFactory factory,Composite parent, int style) {
    super( factory, parent, style);
    
    lMenuDate = new Vector<MenuDateListener>();
    lMenuDomain = new Vector<MenuDomainListener>();
    
    lImport = new Vector<ImportDataListener>();
    lExport = new Vector<ExportDataListener>();    
    lCreateDocument = new Vector<ExportDataListener>();    
    lSearch = new Vector<ExportDataListener>();     
  }
 //implement listener for date combo
  
  public void fireMenuDateEvent( MenuDateEvent e) {
    synchronized(lMenuDate)  {      
      for(int i = 0; i < lMenuDate.size(); i++){
        try{
          MenuDateListener listener = lMenuDate.get(i);
          listener.selected(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addMenuDateListener( MenuDateListener listener) {     
    synchronized(lMenuDate) {     
      lMenuDate.remove(listener);
      lMenuDate.add(listener);
    }
  }
  public void removeMenuDateListener( MenuDateListener listener) {
    synchronized(lMenuDate) {
      lMenuDate.remove(listener);
    }
  }
  public void selected( MenuDateEvent ev) {    
    if(ev.getPath() == null || ev.getPath().equals("")) return;      
    fireMenuDateEvent(ev);     
  } 
  protected void elementDateSelected(){
    MenuDateEvent event = new MenuDateEvent( this.getDateSelected());
    fireMenuDateEvent(event);    
  }  
  
  //implement listener for domain tree
  
  public void fireMenuDomainEvent( MenuDomainEvent e) {
    synchronized(lMenuDomain)  {      
      for(int i = 0; i < lMenuDomain.size(); i++){
        try{
          MenuDomainListener listener = lMenuDomain.get(i);
          listener.selected(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addMenuDomainListener( MenuDomainListener listener) {     
    synchronized(lMenuDomain) {     
      lMenuDomain.remove(listener);
      lMenuDomain.add(listener);
    }
  }
  public void removeMenuDomainListener( MenuDomainListener listener) {
    synchronized(lMenuDomain) {
      lMenuDomain.remove(listener);
    }
  }
  public void selected( MenuDomainEvent ev) {    
    if(ev.getPath() == null || ev.getPath().equals("")) return;      
    fireMenuDomainEvent(ev);     
  } 
  protected void elementDomainSelected(){
    TreeItem [] items = this.treeDomain.getSelection();    
    if( items == null  || items.length < 1) return;
    int style = 0;
    String path = this.getDateSelected();
    UtilConvert convert = new UtilConvert();
    TreeItem item = items[0];
    if( item.getParentItem() != null){
      style = 1;
      path +=  File.separator + convert.enUnicode( item.getParentItem().getText())
      + File.separator + convert.enUnicode( item.getText());
    }else{
      style = 0;
      path +=  File.separator + convert.enUnicode( item.getText());
    }    
    MenuDomainEvent event = new MenuDomainEvent( path, style);
    fireMenuDomainEvent(event);    
  }
  
//implement listener for import event 
  
  public void fireImportDataEvent( ImportDataEvent e) {
    synchronized(lImport)  {      
      for(int i = 0; i < lImport.size(); i++){
        try{
          ImportDataListener listener = lImport.get(i);
          listener.importData(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addImportDataListener( ImportDataListener listener) {     
    synchronized(lImport) {     
      lImport.remove(listener);
      lImport.add(listener);
    }
  }
  public void removeImportDataListener( ImportDataListener listener) {
    synchronized(lImport) {
      lImport.remove(listener);
    }
  }
  public void importData( ImportDataEvent ev) {  
    fireImportDataEvent(ev);     
  } 
  public void importData(){
    ImportDataEvent event = new ImportDataEvent();
    fireImportDataEvent(event);  
  }
  
//implement listener for import event 
  
  public void fireExportDataEvent( ExportDataEvent e) {
    synchronized(lExport)  {      
      for(int i = 0; i < lExport.size(); i++){
        try{
          ExportDataListener listener = lExport.get(i);
          listener.exportData(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addExportDataListener( ExportDataListener listener) {     
    synchronized(lExport) {     
      lExport.remove(listener);
      lExport.add(listener);
    }
  }
  public void removeExportDataListener( ExportDataListener listener) {
    synchronized(lExport) {
      lExport.remove(listener);
    }
  }
  public void exportData( ExportDataEvent ev) {  
    fireExportDataEvent(ev);     
  } 
  public void exportData(){
    ExportDataEvent event = new ExportDataEvent();
    fireExportDataEvent(event);  
  }
  
//implement listener for creation event 
  
  public void fireCollectionCreationEvent( ExportDataEvent e) {
    synchronized(lCreateDocument)  {      
      for(int i = 0; i < lCreateDocument.size(); i++){
        try{
          ExportDataListener listener = lCreateDocument.get(i);
          listener.exportData(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addCollectionCreationListener( ExportDataListener listener) {     
    synchronized(lCreateDocument) {     
      lCreateDocument.remove(listener);
      lCreateDocument.add(listener);
    }
  }
  public void removeCollectionCreationListener( ExportDataListener listener) {
    synchronized(lCreateDocument) {
      lCreateDocument.remove(listener);
    }
  }
  public void creationData( ExportDataEvent ev) {  
    fireCollectionCreationEvent(ev);     
  } 
  public void creationData(){
    ExportDataEvent event = new ExportDataEvent();
    fireCollectionCreationEvent(event);  
  }
  
//implement listener for search event 
  
  public void fireSearchEvent( ExportDataEvent e) {
    synchronized(lSearch)  {      
      for(int i = 0; i < lSearch.size(); i++){
        try{
          ExportDataListener listener = lSearch.get(i);
          listener.exportData(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addSearchListener( ExportDataListener listener) {     
    synchronized(lSearch) {     
      lSearch.remove(listener);
      lSearch.add(listener);
    }
  }
  public void removeSearchListener( ExportDataListener listener) {
    synchronized(lSearch) {
      lSearch.remove(listener);
    }
  }
  public void searchData( ExportDataEvent ev) {  
    fireSearchEvent(ev);     
  } 
  public void searchData(){
    ExportDataEvent event = new ExportDataEvent();
    fireSearchEvent(event);  
  }
}
