/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.Section;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;
import org.vietspider.veis.impl.ui.widget.ImageLoader;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 19, 2005
 */
public class MenuViewer extends Composite {
  
  protected List lstDate;  
  protected Tree treeDomain;
  protected Section sectionDate; 
  
  public MenuViewer( ApplicationFactory factory, Composite parent, int style) {
    super( parent, style);
    
    factory.setClassName( this.getClass().getName());
  
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;   
    this.setLayout( gridLayout);
    
    sectionDate = new Section( this, Section.TWISTIE | Section.TITLE_BAR );   
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);        
    gridData.horizontalSpan = 1;    
    sectionDate.setLayoutData(gridData);  
    sectionDate.setLayout( new FillLayout());
    sectionDate.setText( factory.getLabel("sectionDate"));
    sectionDate.setFont(new Font( this.getDisplay(), "Tahoma", 11, SWT.NORMAL));
    sectionDate.setForeground( new Color( this.getDisplay(), 26, 140, 255));    
    
    sectionDate.setTitleBarForeground(  new Color( this.getDisplay(), 26, 140, 255));
    sectionDate.setTitleBarGradientBackground( new Color( this.getDisplay(), 255, 255, 255));
    sectionDate.setTitleBarBackground( new Color( this.getDisplay(), 200, 200, 200));
       
    Composite composite = new Composite ( sectionDate, SWT.NONE);    
    composite.setLayout( new FillLayout());
    //composite.setBackground( new Color( this.getDisplay(), 255, 255, 255));
    
    lstDate = factory.createList( composite, SWT.SINGLE | SWT.CENTER | SWT.BORDER);
    lstDate.setFont(new Font( this.getDisplay(), "Times New Roman", 12, SWT.NORMAL));
    lstDate.setForeground( new Color( this.getDisplay(), 0, 64, 64));     
    lstDate.setToolTipText( factory.getLabel( "lblDate"));   
    lstDate.addListener(SWT.Selection, new Listener() {
      public void handleEvent(Event e) {
        selectedDate();
        elementDateSelected();     
      }          
    }); 
    sectionDate.setClient( composite); 
    
    FormToolkit toolkit = new FormToolkit( this.getDisplay());
    
    Form form = toolkit.createForm( this);
    form.setText(factory.getLabel( "form"));    
    Image img = (new ImageLoader()).load( this.getDisplay(), "titledomain.gif");
    if( img != null )  form.setBackgroundImage( img);    
    //form.setBackground( new Color( this.getDisplay(), 0, 255, 0));
    form.setFont(new Font( this.getDisplay(), "Tahoma", 11, SWT.BOLD));   
    form.getBody().setLayout(new FillLayout());
    form.setVisible( true); 
    gridData = new GridData(GridData.FILL_BOTH);       
    gridData.horizontalSpan = 1;      
    form.setLayoutData(gridData);
    
    treeDomain = toolkit.createTree( form.getBody(), SWT.SINGLE);
    treeDomain.setForeground( new Color( this.getDisplay(), 0, 64, 64));   
    treeDomain.setFont(new Font( this.getDisplay(), "Times New Roman", 13, SWT.NORMAL));
    treeDomain.addListener(SWT.Selection, new Listener() {
      public void handleEvent(Event e) {       
        elementDomainSelected();
      }          
    });  
    
    final Menu menu = new Menu ( this.getShell(), SWT.POP_UP);
    factory.createMenuItem( menu, "itemUpdate", "update.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        refresh();
      }      
    });   
    
    new MenuItem (menu, SWT.SEPARATOR);
    
    factory.createMenuItem( menu, "itemExport", "export.png", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        exportData();
      }      
    });   
    
    factory.createMenuItem( menu, "itemImport", "import.png", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        importData();
      }      
    });   
    
    factory.createMenuItem( menu, "itemSearch", "search.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        searchData();
      }      
    });  
    
    factory.createMenuItem( menu, "itemExportDocument", "view.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        creationData();
      }      
    });       
       
    this.lstDate.setMenu( menu);
    this.treeDomain.setMenu( menu);   
    this.sectionDate.setMenu( menu);
    
  } 
  protected void selectedDate(){}
  protected void refresh(){}
  public String getDateSelected(){
    try{      
      String date = this.lstDate.getSelection()[0];
      if( date == null || date.equals("")) return "";
      date = date.trim();
      UtilFile util = new UtilFile();            
      String [] split= date.split("\\/");   
      String path = util.getFolder("data.web") ;
      date = split[2]+"_"+split[1]+"_"+split[0];
      path +=  date;
      return path;
    }catch( Exception exp){
      exp.printStackTrace();
      return "";
    }
  }
  protected void elementDomainSelected(){}
  protected void elementDateSelected(){}
  public void importData(){}
  public void exportData(){}
  public void searchData(){}
  public void creationData(){}  
}
