/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.vietspider.veis.impl.ui.publisher.action.ExportDataEvent;
import org.vietspider.veis.impl.ui.publisher.action.ExportDataListener;
import org.vietspider.veis.impl.ui.publisher.action.ImportDataEvent;
import org.vietspider.veis.impl.ui.publisher.action.ImportDataListener;
import org.vietspider.veis.impl.ui.publisher.action.MenuDateEvent;
import org.vietspider.veis.impl.ui.publisher.action.MenuDateListener;
import org.vietspider.veis.impl.ui.publisher.action.MenuDomainEvent;
import org.vietspider.veis.impl.ui.publisher.action.MenuDomainListener;
import org.vietspider.veis.impl.ui.publisher.action.StoreEvent;
import org.vietspider.veis.impl.ui.publisher.action.StoreListener;
import org.vietspider.veis.impl.ui.publisher.action.UpdateEvent;
import org.vietspider.veis.impl.ui.publisher.action.UpdateListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 19, 2005
 */
public class PublisherViewer  {  
  
  protected Menu menu;
  protected Content content;
  public Shell shell;
  protected RSS rss;
  protected final Display display;
  
  public PublisherViewer() {   
    display = Display.getDefault();   
    ApplicationFactory factory = new ApplicationFactory(display, this.getClass() , 800, 520);
    shell = (Shell) factory.getComposite(); 
    shell.setLayout( new FillLayout());
    
    SashForm sash = new SashForm( shell, SWT.HORIZONTAL);
    
    SashForm sashMenu = new SashForm( sash, SWT.HORIZONTAL);
    
    Composite comMenu = new Composite( sashMenu, SWT.NONE);
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;   
    comMenu.setLayout( gridLayout);
    
    menu = new Menu( factory, comMenu, SWT.NONE);
    GridData gridData = new GridData(GridData.FILL_BOTH);        
    gridData.horizontalSpan = 1;    
    menu.setLayoutData(gridData);  
    menu.addMenuDateListener( new MenuDateListener(){
      public void selected( MenuDateEvent evt){
        selectedPath( evt.getPath(), 1);
      }
    });    
    menu.addMenuDomainListener( new MenuDomainListener(){
      public void selected( MenuDomainEvent evt){
        selectedPath( evt.getPath(), evt.getStyle()+2);
      }
    });    
    menu.addImportDataListener( new ImportDataListener(){
      public void importData( ImportDataEvent evt){
        import_();
      }
    });
    menu.addExportDataListener( new ExportDataListener(){
      public void exportData( ExportDataEvent evt){
        export_();
      }
    });
    menu.addSearchListener( new ExportDataListener(){
      public void exportData( ExportDataEvent evt){
        search();
      }
    });   
    menu.addCollectionCreationListener( new ExportDataListener(){
      public void exportData( ExportDataEvent evt){
        creationCollection();
      }
    });
    
    Store store = new Store( factory, comMenu, SWT.NONE);
    gridData = new GridData(GridData.FILL_HORIZONTAL);        
    gridData.horizontalSpan = 1;    
    store.setLayoutData(gridData); 
    store.addStoreListener( new StoreListener(){
      public void store( StoreEvent evt){
        selectedStore( evt.getPath());
      }
    });
    
    rss = new RSS( factory, comMenu, SWT.NONE);    
    gridData = new GridData(GridData.FILL_HORIZONTAL);        
    gridData.horizontalSpan = 1;   
    rss.setLayoutData(gridData); 
    rss.addRSSListener( new MenuDomainListener(){
      public void selected( MenuDomainEvent evt){
        selectedRSS( evt.getPath());
      }
    });
    
    content = new Content( factory, sash, SWT.NONE);   
    content.addUpdateListener( new UpdateListener(){
      public void update( UpdateEvent evt){
        menuUpdate();
      }
    }); 
  
    sash.setWeights( new int[]{ 200, 600});      
  
    shell.open();   
    content.setPath( menu.getDateSelected(), 1); 
  }
  protected void selectedPath(String path, int level){}
  protected void menuUpdate(){}
  protected void import_(){}
  protected void export_(String path, int level){}
  protected void search(){}
  protected void export_(){}
  protected void creationCollection(){}
  protected void selectedStore( String path){}
  protected void selectedRSS( String path){}
  protected void viewRSS(){}
  
}
