/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.io.File;
import java.util.Vector;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.TreeItem;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.rss.dom.RssChannel;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.publisher.action.MenuDomainEvent;
import org.vietspider.veis.impl.ui.publisher.action.MenuDomainListener;
import org.vietspider.veis.impl.ui.publisher.action.RSSSaveEvent;
import org.vietspider.veis.impl.ui.publisher.action.RSSSaveListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 26, 2005
 */
public class RSSAction extends RSSViewer {
  
  protected Vector<MenuDomainListener> lRSS; 
  
  
  protected String path = "", title = "";
  
  public RSSAction(ApplicationFactory factory,Composite parent, int style) {
    super( factory, parent, style);
    
    lRSS = new Vector<MenuDomainListener>();    
  }
  
  protected void newRSS(){   
    RSSDialogViewer dialog = new RSSDialogViewer( this.getShell());
    dialog.addSaveListener( new RSSSaveListener(){
      public void save( RSSSaveEvent evt){
        try{
          load();
        }catch( Exception exp){
          exp.printStackTrace();
        }
      }
    });
  }
  
  protected void viewRSS(){   
    RSSDialogViewer dialog = new RSSDialogViewer( this.getShell());
    dialog.setData( this.path);
    dialog.addSaveListener( new RSSSaveListener(){
      public void save( RSSSaveEvent evt){
        try{
          load();
        }catch( Exception exp){
          exp.printStackTrace();
        }
      }
    });
  }
  
//implement listener for rss tree
  
  public void fireRSSEvent( MenuDomainEvent e) {
    synchronized(lRSS)  {      
      for(int i = 0; i < lRSS.size(); i++){
        try{
          MenuDomainListener listener = lRSS.get(i);
          listener.selected(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addRSSListener( MenuDomainListener listener) {     
    synchronized(lRSS) {     
      lRSS.remove(listener);
      lRSS.add(listener);
    }
  }
  public void removeRSSListener( MenuDomainListener listener) {
    synchronized(lRSS) {
      lRSS.remove(listener);
    }
  }
  public void selected( MenuDomainEvent ev) {    
    if(ev.getPath() == null || ev.getPath().equals("")) return;      
    fireRSSEvent(ev);     
  } 
  protected void elementDomainSelected(){
    TreeItem [] items = this.treeRSS.getSelection();    
    if( items == null  || items.length < 1) return;
    TreeItem item = items[0];   
    if( item.getParentItem() == null) return;    
    try{
      UtilFile util = new UtilFile();    
      String folder = util.getFolder("data.rss") ;    
      UtilConvert convert = new UtilConvert();      
      this.path = folder + File.separator + convert.enUnicode( item.getParentItem().getText())
             + File.separator + convert.enUnicode( item.getText());
      this.title ="RSS / "+item.getParentItem().getText()+" / "+item.getText();
      MenuDomainEvent event = new MenuDomainEvent( this.path, 1);
      fireRSSEvent(event);      
    }catch( Exception exp){
      exp.printStackTrace();
    }    
  }  

  protected String getContent( RssChannel channel){
    return "";
  }  
  
  protected RssChannel getChannel( String path){
    return null;
  }  
}
