/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.MessageBox;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.local.StoreFolder;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 26, 2005
 */
public class Store extends StoreAction {

  public Store(ApplicationFactory factory, Composite parent, int style) {
    super(factory, parent, style); 
    loadStore();
  }
  
  protected void loadStore(){
    try{
      StoreFolder store = new StoreFolder();  
      String[] files = store.getDomain();
      UtilConvert convert = new UtilConvert();
      for( int i=0; i<files.length; i++){
        files[i] = convert.deUnicode( files[i]);
      }
      this.lstStore.setItems( files);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void deleteStore(){
    MessageBox msg = new MessageBox ( this.getShell(), SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);  
    ResourceManager resource = new ResourceManager( "veis");  
    msg.setMessage (resource.getLabel( this.getClass().getName()+".msgStoreDelete"));
    if(msg.open() == SWT.NO) return;  
    String folder = this.getStoreSelected();
    UtilFile util = new UtilFile();
    util.deleteFolder( folder);
    this.loadStore();    
  }

}
