/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.forms.widgets.Section;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 26, 2005
 */
public class StoreViewer  extends Composite {
  
  protected List lstStore; 
  protected Section sectionStore; 

  public StoreViewer(ApplicationFactory factory, Composite parent, int style) {
    super( parent, style);
    
    factory.setClassName( this.getClass().getName());
    
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;   
    this.setLayout( gridLayout);
    
    sectionStore = new Section( this, Section.TWISTIE | Section.TITLE_BAR );    
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);        
    gridData.horizontalSpan = 1;    
    sectionStore.setLayoutData(gridData);  
    sectionStore.setLayout( new FillLayout());
    sectionStore.setText( factory.getLabel( "sectionStore"));
    sectionStore.setFont(new Font( this.getDisplay(), "Tahoma", 11, SWT.NORMAL));
    sectionStore.setForeground( new Color( this.getDisplay(), 26, 140, 255));    
    
    sectionStore.setTitleBarForeground(  new Color( this.getDisplay(), 26, 140, 255));
    sectionStore.setTitleBarGradientBackground( new Color( this.getDisplay(), 255, 255, 255));
    sectionStore.setTitleBarBackground( new Color( this.getDisplay(), 200, 200, 200));
       
    Composite composite = new Composite ( sectionStore, SWT.NONE);    
    composite.setLayout( new FillLayout());
    //composite.setBackground( new Color( this.getDisplay(), 255, 255, 255));
    lstStore = factory.createList( composite, SWT.SINGLE | SWT.CENTER | SWT.BORDER);
    lstStore.setForeground( new Color( this.getDisplay(), 0, 64, 64));
    lstStore.setFont(new Font( this.getDisplay(), "Times New Roman", 12, SWT.NORMAL));
    lstStore.setToolTipText( factory.getLabel( "lblStore"));   
    lstStore.addListener(SWT.Selection, new Listener() {
      public void handleEvent(Event e) {
        storeData();
      }          
    }); 
    sectionStore.setClient( composite);  
    
    Menu menu = new Menu ( this.getShell(), SWT.POP_UP);
    
    factory.createMenuItem( menu, "itemStoreUpdate", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        loadStore();      
      }      
    });  
    
    factory.createMenuItem( menu, "itemStoreDelete", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        deleteStore();   
      }      
    });    
    this.lstStore.setMenu( menu);
  }
  
  protected void storeData(){}
  
  protected void loadStore(){}
  
  public String getStoreSelected(){
    try{      
      if( this.lstStore.getItemCount() < 1) return "";
      String name = this.lstStore.getSelection()[0];
      if( name == null || name.equals("")) return "";
      name = name.trim();
      UtilFile util = new UtilFile();     
      UtilConvert convert = new UtilConvert();
      return util.getFolder("data.store."+convert.enUnicode( name)) ;      
    }catch( Exception exp){
      exp.printStackTrace();
      return "";
    }
  }  
  
  protected void deleteStore(){}   
}
