/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.resources;

import java.io.InputStream;
import java.util.Locale;
import java.util.ResourceBundle;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.widgets.Display;
import org.vietspider.veis.impl.core.io.local.SystemProperties;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 12, 2005
 */
public class ResourceManager {

  private ResourceBundle  resources;
  
  public ResourceManager(){
    
  }
  
  public ResourceManager( String name){    
    ClassLoader cl = Thread.currentThread().getContextClassLoader() ;
    String locale = "en";
    try{
      SystemProperties pr = new SystemProperties();
      locale = pr.get("locale");
      if( locale==null || locale.trim().equals("")){        
        locale = "en";
        pr.set("locale",locale);
      }
    }catch( Exception exp){
      exp.printStackTrace();
      locale = "en";
    }  
    this.resources = ResourceBundle.getBundle("resources.i18n."+locale+"."+name, Locale.ENGLISH, cl); 
  }
  public String getLabel( String name){
    try{
      return this.resources.getString( name);
    }catch( Exception exp){
      return null;
    }
  }
  
  public Image load( Display dis ,String name){
    try{
      ClassLoader cl = Thread.currentThread().getContextClassLoader() ;
      InputStream input = cl.getResourceAsStream("resources/images/" + name) ;      
      ImageData imgData = new ImageData( input);      
      return new Image( dis, imgData);
    }catch( Exception exp){
      exp.printStackTrace();
      return null;
    }
  }
  
  public InputStream load( String name){
    try{
      ClassLoader cl = Thread.currentThread().getContextClassLoader() ;
      return cl.getResourceAsStream("resources/" + name) ;     
    }catch( Exception exp){
      exp.printStackTrace();
      return null;
    }
  }
}
