package org.vietspider.veis.impl.ui.spider;

import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.vietspider.veis.impl.ui.spider.action.FavoritesInputEvent;
import org.vietspider.veis.impl.ui.spider.action.FavoritesInputListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

public class FavoritesInputViewer {
	
	private Shell shell;
	private Text text;
	private Vector<FavoritesInputListener> listeners2;
	private int s;

	public FavoritesInputViewer(Shell parent, int s){
		shell = new org.eclipse.swt.widgets.Shell( parent);
		shell.setLocation( parent.getLocation().x+150, parent.getLocation().y+50);		
		shell.setLayout( null);
		
		listeners2 = new Vector<FavoritesInputListener>();
		this.s = s;
    
    ApplicationFactory factory = new ApplicationFactory( shell, this.getClass().getName());
		
		factory.createLabel( SWT.LEFT | SWT.WRAP, "lblDes").setBounds( 10, 10, 270, 60);
		
		text = factory.createText();
    text.setBounds( 10, 80, 270, 25);
		
		factory.createButton( "butOk", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        createdInputAction(1);     
      }   
    }).setBounds( 10, 120, 120, 25);  
    
    factory.createButton( "butCancel", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        createdInputAction(0);   
      }   
    }).setBounds( 150, 120, 120, 25);
		
		shell.setSize( 300, 200);		
		shell.open();
	}
	//intput
	public void fireInputEvent( FavoritesInputEvent e) {
		 synchronized(listeners2)  {
		    for(int i = 0; i < listeners2.size(); i++){
			  try{
				  FavoritesInputListener listener = listeners2.get(i);
		          listener.input(e);
				 break;
			  }catch(Exception exp){               	  
			  }       
			}
		 }
	}
	public void addInputListener(  FavoritesInputListener listener) {    	
		synchronized(listeners2) {
			listeners2.remove(listener);
			listeners2.add(listener);
	    }
	}
	public void removeInputListener(  FavoritesInputListener listener) {
	   synchronized(listeners2) {
	        listeners2.remove(listener);
	   }
	}
	public void input (FavoritesInputEvent ev) {	    		 
	   fireInputEvent(ev);	   
	}	
	public void createdInputAction(int r)  {
		FavoritesInputEvent e = new FavoritesInputEvent( this.text.getText(), this.s, r);
		fireInputEvent(e);
		this.shell.dispose();
	}		

}
