package org.vietspider.veis.impl.ui.spider;

import java.io.File;
import java.util.Calendar;
import java.util.Locale;
import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.TableItem;
import org.vietspider.veis.impl.core.crawler.AgentConfig;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.filter.HtmlFilter;
import org.vietspider.veis.impl.core.io.local.FavoritesCollection;
import org.vietspider.veis.impl.core.io.local.LoadCollection;
import org.vietspider.veis.impl.core.io.local.SystemProperties;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.core.text.html.Document;
import org.vietspider.veis.impl.core.text.html.DocumentProcessor;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.spider.action.AgentAddEvent;
import org.vietspider.veis.impl.ui.spider.action.AgentAddListener;
import org.vietspider.veis.impl.ui.spider.action.FavoritesAddEvent;
import org.vietspider.veis.impl.ui.spider.action.FavoritesAddListener;
import org.vietspider.veis.impl.ui.spider.action.FavoritesInputEvent;
import org.vietspider.veis.impl.ui.spider.action.FavoritesInputListener;
import org.vietspider.veis.impl.ui.spider.action.FavoritesSaveEvent;
import org.vietspider.veis.impl.ui.spider.action.FavoritesSaveListener;
import org.vietspider.veis.impl.ui.widget.action.DialogInputEvent;
import org.vietspider.veis.impl.ui.widget.action.DialogInputListener;

public class SpiderImpl extends SpiderViewer {
  
  int current_thread = 0;
  
  public SpiderImpl(Display display){
    super( display);     
  }  
  public void setImage( Image img){
    this.shell.setImage( img);
  }
  protected void configLoadResource(){
    try{
      SystemProperties properties = new SystemProperties();
      Properties p = properties.get();
      if( p.getProperty("LOAD_RESOURCES") == null || p.getProperty("LOAD_RESOURCES").trim().equals("")){ 
        AgentConfig.LOAD_RESOURCES = true;
        properties.set( "LOAD_RESOURCES", "true");
      } else{
        AgentConfig.LOAD_RESOURCES = false;
        properties.set( "LOAD_RESOURCES", "");
      }
    }catch( Exception exp){
      exp.printStackTrace();
    }   
  }
  
  protected void configRemoveScript(){
    try{
      SystemProperties properties = new SystemProperties();
      Properties p = properties.get();
      if( p.getProperty("REMOVE_SCRIPT") == null || p.getProperty("REMOVE_SCRIPT").trim().equals("")){ 
        AgentConfig.REMOVE_SCRIPT = true;
        properties.set( "REMOVE_SCRIPT", "true");
      } else{
        AgentConfig.REMOVE_SCRIPT = false;
        properties.set( "REMOVE_SCRIPT", "");
      }
    }catch( Exception exp){
      exp.printStackTrace();
    }   
  }
  
  protected void configSaveThread(){
    try{
      SystemProperties properties = new SystemProperties();
      Properties p = properties.get();
      if( p.getProperty("SAVE_ORDER") == null || p.getProperty("SAVE_ORDER").trim().equals("")){ 
        AgentConfig.SAVE_ORDER = true;
        properties.set( "SAVE_ORDER", "true");
      } else{
        AgentConfig.SAVE_ORDER = false;
        properties.set( "SAVE_ORDER", "");
      }
    }catch( Exception exp){
      exp.printStackTrace();
    }   
  }
  
  protected void setSpeed(){
    SpeedInputViewer speed = new SpeedInputViewer( this.shell);    
    speed.addListener( new DialogInputListener(){
      public void entered( DialogInputEvent evt){
        setSpeed( evt.getText());
      }
    });
  }
  
  private void setSpeed( String value){
    try{
      int iv = Integer.parseInt( value);
      if( iv < 1 && iv > 10 ) iv = 3;
      SystemProperties properties = new SystemProperties();
      properties.set("TOTAL_THREAD", String.valueOf( iv));
      MessageBox message = new MessageBox( this.shell, SWT.YES );
      ResourceManager resource = new ResourceManager( "veis");
      message.setMessage ( resource.getLabel( this.getClass().getName()+".msgAlertSpeed"));     
      message.open();
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  
  public void dispose(){
    this.shell.dispose();
  }  
  public boolean isDispose(){
    return this.shell.isDisposed();
  }
  public void show(){
    this.shell.setVisible( true);
  }  
  public void changeThread(){
    AgentConfig.CHANGE_THREAD = this.table.getSelectionIndex();
  }
  
  protected void loadAgent(){		
    try{			
      String[] names = ( new LoadCollection()).getAllAgent( null);
      TableItem [] item = new TableItem[ names.length];		   
      table.removeAll();
      UtilConvert convert = new UtilConvert();
      for( int i=0; i< names.length; i++){
        names[i] = convert.deUnicode( names[i]).replaceAll(".properties","");		   	  
        item[i] = new TableItem( table, SWT.NONE);
        item[i].setFont(new Font( table.getDisplay(), "Tahoma", 9, SWT.NORMAL));
        item[i].setText( 0, String.valueOf(i+1));
        item[i].setText( 1, names[i]);
        
      }
    }catch(Exception exp){
      exp.printStackTrace();
    }
  }
  protected void addAgent(){		
    AgentAddViewer add = new AgentAddViewer( this.table.getShell());
    add.addAddListener( new AgentAddListener(){
      public void add( AgentAddEvent evt){
        loadAgent();
      }
    });
  }
  protected void removeAgent(){
    TableItem[] items = this.table.getSelection();
    LoadCollection load = new LoadCollection();
    UtilConvert convert = new UtilConvert();    
    try{
      for( TableItem item : items)
        load.delAgent( convert.enUnicode(item.getText( 1)));      
      loadAgent();
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void removeAll(){
    saveFavorites( 1);
  }
  protected void favorite(){   
    FavoritesViewer fav = new FavoritesViewer( this.table.getShell());
    fav.addSaveListener( new FavoritesSaveListener(){
      public void save( FavoritesSaveEvent evt){
        saveFavorites( 0);       
      }
    });
    fav.addAddListener( new FavoritesAddListener(){
      public void add( FavoritesAddEvent evt){        
        addFavorites( evt.getDomain());        
      }
    });
  }
  private void saveFavorites(int s){    
    FavoritesInputViewer input = new FavoritesInputViewer( this.table.getShell(), s);
    input.addInputListener( new FavoritesInputListener(){
      public void input( FavoritesInputEvent evt){        
        saveFavorites( evt.getDomain(), evt.getStyle(), evt.getReturn());
      }
    });		
  }
  private void saveFavorites(String domain, int s, int r){	
    try{           
      if( r == 1)
        (new FavoritesCollection()).setAgent( ( new UtilConvert()).enUnicode(domain));     
      if( s == 1){
        ( new LoadCollection()).removeAll();
        loadAgent();
      }
    }catch( Exception exp){
      exp.printStackTrace();
    }		
  }
  private void addFavorites( String domain){
    try{    
      domain = ( new UtilConvert()).enUnicode( domain);		
      ( new FavoritesCollection()).setBackAgent( domain);
      this.loadAgent();
    }catch(Exception exp){
      exp.printStackTrace();
    }
  }
  protected void showData(){
    TableItem [] items = table.getSelection();
    if( items.length < 1) return;
    TableItem item = items[0];
    Calendar cal=Calendar.getInstance(Locale.FRANCE);     
    String path = String.valueOf(cal.get(Calendar.YEAR))+"_"
    +String.valueOf(cal.get(Calendar.MONTH)+1)+"_"
    +String.valueOf(cal.get(Calendar.DATE))+"."+( new UtilConvert()).enUnicode(item.getText(1));
    try{       
      showData( (new UtilFile()).getFolder("data.web."+path));
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  private void showData(String path){		
    try{		      
      UtilFile util = new UtilFile();
      File [] files = util.list( path, new HtmlFilter());          
      if ( files == null || files.length < 0) {
        this.browser.setText("");
        return;
      }
      String html = "<html><body>"
        + "<STYLE TYPE=\"text/css\">"
        + "a:hover { COLOR: #ff6600 } a:visited { COLOR: #84689d }"
        + ".Title {FONT-SIZE: 11pt; COLOR: darkblue; FONT-FAMILY: Arial }"				          
        + ".Number { FONT-SIZE: 10pt; COLOR: #003399; FONT-FAMILY: Arial }"
        + ".Time { FONT-SIZE: 8pt; COLOR: #003399; FONT-FAMILY: Tahoma }"
        + "</style>"
        + "<table border =\"0\" cellSpacing=\"0\" cellPadding=\"0\" bordercolor=\"#99CCFF\" style=\"border-collapse:collapse\">"
        ;
      Document doc;
      DocumentProcessor docProcessor = new DocumentProcessor();
      NodeProcessor nodeProcessor = new NodeProcessor();
      for( int i=0; i< files.length ; i++){					 
        doc = new Document( files[ i], null);				 
        String title = docProcessor.getTitle( doc.getTag());
        
        String address = files[i].toURL().toString(); 
        address = address.replaceAll("\\ ", "\\%20");
        
        String split[] = nodeProcessor.getText( doc.getTag()).toString().split("--");			 
        String source = "";
        if( split.length > 2) source = split[1];
        
        String time =  files[ i].getName();
        time = time.replaceAll("\\_","\\:");
        time = time.replaceAll(".htm","");        
        html += "<tr><td class=\"number\">"
          + "<b>"+String.valueOf( files.length -i)+"</b>&nbsp;&nbsp;"
          +"</td>"
          +"<td height=\"24\">"
          + "<a class=\"title\" href=\""+address
          +"\" target=\"_blank\" style=\"text-decoration:none\">"
          + title +"</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
          +"</td>"
          +"<td class=\"time\">"				      
          + "<a class=\"number\" href=\""+source
          +"\" target=\"_blank\" style=\"text-decoration:none\"> "
          +time+"</a>"
          + "</td></tr>";				
      }  
      html += "</table></body></html>"; 
      this.browser.setText( html);		    
    }catch(Exception exp){
      exp.printStackTrace();
    }
  }		
  public void setStatusLoding( String status, int id){
    if( this.lbl[id].isDisposed()) return;
    if( status == null) return;
    this.lbl[ id].setText( status);   
    if( current_thread != AgentConfig.CURRENT_THREAD){     
      try{        
        if( current_thread >= this.table.getItemCount()) return;
        TableItem  item = this.table.getItem( current_thread);
        item.setForeground( new Color( item.getDisplay(), 0, 0, 0));
        current_thread = AgentConfig.CURRENT_THREAD;      
        if( current_thread >= this.table.getItemCount()) return;
        item = this.table.getItem( current_thread);
        item.setForeground( new Color( item.getDisplay(), 0, 0, 255));
      }catch( Exception exp){
        exp.printStackTrace();
      }
    }
  }
  
  public void setProxy(){
    new ProxyViewer( this.shell);
  }
}
