/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.spider;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tray;
import org.eclipse.swt.widgets.TrayItem;
import org.vietspider.veis.Spider;
import org.vietspider.veis.impl.core.crawler.AgentConfig;
import org.vietspider.veis.impl.core.crawler.ServiceRun;
import org.vietspider.veis.impl.ui.publisher.PublisherImpl;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;
import org.vietspider.veis.impl.ui.widget.ImageLoader;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 20, 2005
 */
public class SpiderService {

  private TrayItem trayItem;
  private SpiderImpl window;
  private Display display;
  private ServiceRun service;
  
  public Tray tray;
   
  public SpiderService() throws Exception {    
    display = Display.getDefault();   
    Image image = (new ImageLoader()).load( display, "vsicon.ico");   
    tray = display.getSystemTray();        
    trayItem = new TrayItem(tray, SWT.NONE); 
    trayItem.setImage( image);  
    trayItem.setVisible(true);     
    trayItem.addListener(SWT.Selection, new Listener(){ 
      public void handleEvent(Event evt){ 
        showWindow();
      } 
    });        
    trayItem.setImage(image);   
    Shell shell = new Shell( tray.getDisplay());
    
    ApplicationFactory factory = new ApplicationFactory( shell, this.getClass().getName());
    
    final Menu menu = new Menu ( shell, SWT.POP_UP);
    factory.createMenuItem( menu, "itemExit", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        System.exit( -1);  
      }   
    });
    
    new MenuItem (menu, SWT.SEPARATOR);
    
    factory.createMenuItem( menu, "itemShowSpider", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        showWindow();
      }   
    });
    
    factory.createMenuItem( menu, "itemShowConfig", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        new org.vietspider.veis.impl.ui.config.AgentConfig(); 
      }   
    });
    
    factory.createMenuItem( menu, "itemShowPublisher", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        runProgram(  "publisher.exe");
      }   
    });
        
    trayItem.addListener (SWT.MenuDetect, new Listener () {
      public void handleEvent (Event event) {
        menu.setVisible (true);
      }
    });
   
    service = new ServiceRun();    
  }
  
  public void showWindow(){
    if( window != null){
      window.dispose();     
    }
    window = new SpiderImpl( this.display);
    window.setImage( this.trayItem.getImage());
  }
  
  public void setStatus(){    
    this.trayItem.setToolTipText( service.getStatus( 0));    
    if( window != null && !window.isDispose()){      
      for( int i=0; i<AgentConfig.TOTAL_THREAD; i++){
        window.setStatusLoding( service.getStatus( i), i);        
      }      
    }else if(window != null && window.isDispose()){
      window = null;
    }
  }
  
  protected void runProgram( String name){
    File file = new File( name);   
    try{    
      if( file.exists()){
        ProcessBuilder pro = new ProcessBuilder( name);
        pro.start();
      }else{
        if( name.indexOf("spider")> -1) new Spider();
        if( name.indexOf("publisher")> -1) new PublisherImpl();
      }
    }catch(Exception exp){
      if( name.indexOf("spider")> -1)
        try{
          new Spider();
        }catch( Exception e){}    
        if( name.indexOf("publisher")> -1) new PublisherImpl();
        exp.printStackTrace();
    }     
  }  
}
