/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.ui.forms.events.IHyperlinkListener;
import org.eclipse.ui.forms.widgets.ImageHyperlink;
import org.vietspider.veis.impl.ui.resources.ResourceManager;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 13, 2005
 */
public class ApplicationFactory extends UIFactory {
  
  private String CLASS_NAME ;
  
  private ResourceManager resource;

  public ApplicationFactory(Composite composite, String name) {
    super(composite);    
    this.CLASS_NAME = name;   
    resource = new ResourceManager( "veis");
  }
  
  public ApplicationFactory( Display display, Class cl, int w, int h) {
    super( null);    
    resource = new ResourceManager( "veis");
    this.CLASS_NAME = cl.getName();
    this.composite = this.createShell( display, cl,
        resource.getLabel( this.CLASS_NAME+".title"), "vsicon.ico", w, h);   
  }
  
  public void setClassName( String name){
    this.CLASS_NAME = name;
  }
  
  public String getClassName(){
    return this.CLASS_NAME;
  }
  
  public Button createButton( String name){
    return super.createButton( this.composite, SWT.PUSH, 
        resource.getLabel( this.CLASS_NAME+"."+name));   
  } 
  
  public Button createButton( String name,SelectionListener listener){
    if( resource.getLabel( this.CLASS_NAME+"."+name+"Tip") != null){
      return super.createButton( this.composite, SWT.PUSH, 
          resource.getLabel( this.CLASS_NAME+"."+name),
          resource.getLabel( this.CLASS_NAME+"."+name+"Tip"), listener);   
    }
    return super.createButton( this.composite, SWT.PUSH, 
        resource.getLabel( this.CLASS_NAME+"."+name), listener);   
  }
  
  public ImageHyperlink createIcon( String name, IHyperlinkListener listener){
    Image img = resource.load(
          composite.getDisplay(), resource.getLabel( this.CLASS_NAME+"."+name+"Image"));
    Image img1 = resource.load(
        composite.getDisplay(), resource.getLabel( this.CLASS_NAME+"."+name+"Image1"));
    return super.createIcon( 
        SWT.PUSH, img, img1, resource.getLabel( this.CLASS_NAME+"."+name+"Tip"), listener);
  
  }
  
  public Label createLabel( String name){    
    return super.createLabel( resource.getLabel( this.CLASS_NAME+"."+name));
  }  
  
  public Label createLabel( int style, String name){
    return super.createLabel( style, resource.getLabel( this.CLASS_NAME+"."+name));
  }  
  
  public Group createGroup( String name, Object layoutData, Layout layout){
    return super.createGroup( resource.getLabel( this.CLASS_NAME+"."+name), layoutData, layout);
  }
  
  public Table createTable( String name, SelectionListener listener){
    String value = resource.getLabel( this.CLASS_NAME+"."+name+"Columns");
    String [] cols = value.split(",");
    value = resource.getLabel( this.CLASS_NAME+"."+name+"ColumnWidths");
    String [] split = value.split(",");
    int [] w = new int[ split.length];
    for( int i=0; i<w.length; i++){
      w[i] = Integer.parseInt( split[i]);
    }
    return super.createTable( cols, w, listener);
  }
  
  public Combo createCombo(SelectionListener listener){
    Combo combo = super.createCombo( SWT.READ_ONLY);
    combo.addSelectionListener( listener);
    return combo;
  }
  
  public Menu createMenu( Menu menu, String name){
    return super.createMenu( menu, resource.getLabel( this.CLASS_NAME+"."+name));    
  }
  
  public MenuItem createMenuItem( Menu menu, String name){
    return super.createMenuItem( menu, resource.getLabel( this.CLASS_NAME+"."+name));    
  }
  
  public MenuItem createMenuItem( Menu menu, String name, SelectionListener listener){
    return super.createMenuItem( menu, resource.getLabel( this.CLASS_NAME+"."+name), listener);   
  }
  
  public MenuItem createMenuItem( Menu menu, int style, String name, SelectionListener listener){
    return super.createMenuItem( menu, style,resource.getLabel( this.CLASS_NAME+"."+name), listener);   
  }
  
  public MenuItem createMenuItem( Menu menu, String name, String img, SelectionListener listener){
    MenuItem  item = 
      super.createMenuItem( menu, resource.getLabel( this.CLASS_NAME+"."+name), listener);
    item.setImage( resource.load( this.composite.getDisplay(), img));
    return item;
  }
  
  public MenuItem createMenuItem( Menu menu, int style, String name, String img, SelectionListener listener){
    MenuItem  item =
      super.createMenuItem( menu, style,resource.getLabel( this.CLASS_NAME+"."+name), listener);
    item.setImage( resource.load( this.composite.getDisplay(), img));
    return item;  
  }
  
  public Menu createToolItem( final ToolBar bar, String img ){
    return super.createToolItem( bar, resource.load( bar.getDisplay(), img));
  }
  
  public String getLabel(String key){
    return this.resource.getLabel( this.CLASS_NAME+"."+key);
  } 

}
