package org.vietspider.veis.impl.ui.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.browser.ProgressAdapter;
import org.eclipse.swt.browser.ProgressEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;

public class HtmlViewer {
  
  private Shell shell;	
  private ProgressBar progressBar ;	
  protected Browser browser;	
  private boolean busy;
  protected int index;		
  
  
  public HtmlViewer( Shell parent){		
    shell = new Shell( parent, SWT.MAX);	
    shell.setImage( parent.getImage());
    shell.setLocation( parent.getLocation().x+20, parent.getLocation().y+10);    
    
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;
    shell.setLayout( gridLayout);	    
    
    browser = new Browser( shell, SWT.BORDER);	    
    GridData gridData = new GridData( GridData.FILL_BOTH);
    browser.setLayoutData(gridData);
    browser.addProgressListener(new ProgressAdapter(){		
      public void changed(ProgressEvent event){		 		
        if(event.total == 0) return;				
        int ratio = event.current * 100 / event.total;
        progressBar.setSelection(ratio);
        busy = event.current != event.total;
        if(!busy) index = 0;				
      }
      public void completed(ProgressEvent event){		
        progressBar.setSelection(0);
        busy = false;
        index = 0;	
        return;	
      }
    });
    
    
    progressBar =  new ProgressBar( shell, SWT.NONE);
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    progressBar.setLayoutData(gridData);
    
    shell.setSize( 750,520);
    shell.open();	   
  }	
  public void setUrl( String url){
    this.browser.setUrl( url);
  }
  public String getUrl( String url) {
    return this.browser.getUrl();
  }
  public void setText(String html) {
    this.browser.setText( html);
  }
}
