/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.core;

import java.security.AccessControlException;
import java.util.Map;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.access.AccessControlList;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: ExtendedNode.java 3510 2005-12-29 17:32:57Z geaz $
 */

public interface ExtendedNode extends Node {

  void setChildrenPermissions(Map permissions) throws RepositoryException, AccessControlException;

  AccessControlList getChildrenACL();

  void clearChildrenACL() throws RepositoryException, AccessControlException;
  
  void removeChildrenPermission(String identity) throws RepositoryException, AccessControlException;
  
  void setChildrenPermission(String identity, String[] permission) throws RepositoryException, AccessControlException;
  
  void checkChildrenPermission(String actions) throws AccessControlException, RepositoryException; 
}