/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.exo;


import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeDefinition;


import javax.jcr.PropertyType;
import javax.jcr.Value;

import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.value.LongValue;
import org.exoplatform.services.jcr.impl.core.value.StringValue;

import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.RepositoryException;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: NamespaceType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class NamespaceType extends NodeTypeImpl {

  public NamespaceType(NodeTypeManager manager) throws NoSuchNodeTypeException,RepositoryException {
    super(manager);
    this.name = "exo:namespace";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinition[2];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "exo:prefix",                 //name
        this,                         //declaringNodeType
        PropertyType.STRING,          //requiredType
        null,                         //valueConstraints
        null,                         //defaultValues
        false,                        //autoCreate
        true,                         //mandatory
        OnParentVersionAction.COPY,   //onVersion        
        true,                        //readOnly
        false                         //multiple
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "exo:uri",                    //name
        this,                         //declaringNodeType
        PropertyType.STRING,          //requiredType
        null,                         //valueConstraints 
        null,                         //defaultValues
        false,                        //autoCreate
        true,                         //mandatory
        OnParentVersionAction.COPY,   //onVersion        
        true,                         //readOnly
        false                         //multiple
        );

  }

}
