/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeDefinition;


import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: FileType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class FileType extends NodeTypeImpl {

  public FileType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:file";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = "jcr:content";
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:hierarchyNode");
    this.declaredChildNodeDefinitions = new NodeDefinition[1];
    NodeType[] types = {manager.getNodeType("nt:base")};

    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        "jcr:content",                 // name             
        this,                          // declaringNodeType
        types,                         // requiredNodeTypes
        null,                          // defaultNodeType  
        false,                         // autoCreate       
        true,                          // mandatory        
        OnParentVersionAction.COPY,    // onVersion        
        false,                         // protected        
        false                         // same-name sibling
        );

  }

}
