/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.nodetype.*;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;

/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 31 juil. 2004
 */
public class VersionHistoryType extends NodeTypeImpl {

  public VersionHistoryType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:versionHistory";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new javax.jcr.nodetype.NodeType[2];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredSupertypes[1] = manager.getNodeType("mix:referenceable");
    this.declaredChildNodeDefinitions = new NodeDefinition[3];
    this.declaredPropertyDefinitions = new PropertyDefinition[1];
    
    NodeType[] types = {manager.getNodeType("nt:version")};

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
            "jcr:versionableUuid",                   //name
            this,                            //declaringNodeType
            PropertyType.STRING,               //requiredType     
            EMPTY_CONSTRAINTS,              //valueConstraints
            null,                     //defaultValues
            true,                            //autoCreate       
            true,                            //mandatory        
            OnParentVersionAction.ABORT,     //onVersion        
            true,                            //readOnly         
            false                            //multiple         
            );
   
    
    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        "jcr:rootVersion",              // name
        this,                           // declaringNodeType
        types,                          // requiredNodeTypes
        manager.getNodeType("nt:version"), // defaultNodeType
        true,                           // autoCreate       
        true,                           // mandatory        
        OnParentVersionAction.ABORT,    // onVersion        
        true,                           // protected        
        false                           // same-name sibling
        );
    
    NodeType[] types1 = {manager.getNodeType("nt:versionLabels")};
    this.declaredChildNodeDefinitions[1] = new NodeDefinitionImpl(
        "jcr:versionLabels",              // name
        this,                             // declaringNodeType
        types1,                          // requiredNodeTypes
        manager.getNodeType("nt:versionLabels"),                    // defaultNodeType
        true,                           // autoCreate
        true,                           // mandatory
        OnParentVersionAction.ABORT,    // onVersion
        true,                           // protected
        false                           // same-name sibling
        );

    this.declaredChildNodeDefinitions[2] = new org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl (
        ItemDefinitionImpl.RESIDUAL_SET,       // name
        this,
        types,
        manager.getNodeType("nt:version"),
        false,
        false,
        OnParentVersionAction.ABORT,
        true,
        false
       );
  }
}
