/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.observation;

import java.util.HashMap;
import java.util.Map;

import javax.jcr.RepositoryException;
import javax.jcr.observation.EventListener;
import javax.jcr.observation.EventListenerIterator;

import org.exoplatform.services.jcr.impl.core.SessionImpl;
import org.exoplatform.services.jcr.impl.core.WorkspaceDataManager;
import org.exoplatform.services.jcr.impl.util.EntityCollection;
import org.exoplatform.services.log.LogService;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: ObservationManagerRegistry.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class ObservationManagerRegistry {

  protected Map listenersMap;
  
  protected ActionLauncher launcher;
  
  private LogService logService;

  public ObservationManagerRegistry(LogService logService, 
      WorkspaceDataManager workspaceDataManager) {
    
    this.logService = logService;
    this.listenersMap = new HashMap();
    this.launcher = new ActionLauncher(this, logService, workspaceDataManager);

  }
  
  public ObservationManagerImpl createObservationManager(SessionImpl session) {
    return new ObservationManagerImpl(this, session, logService);
  }

  public void addEventListener(EventListener listener, ListenerCriteria filter) 
  throws RepositoryException {
    listenersMap.put(listener, filter);
  }
  
  public void removeEventListener(EventListener listener) throws RepositoryException {
    listenersMap.remove(listener);
  }
  
  public EventListenerIterator getEventListeners() {
    return new EntityCollection(listenersMap.keySet());
  }

  public ListenerCriteria getListenerFilter(EventListener listener) {
    return (ListenerCriteria) listenersMap.get(listener);
  }

}
