/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.storage;

import org.exoplatform.services.jcr.datamodel.InternalQName;
import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.MutableItemData;
import org.exoplatform.services.jcr.datamodel.NodeData;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TransientItemData.java 3510 2005-12-29 17:32:57Z geaz $
 */

/**
 * Encapsulates common part of Node and Property data.
 */
public abstract class TransientItemData implements MutableItemData {

  protected InternalQPath QPath;

  protected String UUID;

  protected String parentUUID;
  
  protected int persistedVersion;

  /**
   * @clientCardinality 0..* 
   */
  protected NodeData parent;

  TransientItemData(InternalQPath path, String uuid, int version, String parentUUID) {
    this.parentUUID = parentUUID; 
    this.QPath = path;
    this.UUID = uuid;
    this.persistedVersion = version;
    //        this.persisted = persisted;
  }

  public InternalQPath getQPath() {
    return QPath;
  }

  public InternalQName getQName() {
    return QPath.getName();
  }

  public String getUUID() {
    return UUID;
  }

  public boolean isPersisted() {
    return (persistedVersion != -1);
  }

  public int getPersistedVersion() {
    return persistedVersion;
  }

  public NodeData getParent() {
    return parent;
  }

  public String getParentUUID() {
    //if(parent == null)  // root
    //  return null;
    //else
    return parentUUID;
  }

  // Mutable
  //public void setPersistedVersion(int version) {
  //  this.persistedVersion = version;
  //}
  //public void setParent(NodeData parent) {
  //	this.parent = parent;
  //}

}