/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.storage;

/**
 * Created by The eXo Platform SARL        .
 * <br>
 * Newly added Node's data (used for mock inmemory repository as well). 
 * Besides NodeData's methods includes child items adders
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TransientNodeData.java 3510 2005-12-29 17:32:57Z geaz $
 */

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.services.jcr.access.AccessControlList;
import org.exoplatform.services.jcr.datamodel.InternalQName;
import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.MutableNodeData;
import org.exoplatform.services.jcr.datamodel.NodeData;
import org.exoplatform.services.jcr.datamodel.PropertyData;

public class TransientNodeData extends TransientItemData implements Comparable,
    MutableNodeData {

  private List nodes;

  private List properties;

  private InternalQName primaryTypeName;

  private InternalQName[] mixinTypeNames;

  private int orderNum;

  private AccessControlList acl;

  public TransientNodeData(InternalQPath path, String uuid, int version,
      InternalQName primaryTypeName, InternalQName[] mixinTypeNames,
      int orderNum, String parentUUID) {
    super(path, uuid, version, parentUUID);
    this.primaryTypeName = primaryTypeName;
    this.mixinTypeNames = mixinTypeNames;
    this.nodes = new ArrayList();
    this.properties = new ArrayList();
    this.orderNum = orderNum;
    //this.acl = acl;
    this.nodes = new ArrayList();
    this.properties = new ArrayList();
  }

  public List getChildNodes() {
    return nodes;
  }

  public List getChildProperties() {
    return properties;
  }

  public int getOrderNumber() {
    return orderNum;
  }

  public InternalQName getPrimaryTypeName() {
    return primaryTypeName;
  }

  public InternalQName[] getMixinTypeNames() {
    return mixinTypeNames;
  }

  public AccessControlList getChildrenACL() {
    return acl;
  }

  public boolean isNodesInitialized() {
    // always initialized
    return nodes == null;
  }

  public boolean isPropertiesInitialized() {
    // always initialized
    return properties == null;
  }

  ////// MutableNode 

  public void setOrderNumber(int orderNum) {
    this.orderNum = orderNum;
  }

  public void setMixinTypeNames(InternalQName[] mixinTypeNames) {
    this.mixinTypeNames = mixinTypeNames;
  }

  public NodeData addNode(NodeData node) {
    nodes.add(node);
    return node;
  }

  public PropertyData addProperty(PropertyData property) {
    properties.add(property);
    return property;
  }

  public void removeProperty(PropertyData property) {
    properties.remove(property);
  }

  public void removeNode(NodeData node) {
    nodes.remove(node);
  }

  public void setUUID(String uuid) {
    UUID = uuid;
  }

  public void setACL(AccessControlList acl) {
    this.acl = acl;
  }

  public boolean isNode() {
    return true;
  }

  // ------------- Comparable  /////

  public int compareTo(Object obj) {
    return ((NodeData) obj).getOrderNumber() - orderNum;
  }

}

