/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

package org.exoplatform.services.jcr.impl;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;

import javax.jcr.Node;
import javax.jcr.Property;
import javax.jcr.Session;

import org.exoplatform.services.jcr.BasePortalTest;
import org.exoplatform.services.jcr.impl.core.CredentialsImpl;


/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TestUpload.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class TestUpload extends BasePortalTest {

  protected String getRepositoryName() {
    return "db1";
  }

  public void testUpload() throws Exception {
    File file = new File("src/resource/jcr.gif");
    System.out.println(" "+file.exists());

    Node node = session.getRootNode().addNode("test-gif", "nt:resource");
    InputStream is = new FileInputStream(file);
    System.out.println(" "+is.available());

    Property data = node.setProperty("jcr:data", is);
    System.out.println(" "+data.getLength());
    session.save();

    Session session1 = repository.login(new CredentialsImpl("exo","exo".toCharArray()));
    data = (Property)session1.getItem("/test-gif/jcr:data");
    System.out.println(" "+data.getLength());
    File file1 = new File("target/temp/test1.gif");
    FileOutputStream fo = new FileOutputStream(file1);
    int size = (int) data.getLength();
    byte[] buffer = new byte[size];
    data.getStream().read(buffer);
    fo.write(buffer);
    fo.flush();
  }

}
