
/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.portlet.commons.servlet;

import javax.servlet.http.HttpServletResponseWrapper;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletOutputStream;
import org.apache.commons.logging.Log;
import org.exoplatform.services.portletcontainer.impl.portletAPIImp.RenderResponseImp;
import org.exoplatform.services.log.LogUtil;
import org.exoplatform.services.log.LogService;
import org.exoplatform.container.PortalContainer;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: BufferedServletResponse.java 808 2005-02-28 19:09:15Z kravchuk $
 */


public class BufferedServletResponse extends RenderResponseImp{// extends HttpServletResponseWrapper {
    private static Log log = LogUtil.getLog("org.exoplatform.portlet.commons");

    private RenderOutputStream outStream;

    /**
     *
     * @todo remove setting debug level
     *
     */
    public BufferedServletResponse(RenderResponseImp renderResponse) {
        super(renderResponse);
        log.debug("create BufferedServletResponse");
        outStream = new RenderOutputStream(new ByteArrayOutputStream());

        //remove this
        PortalContainer manager = PortalContainer.getInstance();
        LogService logService =
                (LogService) manager.getComponentInstanceOfType(LogService.class);
        try {
            logService.setLogLevel("org.exoplatform.portlet.commons",
                                   LogService.DEBUG, true);
        } catch (Exception ex) {

        }

    }

    public boolean isCommitted(){
        log.debug("BufferedServletResponse.isCommitted()");
        return false;
    }


    public int getBufferSize(){
        return super.getBufferSize();
    }

    public void flushBuffer() throws IOException  {
        log.debug("BufferedServletResponse.flushBuffer()");
        outStream.flushBuffer();
    }

    public void closeBuffer() throws IOException {
        outStream.closeBuffer();
    }

    public PrintWriter getWriter() throws IOException {
        log.debug("BufferedServletResponse.getWriter()");
        return new PrintWriter(outStream.baos);
//    return super.getWriter();
    }

    public ServletOutputStream getOutputStream() throws IOException {
        log.debug("BufferedServletResponse.getOutputStream()");
        return outStream;
    }

    public byte[] toByteArray() {
        return outStream.baos.toByteArray();
    }

    public void reset() {
        super.reset();
    }

    private class RenderOutputStream extends ServletOutputStream
    {
        public ByteArrayOutputStream baos;

        public RenderOutputStream(ByteArrayOutputStream baos) {
            this.baos = baos;
        }

        public void write(int i) throws IOException {
            log.trace("RenderOutputStream write "+i);
            baos.write(i);
        }

        public void flush()
        {}

        public void close()
        {}

        public void flushBuffer() throws IOException {
           super.flush();
        }

        public void closeBuffer() throws IOException {
           super.close();
        }


    }

}
