/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.file.explorer.component;

import java.util.List;
import java.util.Collection;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.file.explorer.component.model.NodeDescriptor;
import org.exoplatform.commons.utils.Formater;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentDisplayer.java,v 1.2 2004/08/07 18:11:26 tuan08 Exp $
 */
abstract public class UIChildrenInfo extends UIGrid implements ExplorerListener {
  private static Formater ft_ = Formater.getDefaultFormater() ;
  
  private ListDataHandler dataHandler_ ;
  
  public UIChildrenInfo() {
    setClazz("UIChildrenInfo") ;
    setRendererType("VelocityRenderer");
    dataHandler_ = new ListDataHandler() ;
    addActionListener(ChangeNodeActionListener.class, UIExplorer.CHANGE_NODE_ACTION) ;
  }
  
  public Collection getAllDataInstance() {
    return dataHandler_.getDatas();
  }
  
  public Parameter[] getChangeParams() {
    return UIExplorer.CHANGE_NODE;
  }
  
  public void  onChange(UIExplorer uiExplorer, NodeDescriptor node) throws Exception  {
    if(node.isLeafNode()) {
      setRendered(false) ;
      return ;
    }
    List children = getChildren(uiExplorer, node) ;
    dataHandler_.setDatas(children) ;
    node.setChildren(children) ;
    setRendered(true) ;
  }
  
  public void  onModify(UIExplorer uiExplorer, NodeDescriptor node)  {
    
  }
  
  public void  onAddChild(UIExplorer uiExplorer, NodeDescriptor node) throws Exception  {
    
  }
  
  abstract protected List getChildren(UIExplorer uiExplorer, NodeDescriptor node) throws Exception ;
  
  
  static public class ChangeNodeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIChildrenInfo uicomp = (UIChildrenInfo) event.getComponent() ;
      UIExplorer uiExplorer = 
        (UIExplorer) uicomp.getAncestorOfType(UIExplorer.class) ;
      String uri = event.getParameter(OBJECTID) ;
      if("../".equals(uri))  uri = uiExplorer.getSelectNode().getParentUri() ;
      uiExplorer.changeNode(uri);
    }
  }
}