/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.file.explorer.component;

import org.exoplatform.faces.core.component.UIHtmlTextArea;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.ComponentCell;
import org.exoplatform.faces.core.component.model.FormButton;
import org.exoplatform.faces.core.component.model.ListComponentCell;
import org.exoplatform.faces.core.component.model.Row;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.file.explorer.component.model.NodeDescriptor;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentEditor.java,v 1.1 2004/07/16 09:51:34 oranheim Exp $
 */
abstract public class UIContentEditor extends UISimpleForm implements ExplorerListener {
	final static public String PREVIEW_CONTENT_ACTION = "preview" ;
	final static public String EDIT_CURRENT_CONTENT_ACTION = "editCurrent" ;
	final static public String SAVE_CONTENT_ACTION = "saveContent" ;
	final static public String CANCEL_ACTION = "cancel" ;
	
	final static public String CONTENT_PREVIEW_RENDERER = "ContentPreviewRenderer" ;
	final static public String CONTENT_FORM_RENDERER = "SimpleFormVelocityRenderer" ;

  protected String contentType_ ;
  protected UIHtmlTextArea content_ ;

  public UIContentEditor() {
    super("contentForm", "post", null) ;
    setId("UIContentEditor") ;
    setClazz("UIContentEditor") ;    
    content_ = new UIHtmlTextArea("content", "", "100%", "400px") ;
    add(content_) ;
    addActionListener(PreviewContentActionListener.class, PREVIEW_CONTENT_ACTION)  ;
    addActionListener(EditCurrentActionListener.class, EDIT_CURRENT_CONTENT_ACTION)  ;
  }
  
  public String getPreViewAction() { return PREVIEW_CONTENT_ACTION ; }
  
  public String getContent() {  return content_.getValue() ; }
  
  public  void  setContent(String s) { content_.setValue(s) ; }
  
  public String getContentType() { return contentType_ ; }
  public void   setContentType(String s) {contentType_ = s; }

  public void  onModify(UIExplorer uiExplorer, NodeDescriptor node)  {}
  
  public void  onAddChild(UIExplorer uiExplorer, NodeDescriptor node)  { }
  
  public void  onRemove(UIExplorer uiExplorer, NodeDescriptor node)  {  }
  
  static public class PreviewContentActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIContentEditor uiEditor = (UIContentEditor) event.getComponent() ;
			uiEditor.setRendererType(CONTENT_PREVIEW_RENDERER) ;
		}
	}
  
  static public class EditCurrentActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIContentEditor uiEditor = (UIContentEditor) event.getComponent() ;
			uiEditor.setRendererType(CONTENT_FORM_RENDERER) ;
		}
	}
}