/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.file.explorer.component;

import java.io.File;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.InformationProvider;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.file.explorer.component.model.NodeDescriptor;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentDisplayer.java,v 1.2 2004/08/07 18:11:26 tuan08 Exp $
 */
public class UIFileNodeInfo extends UIGrid implements ExplorerListener {
  private static Parameter[]  DELETE_PARAMS = {new Parameter(ACTION, DELETE_ACTION)} ;
  private NodeDescriptor node_;
  public UIFileNodeInfo() {
    setRendererType("VelocityRenderer");
    addActionListener(RemoveNodeActionListener.class, DELETE_ACTION) ;
  }
  
  public NodeDescriptor getNodeDescriptor() {  return node_ ;  }
  
  public Parameter[] getDeleteParams() { return DELETE_PARAMS ; }
  
  public void  onChange(UIExplorer uiExplorer, NodeDescriptor node)  {
    node_ = uiExplorer.getSelectNode() ;
  }
  
  public void  onRemove(UIExplorer uiExplorer, NodeDescriptor node) throws Exception {}
  
  public void  onModify(UIExplorer uiExplorer, NodeDescriptor node) {}
  
  public void  onAddChild(UIExplorer uiExplorer, NodeDescriptor node) throws Exception {}
  
  static public class RemoveNodeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIFileNodeInfo uiInfo = (UIFileNodeInfo) event.getComponent() ;
      UIFileExplorer uiExplorer = 
        (UIFileExplorer) uiInfo.getAncestorOfType(UIFileExplorer.class) ;
      NodeDescriptor node = uiExplorer.getSelectNode() ;
      Information information = findInformationProvider(uiInfo) ;
      if("/".equals(node.getUri())) {
        information.addMessage(new ExoFacesMessage("#{UIFileNodeInfo.msg.remove-root-node}")) ;
        return ;
      }
      String realPath = uiExplorer.getRealPathBaseDir() + node.getUri() ;
      File file = new File(realPath) ;
      if(delete(file)) {
        uiExplorer.broadcastOnRemove(node);
        uiExplorer.changeNode(node.getParentUri()) ;
        information.addMessage(new ExoFacesMessage("#{UIFileNodeInfo.msg.remove-node-ok}")) ;
      } else {
        information.addMessage(new ExoFacesMessage("#{UIFileNodeInfo.msg.remove-node-fail}")) ;
      }
    }
    
    public static boolean delete(File file) {
      if (file.isDirectory()) {
        File[] children = file.listFiles();
        for (int i=0; i<children.length; i++) {
          if (delete(children[i]))  return false;
        }
      }
      return file.delete();
    }
  }
}