/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.wsrp.component;

import java.util.* ;
import javax.faces.context.FacesContext ;

import org.apache.commons.logging.Log;
import org.exoplatform.faces.FacesConstants;
import org.exoplatform.faces.core.component.*;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.services.wsrp.type.*;

/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIOfferedPortlet.java,v 1.9 2004/06/30 19:54:42 tuan08 Exp $
 */
public class UIOfferedPortlet extends UIGrid implements Node{
  protected static Log log_ = getLog("org.exoplatform.portlets.wsrp") ;
  private static Parameter[] backParams_ = 
      { new Parameter(FacesConstants.ACTION, "back") };
  
  private Collection portletDescription;
  private static String backButton_ 				= "#{UIOfferedPortlet.button.back}" ; 
  private static String portletHandle_ 				= "UIOfferedPortlet.label.portlet-handle" ;
  private static String groupId_ 					= "UIOfferedPortlet.label.group-id" ; 
  private static String title_ 						= "UIOfferedPortlet.label.title" ;
  private static String shortTitle_ 				= "UIOfferedPortlet.label.short-title" ;
  private static String displayName_ 				= "UIOfferedPortlet.label.display-name" ;
  private static String keywords_ 					= "UIOfferedPortlet.label.keywords" ;
  private static String markupType_ 				= "UIOfferedPortlet.label.markup-types" ;
  private static String userCategory_ 				= "UIOfferedPortlet.label.user-categories" ;
  private static String userProfileItem_ 			= "UIOfferedPortlet.label.user-profile-items" ;
  private static String usesMethodGet_ 				= "UIOfferedPortlet.label.uses-method-get" ; 
  private static String defaultMarkupSecure_ 		= "UIOfferedPortlet.label.default-markup-secure" ;
  private static String onlySecure_ 				= "UIOfferedPortlet.label.only-secure" ;
  private static String userContextStoredInSession_ = "UIOfferedPortlet.label.user-context-stored-in-session" ;
  private static String templatesStoredInSession_ 	= "UIOfferedPortlet.label.templates-stored-in-session" ;
  private static String hasUserSpecificState_ 		= "UIOfferedPortlet.label.user-specific-state" ;
  private static String doesUrlTemplateProcessing_ 	= "UIOfferedPortlet.label.url-template-processing" ; 
  private static String extensions_ 				= "UIOfferedPortlet.label.extensions" ;
  
  public UIOfferedPortlet(ResourceBundle res) {
    setId("offered-portlet-detail");
    setRendererType("VelocityRenderer") ;
    setClazz("UIOfferedPortlet") ;
    portletDescription = new ArrayList() ;     
  }
  public Collection getPortletDescription () { return portletDescription ; }
  public void populate(PortletDescription desc) {
    StringBuffer value = new StringBuffer() ;
    portletDescription = new ArrayList() ;    
    portletDescription.add(new PortletItemValue(portletHandle_ , desc.getPortletHandle().toString() )) ;
    portletDescription.add(new PortletItemValue(groupId_ , desc.getGroupID().toString() )) ;
    portletDescription.add(new PortletItemValue(title_ , desc.getTitle().getValue())) ;
    portletDescription.add(new PortletItemValue(shortTitle_ , desc.getShortTitle().getValue() )) ;
    portletDescription.add(new PortletItemValue(displayName_ , desc.getDisplayName().getValue() )) ;
    LocalizedString[] keywords = desc.getKeywords() ;
    if(keywords != null){
      for (int i = 0; i < keywords.length; i++) {
        value.append(getValue(keywords[i])).append(" ");
      }
    }
    portletDescription.add(new PortletItemValue(keywords_ , value.toString() )) ;
    
    MarkupType[] types = desc.getMarkupTypes() ;
    value.setLength(0) ;
    for (int i = 0; i < types.length; i++) {
      value.append(types[i].getMimeType()).append(" ");
    }
    portletDescription.add(new PortletItemValue(markupType_ , value.toString() )) ;
    
    String[] userCategories = desc.getUserCategories() ;
    String valueCategories  = "";
    if( userCategories != null) {
      value.setLength(0) ;
      for (int i = 0; i < userCategories.length; i++) {
        value.append(userCategories[i]).append(" ");
      }
      valueCategories = value.toString();      
    }
    portletDescription.add(new PortletItemValue(userCategory_ , valueCategories )) ;
    
    String[] userProfileItems = desc.getUserProfileItems() ;
    String valueProfileItem = "" ;
    if( userProfileItems != null) {
      value.setLength(0) ;
      for (int i = 0; i < userProfileItems.length; i++) {
        value.append(userProfileItems[i]).append(" ");
      }
      valueProfileItem = value.toString();
    } 
    portletDescription.add(new PortletItemValue(userProfileItem_ , valueProfileItem )) ;
    portletDescription.add(new PortletItemValue(usesMethodGet_ , desc.getUsesMethodGet().toString() )) ;
    
    if(desc.getDefaultMarkupSecure() != null)
    	portletDescription.add(new PortletItemValue(defaultMarkupSecure_ , desc.getDefaultMarkupSecure().toString() )) ;    	
    if(desc.getOnlySecure() != null)
    	portletDescription.add(new PortletItemValue(onlySecure_ , desc.getOnlySecure().toString() )) ;    	    	
    if(desc.getUserContextStoredInSession() != null)
    	portletDescription.add(new PortletItemValue(userContextStoredInSession_ , desc.getUserContextStoredInSession().toString() )) ;    	
	if(desc.getTemplatesStoredInSession() != null)
		portletDescription.add(new PortletItemValue(templatesStoredInSession_ , desc.getTemplatesStoredInSession().toString() )) ;		
    if(desc.getHasUserSpecificState() != null)
    	portletDescription.add(new PortletItemValue(hasUserSpecificState_ , desc.getHasUserSpecificState().toString() )) ;    	
    if(desc.getDoesUrlTemplateProcessing() != null)
    	portletDescription.add(new PortletItemValue(doesUrlTemplateProcessing_ , desc.getDoesUrlTemplateProcessing().toString() )) ;
    portletDescription.add(new PortletItemValue(extensions_ , "N/A" )) ;
  }
  
  public String getComponentType() { return COMPONENT_TYPE; }

  private String getValue(LocalizedString s) {
    if (s == null) return "" ;
    else return s.getValue() ;
  }

  public String getName() {
    return "";
  }

  public String getIcon() {
    return "no-icon";
  }

  public String getDescription() {
    return "no-description";
  }
  static public class PortletItemValue {
	  private String name_ ;
	  private String value_ ;
	  
	  public PortletItemValue(String name, String value) {
		  name_ = name ;
		  value_ = value ;
	  }
	  public String getName() { return name_ ; }
	  public void setName( String name ) { name_ = name ; }
	  public String getValue() { return value_ ; }
	  public void setValue( String value ) { value_ = value ; }
	  
  }
}
