/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.templates.groovy;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Mar 2, 2005
 * @version $Id$
 */
public class GroovyTemplateFileLoader extends GroovyTemplateLoader {
  private String[] basePath_ ;
  
  public GroovyTemplateFileLoader(String basePath) {
    String[] tmp = new String[] {basePath} ;
    init(tmp) ;
  }
  
  public GroovyTemplateFileLoader(String[] basePath) {
    init(basePath) ;
  }
  
  public void init(String[] basePath) {
    basePath_ = new String[basePath.length] ;
    for(int i = 0; i < basePath.length ; i++) {
      if(!basePath[i].endsWith("/")) basePath_[i] = basePath[i] + "/" ;
      else basePath_[i] = basePath[i] ;
    }
  }
  
  public boolean canLoad(String type, String template) throws Exception {
    for(int i = 0; i < basePath_.length ; i++) {
      String realPath =  basePath_[i] + template ;
      File file = new File(realPath) ;
      return file.exists() ;
    }
    return false ;
  }
  
  public InputStream load(String template) throws Exception {
    for(int i = 0; i < basePath_.length ; i++) {
      String realPath =  basePath_[i] + template ;
      File file = new File(realPath) ;
      if(file.exists()) {
        FileInputStream is = new FileInputStream(file) ;
        byte[]  buf =  new  byte[is.available()] ;
        is.read(buf) ;
        ByteArrayInputStream bis = new ByteArrayInputStream(buf) ;
        return bis;
      }
    } 
    return null ;
  }
}
