/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map ;

import java.io.IOException  ;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.apache.commons.fileupload.FileItem;
/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UICheckBox.java,v 1.4 2004/08/23 15:05:41 benjmestrallet Exp $
 */
public class UICheckBox extends UIInput {
  protected boolean isCheck_ ;

  public UICheckBox(String name, String text) {
    name_ = name ;
    value_ = text;
    isCheck_ = false ;
  }

  final public boolean getSelect() { return isCheck_ ; }
  final public UICheckBox setSelect(boolean b) { 
    isCheck_ = b ; 
    return this ;
  }

  public void decode(FacesContext context) {
    if (!editable_ || readonly_) return ;
    Map paramMap = context.getExternalContext().getRequestParameterMap() ;
    value_ = (String) paramMap.get(name_) ;
    if (value_ == null)  isCheck_ = false ;
    else  isCheck_ = true ;
  }
  
  public void decodeFromMultipartFields(FacesContext context,   UIComponent component, List items) {
    Iterator iter = items.iterator();
    while (iter.hasNext()) {
      FileItem item = (FileItem) iter.next();
      if (item.isFormField()) {
        String name = item.getFieldName();
        if (name.equals(getName())) {
          value_ = item.getString();
          if (value_ == null)  isCheck_ = false ;
          else  isCheck_ = true ;       
        }
      }
    }
  }    

  public void encodeBegin(FacesContext context) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    String value = value_ ;
    if (value == null) value = "" ;
    String check = "" ;
    if (isCheck_) check = " checked" ;
    w.write("<input type='checkbox' name='"); w.write(name_); w.write("'") ;
    w.write(" value='"); w.write(value); w.write("' ");
    w.write(check) ;
    if (!editable_ || readonly_) {
      w.write(" readonly='readonly'");
    }
    w.write(" class='checkbox'/>") ;
    if(hasSelectors()){
      Collection selectors = getSelectors();
      for (Iterator iter = selectors.iterator(); iter.hasNext();) {
        String button = (String) iter.next();
        w.write(button);
      }
    }    
  }
}

