/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.user.component;

import javax.faces.context.FacesContext;

import org.apache.commons.lang.StringUtils;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.services.portal.model.Permission;
/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISelectBox.java,v 1.6 2004/06/26 03:47:31 tuan08 Exp $
 */
public class UIExoPermissionSelector extends UIStringInput {
  protected String groupId_ = "";
  protected String membership_ = "*";

  public UIExoPermissionSelector(String name, String value) throws Exception {
    super(name, value) ;
    setPermissionExpression(value) ;
  } 

  public String getMembership() { return membership_ ; }
  public void setMembership(String s) { membership_ = s ; }
  
  public String getGroupId() { return groupId_ ; }
  public void setGroupId(String s) { groupId_ = s ; }
  
  public void reset() {
    groupId_ = "";
    String membership_ = "*";
    setValue(null) ;
  }
  
  public void decode(FacesContext context) {
    super.decode(context) ;
    setPermissionExpression(getValue()) ;
  }
  
  public void setPermissionExpression(String s) {
    if(s == null || s.length() == 0) {
      groupId_ = null ;
      membership_ = "*" ;
    } else {
      String[] tmp = s.split(":", 2) ;
      if(tmp.length != 2) {
        return ;
        //throw new RuntimeException("Expect the exo permission in the format membership:/groupId, input permission = " + s) ;
      }
      membership_ = tmp[0] ;
      groupId_ = tmp[1] ;
    }
    setValue(s) ;
  }
  
  public String getPermissionExpression() {
    if(groupId_ == null || groupId_.length() == 0) return null ;
    return membership_ + ":" + groupId_ ; 
  }
  
  public void setPermission(String membership, String  groupId) {
    groupId_ = groupId ;
    if(membership == null || membership.length() ==0) membership_ = "*" ;
    else membership_ = membership ;
    if(groupId == null || groupId.length() == 0)  setValue("") ;
    else setValue(membership_ + ":" + groupId_) ;
  }
  
  public void setPermission(String encodedPerm){
    String[] splittedPerms = StringUtils.split(encodedPerm, ":");
    setPermission(splittedPerms[0], splittedPerms[1]);
  }
   
  public void setPermission(Permission perm) {
    if(perm == null) {
      reset() ;
      setValue("") ;
    } else {
      setGroupId(perm.getGroup()) ;
      String membership = perm.getMembership() ;
      if(membership == null || "".equals(membership)) {
        membership = "*" ;
      }
      membership_ = membership ;
      setValue(getPermissionExpression()) ;
    }
  }
  
  public Permission getPermission() {
    if(groupId_ == null ||  groupId_.length() == 0) return null ;
    return new Permission(groupId_ , membership_) ; 
  }
}