/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.listener.portal;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.faces.component.PortalComponentCache;
import org.exoplatform.portal.faces.component.UINavigationManager;
import org.exoplatform.portal.faces.component.UIPageBrowser;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.services.portal.PortalConfigService;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 16, 2004
 * @version $Id: NodeActionListener.java,v 1.1 2004/09/26 02:25:47 tuan08 Exp $
 */
public class NodeActionListener extends ExoActionListener  {
  public void execute(ExoActionEvent event) throws Exception {
    UIPortal uiPortal  = (UIPortal)event.getSource() ;
    String portalAction = event.getAction() ;
    if (PortalConstants.SHOW_NAVIGATION_ACTION.equals(portalAction)) {
      UINavigationManager uiNav = 
        (UINavigationManager)PortalComponentCache.findPortalComponent(UINavigationManager.class) ;
      uiPortal.setBodyComponent(uiNav);  
    }  else if (PortalConstants.SAVE_NODE_ACTION.equals(portalAction)) {
      PortalConfigService service = 
        (PortalConfigService)PortalContainer.getInstance().
                             getComponentInstanceOfType(PortalConfigService.class) ;
      service.saveNodeNavigation(uiPortal.getOwner(), uiPortal.getRootNode()) ;
    } else if (PortalConstants.BROWSE_PAGE_ACTION.equals(portalAction)) {
      UIPageBrowser uiPageBrowser = 
        (UIPageBrowser)PortalComponentCache.findPortalComponent(UIPageBrowser.class);
      uiPageBrowser.setReturnModule(UIPageBrowser.UI_PAGE) ;
      if (uiPageBrowser != null) {
        uiPortal.setBodyComponent(uiPageBrowser);
      }
    } 
  }
}