package org.exoplatform.portlets.user.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;

/**
 * Sat, Jan 010, 2006 @ 11:16 
 * @author: Nguyen Quang Hung
 * @email:   nguyenkequanghung@yahoo.com
 * @version: $Id: UIPersonalInfoForm.java,v 1.14 2006/01/10 13:07:02 nqhung Exp $
 */
public class UIPersonalInfoForm extends UISimpleForm {
  final static public String[] PERSONAL_INFO_KEYS =  {
    "given", "family", "nickName", "bdate" , 
    "gender" , "employer" , "department",  "jobtitle" 
  } ;

 final static public String[] HOME_INFO_KEYS =  {
    "home_postal_name", "home_postal_street", 
    "home_postal_city", "home_postal_stateprov" ,
    "home_postal_postalcode", "home_postal_country",
    "home_mobile_number", "home_telephone_number", 
    "home_online_email", "home_online_uri" 
  } ;  
 
  public UIPersonalInfoForm() throws Exception {
    super("UIPersonalInfoForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer") ;
    setId("UIPersonalInfoForm") ;
    
    // persional info
    add(new UIStringInput("given", "")) ;
    add(new UIStringInput("family", "")) ;
    add(new UIStringInput("nickName", "")) ;
    add(new UIStringInput("bdate", "")) ;
    add(new UIStringInput("gender", "")) ;
    add(new UIStringInput("employer", "")) ;
    add(new UIStringInput("department", "")) ;
    add(new UIStringInput("jobtitle", "")) ;
    
    //persional home info   
    add(new UIStringInput("home_postal_name", "")) ;
    add(new UIStringInput("home_postal_street", "")) ;
    add(new UIStringInput("home_postal_city", "")) ;
    add(new UIStringInput("home_postal_stateprov", "")) ;
    add(new UIStringInput("home_postal_postalcode", "")) ;
    add(new UIStringInput("home_postal_country", "")) ;
    add(new UIStringInput("home_mobile_number", "")) ;
    add(new UIStringInput("home_telephone_number", "")) ;
    add(new UIStringInput("home_online_email", "")) ;
    add(new UIStringInput("home_online_uri", "")) ;
    
  }
  
  public void updatePersonalInfo(int index, String fieldValue) {
    getUIInput(PERSONAL_INFO_KEYS[index]).setValue(fieldValue) ;
  }
  public String getPersonalFieldInput(int index){
    return getUIInput(PERSONAL_INFO_KEYS[index]).getValue() ;
  }
  public void updateHomeInfo(int index, String fieldValue) {
    getUIInput(HOME_INFO_KEYS[index]).setValue(fieldValue) ;
  }
  public String getHomeFieldInput(int index){
    return getUIInput(HOME_INFO_KEYS[index]).getValue() ;
  }
}