package org.exoplatform.portlets.portal.component;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.portlet.PortletPreferences ; 

import org.exoplatform.container.PortalContainer ;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.container.client.http.HttpClientInfo;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.ComponentTemplate; 
import org.exoplatform.portal.session.ExoPortal;
import org.exoplatform.portal.session.RequestInfo;
import org.exoplatform.services.portal.model.Node;
import org.exoplatform.services.resources.LocaleConfigService;
/**
 * @version $Revision: 1.11 $ $Date: 2004/09/27 18:26:58 $
 * @author Fahrid Djebbari
 */
public class UIPortalInfo extends UIExoCommand implements ComponentTemplate {
 
  private String preferedMimetype_ ;
  private String template_ ;
  
	public UIPortalInfo() throws Exception {
		setId("UIPortalInfo");
    setRendererType("VelocityRenderer") ;
    HttpClientInfo info = (HttpClientInfo) SessionContainer.getInstance().getClientInfo() ;
    preferedMimetype_ = info.getPreferredMimeType() ;
    PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
    template_ = prefs.getValue("template" , "") ;
	}
  
  public Node getRootNode() { 
    ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
    return  portal.getRootNode();  
  }
  
  public Node getSelectedNode()  { 
    ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
    return  portal.getSelectedNode() ; 
  }
  
  public Object getPortalInfo() {
    return SessionContainer.getComponent(ExoPortal.class) ;
  }
  
  public Collection getLocalConfigs() {
    LocaleConfigService manager = 
      (LocaleConfigService) PortalContainer.getComponent(LocaleConfigService.class) ;
    return  manager.getLocalConfigs() ; 
  }
  
  public List getSelectedPath()  { 
    ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
    Node node = portal.getSelectedNode() ;
    List<Node> list = new ArrayList<Node>() ;
    while (node != null) {
      list.add(node) ;
      node = node.getParent() ;
    }
    List<Node> nodes = new ArrayList<Node>() ;
    for(int i = list.size() - 1 ; i >= 0 ; i--) {
      nodes.add(list.get(i)) ;
    }
    return  nodes ; 
  }
  
  public String getPreferedMimeType() { return preferedMimetype_ ; }
  
  public String getSelectNodeURI()  {
    RequestInfo rinfo = (RequestInfo)SessionContainer.getComponent(RequestInfo.class);
    return rinfo.getNodeURI() ;
  }
  
  public String getOwnerURI()  {
    RequestInfo rinfo = (RequestInfo)SessionContainer.getComponent(RequestInfo.class);
    return rinfo.getOwnerURI() ;
  }

  public String getTemplatePath() {  return template_ ;  }
}