/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.log.impl;

import java.util.Date;

import org.exoplatform.services.portal.log.PageLogData;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Sep 19, 2005
 * @hibernate.class  table="PAGE_LOG_DATA"
 */
public class PageLogDataImpl implements PageLogData {
  private String id ;
  private Date   timeSlot ;
  private int    timeIndex ;
  private String strTimeSlot ;
  private String strTimeIndex ;
  private String pageId ;
  private String pageOwner ;
  private long   accessCounter ;
  private long   accessErrorCounter ;
  private long   summaryAccessTime ;
  
  public PageLogDataImpl() {
    accessCounter = 0 ;
    accessErrorCounter = 0 ;
    summaryAccessTime = 0 ;
  }
  
  /**
   * @hibernate.id  generator-class="assigned" unsaved-value="null"
   ***/
  public String getId() { return id ; }
  public void   setId(String s) { id = s ; }
  
  /**
   * @hibernate.property
   ***/
  public Date getTimeSlot() { return timeSlot ; }
  public void setTimeSlot(Date d) { timeSlot =  d ; }
  
  /**
   * @hibernate.property
   ***/
  public int    getTimeIndex() { return timeIndex ; }
  public void   setTimeIndex(int i) { timeIndex =  i ; }
  
  /**
   * @hibernate.property
   ***/
  public String getStrTimeSlot() { return strTimeSlot ; }
  public void   setStrTimeSlot(String s) { strTimeSlot = s ; }
  
   /**
   * @hibernate.property
   ***/
  public String getStrTimeIndex() { return strTimeIndex ; }
  public void   setStrTimeIndex(String s) { strTimeIndex = s ; }
  
  /**
   * @hibernate.property
   ***/
  public String getPageId() { return pageId ; }
  public void   setPageId(String s) { pageId =  s ; }
  
  /**
   * @hibernate.property
   ***/
  public String getPageOwner() { return pageOwner ; }
  public void   setPageOwner(String s) { pageOwner =  s ; }
  
  /**
   * @hibernate.property
   ***/
  public long getAccessCounter()  {  return accessCounter ; }
  public void setAccessCounter(long c) { accessCounter = c ; }
  
  /**
   * @hibernate.property
   ***/
  public long getAccessErrorCounter()  {  return accessErrorCounter ; }
  public void setAccessErrorCounter(long c) { accessErrorCounter = c ; }
  
  /**
   * @hibernate.property
   ***/
  public long getSummaryAccessTime()  {  return summaryAccessTime ; }
  public void setSummaryAccessTime(long c) { summaryAccessTime = c ; }
  
  
  public long getAvgRenderTime() {  
    if(accessCounter == 0) return 0 ;
    return summaryAccessTime / accessCounter ; 
  }
  
  public String getShortDateTime(){     
    String dateTime =  String.valueOf(timeSlot.getDate())+ "-" + 
                       String.valueOf(timeSlot.getMonth() + 1) + "-" + 
                       String.valueOf(timeSlot.getYear()+1900) + " / " + 
                       String.valueOf(timeIndex) ;
    return dateTime ;
  }
  
  synchronized public void logPageAccess(String uniqueId, String pId, String owner, 
                                         Date timeSl, int index, long exeTime, boolean error) {
    id           = uniqueId ;
    pageId       = pId ;
    pageOwner    = owner ;
    timeSlot     = timeSl ;
    timeIndex    = index ;
    strTimeSlot  = timeSl.toString() ;
    strTimeIndex = String.valueOf(index) ;
    accessCounter ++ ;
    if(error) 
      accessErrorCounter ++ ;
    summaryAccessTime += exeTime ;
  }
  
  synchronized public void updateLogAccess(long exeTime, boolean error) {
    accessCounter ++ ;
    if(error) 
      accessErrorCounter ++ ;
    summaryAccessTime += exeTime ;
  }
  
  synchronized public void merge(PageLogDataImpl other) {
    accessCounter += other.getAccessCounter() ;
    accessErrorCounter += other.getAccessErrorCounter() ;
    summaryAccessTime += other.getSummaryAccessTime() ;    
  }
}