/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.log.impl;

import java.util.List;

import org.exoplatform.commons.utils.PageList;
import org.exoplatform.services.portal.log.PageLogData;
import org.exoplatform.services.portal.log.PortalActivitiesLogService;
import org.exoplatform.services.portal.log.PortalLogData;
import org.exoplatform.services.portal.log.PortletLogData;
import org.exoplatform.services.portal.log.Query;
import org.exoplatform.services.scheduler.JobSchedulerService;

/**
 * @author Hung Nguyen (nqhungvn@users.sourceforge.net)
 * @since Sep 26, 2005
 * @version $Id$
 */

public class PortalActivitiesLogServiceImpl implements PortalActivitiesLogService {
  private PortletActivitiesLogPlugin portletPlugin_ ;
  private PageActivitiesLogPlugin    pagePlugin_ ;
  private PortalActivitiesLogPlugin  portalPlugin_ ;
  
  public PortalActivitiesLogServiceImpl(JobSchedulerService jsService) throws Exception {
          
  }  
  public void setPortletLogActivitiesPlugin(PortletActivitiesLogPlugin plugin) {
    portletPlugin_ = plugin ;
  }
  public void setPageLogActivitiesPlugin(PageActivitiesLogPlugin plugin) {
    pagePlugin_ = plugin ;
  }
  public void setPortalLogActivitiesPlugin(PortalActivitiesLogPlugin plugin) {
    portalPlugin_ = plugin ;
  }
  final public void logPortletRender(String portletId, String portletAppId, 
      long exeTime, boolean error, String eventType) {
    portletPlugin_.logPortletRender(portletId, portletAppId, exeTime, error, eventType) ;
  }

  public void logPortletAction(String portletId, String portletAppId, long exeTime, boolean error, 
                               String eventType) {
	  portletPlugin_.logPortletAction(portletId, portletAppId, exeTime, error, eventType) ;
  }

  public void logPageAccess(String pageId, String pageOwner, long exeTime, boolean error) {
    pagePlugin_.logPageAccess(pageId, pageOwner, exeTime, error) ;
  }

  public void logPortalAccess(String portalId, String portalOwner, long exeTime, boolean error, boolean illegalAccess) {
    portalPlugin_.logPortalAccess(portalId, portalOwner, exeTime, error) ;
  }

  public PageList getPortletLogDatas(Query queryData) throws Exception {
    return portletPlugin_.getPortletLogDatas(queryData);
  }
  
  final public void savePortletLogData(PortletLogData data) throws Exception {
    portletPlugin_.savePortletLogData(data) ;
  }
  
  public List getPortletLogChartDatas(Query queryData) throws Exception {
    return portletPlugin_.getPortletLogChartDatas(queryData) ;
  }
  
  public PageList getPageLogDatas( Query queryData) throws Exception {
    return pagePlugin_.getPageLogDatas(queryData);
  }
  
  public List getPageLogChartDatas(Query queryData) throws Exception {
    return pagePlugin_.getPageLogChartDatas(queryData) ;
  }
  
  public void savePageLogData(PageLogData data) throws Exception {
    pagePlugin_.savePageLogData(data) ;
  }

  public PageList getPortalLogDatas(Query queryData) throws Exception {
    return portalPlugin_.getPortalLogDatas(queryData);
  }
  
  public List getPortalLogChartDatas(Query queryData) throws Exception {
    return portalPlugin_.getPortalLogChartDatas(queryData) ;
  }
  
  public void savePortalLogData(PortalLogData data) throws Exception {
    portalPlugin_.savePortalLogData(data) ;    
  }
  
  public void  saveMonitorData() throws Exception {
    portalPlugin_.saveMonitorData() ; 
    pagePlugin_.saveMonitorData();
    portletPlugin_.saveMonitorData() ;
  }
  
  public void updateTimeSlot() throws Exception {    
    portalPlugin_.updateTime() ;
    pagePlugin_.updateTime() ;
    portletPlugin_.updateTime() ;
    portalPlugin_.savePrevTimeSlotMonitorData() ;
    pagePlugin_.savePrevTimeSlotMonitorData() ;
    portletPlugin_.savePrevTimeSlotMonitorData() ;
    
  }
}
