package control;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.servlet.* ;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class  GroovyConfiguration extends  Configuration {
  private ExoWebClient client_ ;
  
  public void configure(ControllerServlet servlet)  {
    client_ = new ExoWebClient("exo", "http://localhost:8080/ecm");
    client_.setStoreResult(true) ;
    addDefaultActionHandler(new ShowTemplate()) ;
    addActionHandler("configTest", new ConfigTest()) ;
    addActionHandler("runTest", new RunTest()) ;        
    addActionHandler("selectTest", new SelectTest()) ;
  }
  
  public  ExoWebClient getWebClient()  { return client_ ; }
  
  public TestSuites getTestSuites(ResourceManager resManager, String name) {
    Object o = resManager.getGroovyObject(name, true) ;
    if(o instanceof TestSuites) return (TestSuites) o ;
    WebUnitSuite suite = (WebUnitSuite) o ;
    List requiredSuites = suite.getRequiredSuites() ;
    TestSuites suites = new TestSuites() ;
    if(requiredSuites != null) {
      for(rsuite in requiredSuites) {
        suites.addSuite(rsuite) ;
      }
    }
    suites.addSuite(suite) ;
    return suites ;
  }
}