/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 *  Add a new /test-folder directory
 *     1) Go to Production workspace
 *     2) Delete test-folder if does exist
 *     3) Add /test-folder directory
 *     4) Return to workspaces selection page
 *
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserAddFolderSuite extends WebUnitSuite {
  static String DESC = "Go to ECM File Explorer page and add a new folder" ;
  static String NAME = "UserAddFolderSuite" ;
  
  public UserAddFolderSuite() {    
    super(NAME, DESC) ;    
    goToPage("/Site Map/cms") ;
    //Go to Production workspace
    /*
    addWebUnit(
      new ClickURLLinkUnit("SelectECMFileExplorer", "Select ECM File Explorer tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=jcr").                  
      addValidator(new ExpectTextValidator("Workspaces"))      
    ) ;
    */        
    addWebUnit(
      new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
      setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectWorkspace"))      
    ) ;    
    //-----Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIDefaultAction").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ; 
    //-----Delete test-folder if does exist
    addWebUnit(
      new ClickURLLinkUnit("DeleteExistedFolder", "Delete if test-folder is existed").
      setURL("&uicomponent=UIDocumentInfo&op=removeNode&objectId=test-folder").
      addCondition(new HaveLinkWithURLCondition("&uicomponent=UIDocumentInfo&op=removeNode&objectId=test-folder")).
      addValidator(new ExpectTextValidator("The node /test-folder has been removed."))
    ) ;  
    //-----Add /test-folder directory
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddFolder", "click on Add Folder button").
      setURL("&uicomponent=UIToolbar&op=addFolder").                  
      addValidator(new ExpectFormIdValidator("folderForm"))      
    ) ;       
    //----------Save new folder
    addWebUnit(
      new SubmitFormUnit("SaveNewFolder", "click on Save button").
      setFormId("folderForm").   
      setField("name","test-folder").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/test-folder"))      
    ) ;      
    //-----Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    //-----Return to workspaces selection page
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() {    
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}