/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserImportNodeSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet Admin page, select Admin tab, click on UserExportNodeSuite button and test all the basic actions" ;
  static String NAME = "UserExportNodeSuite" ;
  String COMMENT = null;
  
  public UserImportNodeSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());
    addWebSuite(new GotoFolderSuite());
    //-----Select Admin tab
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIAdminAction").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
    ) ;     
    //-----Import Node
    addWebUnit(
      new ClickURLLinkUnit("ClickOnImportNode", "click on Import Node button").
      setURL("&uicomponent=UIToolbar&op=importNode").                  
      addValidator(new ExpectFormIdValidator("importForm"))      
    ) ;           
    addWebUnit(
      new SubmitFormUnit("ClickOnCancel", "click on cancel button").
      setFormId("importForm").
      setField("op","PhaseId[1].cancel").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=UIDefaultAction"))
    ) ;
    //Back to home
    addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "back to home").
      setURL("&uicomponent=UIJCRExplorer&op=changeNode&objectId=/").      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/test-folder"))            
    ) ;   
    //Saved Session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}