/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserViewNodePropertiesSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet Admin page and test all the basic actions" ;
  static String NAME = "EcmPortletAdminSuite" ;
  
  public UserViewNodePropertiesSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());
    addWebSuite(new GotoFolderSuite());   
    //-----Select Info tab
    addWebUnit(
      new ClickURLLinkUnit("SelectInfoTab", "click on info tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIInfoAction").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewReferences")).         
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewNodeType")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewPermissions")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewProperties"))
    ) ;
    //-----View Node Properties
    addWebUnit(
      new ClickURLLinkUnit("ViewNodeProperties", "click on View Node Properties button").
      setURL("&uicomponent=UIToolbar&op=viewProperties").        
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPropertiesInfo&op=addProperty"))       
    ) ;  
    addWebUnit(
      new ClickURLLinkUnit("AddProperty", "click on Add Property button").
      setURL("&uicomponent=UIPropertiesInfo&op=addProperty").        
      addValidator(new ExpectFormIdValidator("propertyForm"))      
    ) ;
    //---------------Save Property
    addWebUnit(
      new SubmitFormUnit("SaveProperty", "click on save button").
      setFormId("propertyForm").
      setField("name","property-test").                        
      setField("value","value-test").
      setField("op","save").
      addValidator(new ExpectTextValidator("UIPropertyForm.msg.unsetable"))
    ) ;
    //Saved Session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;    
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;        
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}