/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.portal;

import suites.share.*;

import org.exoplatform.test.*;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class CustomizationPortalSuite extends WebUnitSuite {
  public CustomizationPortalSuite() {
    super("CustomizationPortalSuite", "Click edit-portal-mode and do some action") ;
    addWebUnit(CommonUnit.CLICK_EDIT_PORTAL_MODE) ;
    //---------------- Add NewContatner on a container-------
    addWebUnit(
        new ClickURLLinkUnit("ClickAddContainer", "Tell web client click addContainer on a container").
        setURL("portal:action=addContainer").
        addValidator(new ExpectFormIdValidator("containerForm"))        
    ) ;
    addWebSuite(new CreateEditContainerSuite("containerForm","NewContainer","NewContainer",
                                                "ContainerColumnRenderer","default")) ;
    //-------------Edit this conntainer--------------    
    addWebUnit(
        new ClickURLLinkUnit("EditParentContainer", "Tell web client click 'EditContainerProperties' on ParentContainer").
        setURL("componentId=NewContainer&portal:action=editProperty")
    ) ;
    addWebSuite(new CreateEditContainerSuite("containerForm","ParentContainer",
                                               "Parent Container","default","default")) ;
  }
  public java.util.List getRequiredSuites() {     
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;  
  } 
}