/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.maven2.plugin.exo.test;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.exoplatform.maven2.plugin.Utils;
import org.exoplatform.maven2.plugin.exo.DeployConfiguration;
import org.exoplatform.maven2.plugin.exo.ExoWarPackaging;
import org.exoplatform.maven2.plugin.exo.PackagingConfiguration;

/**
 * Created by The eXo Platform SARL Author : Phung Hai Nam phunghainam@gmail.com
 * Jan 3, 2006
 */
public class TestExoWarPackaging extends TestCase {
  public TestExoWarPackaging(String testname) {
    super(testname);
  }

  public void testTest() throws Exception {
    DeployConfiguration dconfig = new DeployConfiguration();
    PackagingConfiguration pconfig = new MockPackagingConfiguration();
    ExoWarPackaging ewp = new ExoWarPackaging();
    
    String basedir = System.getProperty("basedir");
    //  Create a source directory
    File srcDir = new File(basedir + "/target/outputDirecttory");
    if (!srcDir.exists())
      srcDir.mkdirs();
    for (int i = 0; i < 10; i++) {
      File srcF = new File(srcDir + "/sourceFile-" + i + ".txt");
      srcF.createNewFile();
      StringBuilder sb = new StringBuilder();
      sb.append("This is file " + i);
      FileOutputStream out = new FileOutputStream(srcF);
      out.write(sb.toString().getBytes());
      out.close();
    }
    
    List<String> scripts = new ArrayList<String>();
//    String copyDir =
//      "import java.io.File ;" +
//      "File srcDir = new File(\""+srcDir.getPath()+"\") ;"+
//      "FileUtils.copyDirectoryStructure(srcDir," +
//        "new File(deployConfig.getDeployLibDir()), FileUtils.getDefaultIgnoreFiles(), true)";
//    scripts.add(copyDir);
    ewp.setCommands(scripts);
    

    // Set value for dconfig
    dconfig.setDeployLibDir(basedir + "/target/deployLibDir");
    dconfig.setDeployWebappDir(basedir + "/target/deployWebappDir");
    ewp.setDeployConfiguration(dconfig) ;
    
    // Set value for pconfig
    pconfig.setOutputDirectory(basedir+"/target/outputDirecttory");
    pconfig.setOutputFileName("outputFileName");
    ewp.setPackagingConfiguration(pconfig) ;
    
    //Test execute() method of ExoWarPackaging
    ewp.execute();
  }
}
